
(* This generated code requires the following version of MenhirLib: *)

let () =
  MenhirLib.StaticVersion.require_20231231

module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | WHILE
    | WHEN
    | UU_WRITE
    | UU_UNPREDICTABLE_UNLESS
    | UU_UNPREDICTABLE
    | UU_UNALLOCATED
    | UU_REGISTER
    | UU_READWRITE
    | UU_POSTDECODE
    | UU_OPERATOR_TWO
    | UU_OPERATOR_ONE
    | UU_OPCODE
    | UU_NOP
    | UU_NEWMAP
    | UU_NEWEVENT
    | UU_MAP
    | UU_INSTRUCTION_SET
    | UU_INSTRUCTION
    | UU_GUARD
    | UU_FUNCTION
    | UU_FIELD
    | UU_EXECUTE
    | UU_EXCEPTIONTAKEN
    | UU_EVENT
    | UU_ENCODING
    | UU_DECODE
    | UU_CONFIG
    | UU_CONDITIONAL
    | UU_BUILTIN
    | UU_ARRAY
    | UNTIL
    | UNPREDICTABLE
    | UNKNOWN
    | UNDEFINED
    | TYPEOF
    | TYPE
    | TRY
    | TO
    | THROW
    | THEN
    | STRING_LIT of (
# 74 "asllib/Parser0.mly"
       (string)
# 60 "asllib/Parser0.ml"
  )
    | STAR
    | SLASH
    | SEMICOLON
    | SEE
    | RPAREN
    | RETURN
    | REPEAT
    | REM
    | RECORD
    | REAL_LIT of (
# 78 "asllib/Parser0.mly"
       (Q.t)
# 74 "asllib/Parser0.ml"
  )
    | REAL
    | RBRACK
    | RBRACE_RBRACE
    | RBRACE
    | QUOT
    | QUALIFIER of (
# 80 "asllib/Parser0.mly"
       (string)
# 84 "asllib/Parser0.ml"
  )
    | PLUS_PLUS
    | PLUS_COLON
    | PLUS
    | OTHERWISE
    | OR
    | OF
    | NOT
    | MOD
    | MINUS
    | MASK_LIT of (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 98 "asllib/Parser0.ml"
  )
    | LT_LT
    | LT_EQ
    | LT
    | LPAREN
    | LIMIT
    | LET
    | LBRACK
    | LBRACE_LBRACE
    | LBRACE
    | IS
    | INT_LIT of (
# 77 "asllib/Parser0.mly"
       (Z.t)
# 113 "asllib/Parser0.ml"
  )
    | INTEGER
    | INDENT
    | IN
    | IMPLIES
    | IMPLEM_DEFINED
    | IFF
    | IF
    | IDENTIFIER of (
# 74 "asllib/Parser0.mly"
       (string)
# 125 "asllib/Parser0.ml"
  )
    | GT_GT
    | GT_EQ
    | GT
    | FOR
    | EQ_GT
    | EQ_EQ
    | EQ
    | EOR
    | EOL
    | EOF
    | ENUMERATION
    | ELSIF
    | ELSE
    | DOWNTO
    | DOT_DOT
    | DOT
    | DO
    | DIV
    | DEDENT
    | DEBUG
    | CONSTRAINED_UNPRED
    | CONSTANT
    | CONFIG
    | COMMA
    | COLON
    | CATCH
    | CASE
    | CARET
    | BOOL_LIT of (
# 79 "asllib/Parser0.mly"
       (bool)
# 158 "asllib/Parser0.ml"
  )
    | BOOLEAN
    | BITS_LIT of (
# 76 "asllib/Parser0.mly"
       (Bitvector.t)
# 164 "asllib/Parser0.ml"
  )
    | BITS
    | BIT
    | BAR_BAR
    | BANG_EQ
    | BANG
    | ASSERT
    | ARRAY
    | AND
    | AMP_AMP
    | AMP
  
end

include MenhirBasics

# 23 "asllib/Parser0.mly"
  

  module Prelude = struct
    open AST
    open ASTUtils

    let version = V0

    let build_expr_conds =
      let make_cond { desc = c, e_then; _ } e_else =
        E_Cond (c, e_then, e_else)
      in
      fun (elseifs, e) -> List.fold_right (map2_desc make_cond) elseifs e

    let build_stmt_conds (s_elsifs, s_else) =
      let s_else = match s_else with Some s -> s | None -> s_pass in
      let folder { desc = c, s_then; _ } s_else = S_Cond (c, s_then, s_else) in
      List.fold_right (map2_desc folder) s_elsifs s_else

    let t_bit =
      T_Bits (E_Literal (L_Int Z.one) |> add_dummy_annotation ~version, [])


    let make_ldi_vars (ty, xs) =
      let make_one x =
        S_Decl (LDK_Var, LDI_Typed (LDI_Var x, ty), None)
        |> add_dummy_annotation ~version
      in
      List.map make_one xs |> stmt_from_list |> desc

    let make_func name args return_type body =
      let subprogram_type =
        match return_type with | Some _ -> ST_Function | None -> ST_Procedure
      and parameters = []
      and recurse_limit = None 
      in
      D_Func {
        name;
        args;
        return_type;
        body;
        parameters;
        subprogram_type;
        recurse_limit
      }
  end

  open Prelude


# 232 "asllib/Parser0.ml"

module Tables = struct
  
  include MenhirBasics
  
  let token2terminal : token -> int =
    fun _tok ->
      match _tok with
      | AMP ->
          127
      | AMP_AMP ->
          126
      | AND ->
          125
      | ARRAY ->
          124
      | ASSERT ->
          123
      | BANG ->
          122
      | BANG_EQ ->
          121
      | BAR_BAR ->
          120
      | BIT ->
          119
      | BITS ->
          118
      | BITS_LIT _ ->
          117
      | BOOLEAN ->
          116
      | BOOL_LIT _ ->
          115
      | CARET ->
          114
      | CASE ->
          113
      | CATCH ->
          112
      | COLON ->
          111
      | COMMA ->
          110
      | CONFIG ->
          109
      | CONSTANT ->
          108
      | CONSTRAINED_UNPRED ->
          107
      | DEBUG ->
          106
      | DEDENT ->
          105
      | DIV ->
          104
      | DO ->
          103
      | DOT ->
          102
      | DOT_DOT ->
          101
      | DOWNTO ->
          100
      | ELSE ->
          99
      | ELSIF ->
          98
      | ENUMERATION ->
          97
      | EOF ->
          96
      | EOL ->
          95
      | EOR ->
          94
      | EQ ->
          93
      | EQ_EQ ->
          92
      | EQ_GT ->
          91
      | FOR ->
          90
      | GT ->
          89
      | GT_EQ ->
          88
      | GT_GT ->
          87
      | IDENTIFIER _ ->
          86
      | IF ->
          85
      | IFF ->
          84
      | IMPLEM_DEFINED ->
          83
      | IMPLIES ->
          82
      | IN ->
          81
      | INDENT ->
          80
      | INTEGER ->
          79
      | INT_LIT _ ->
          78
      | IS ->
          77
      | LBRACE ->
          76
      | LBRACE_LBRACE ->
          75
      | LBRACK ->
          74
      | LET ->
          73
      | LIMIT ->
          72
      | LPAREN ->
          71
      | LT ->
          70
      | LT_EQ ->
          69
      | LT_LT ->
          68
      | MASK_LIT _ ->
          67
      | MINUS ->
          66
      | MOD ->
          65
      | NOT ->
          64
      | OF ->
          63
      | OR ->
          62
      | OTHERWISE ->
          61
      | PLUS ->
          60
      | PLUS_COLON ->
          59
      | PLUS_PLUS ->
          58
      | QUALIFIER _ ->
          57
      | QUOT ->
          56
      | RBRACE ->
          55
      | RBRACE_RBRACE ->
          54
      | RBRACK ->
          53
      | REAL ->
          52
      | REAL_LIT _ ->
          51
      | RECORD ->
          50
      | REM ->
          49
      | REPEAT ->
          48
      | RETURN ->
          47
      | RPAREN ->
          46
      | SEE ->
          45
      | SEMICOLON ->
          44
      | SLASH ->
          43
      | STAR ->
          42
      | STRING_LIT _ ->
          41
      | THEN ->
          40
      | THROW ->
          39
      | TO ->
          38
      | TRY ->
          37
      | TYPE ->
          36
      | TYPEOF ->
          35
      | UNDEFINED ->
          34
      | UNKNOWN ->
          33
      | UNPREDICTABLE ->
          32
      | UNTIL ->
          31
      | UU_ARRAY ->
          30
      | UU_BUILTIN ->
          29
      | UU_CONDITIONAL ->
          28
      | UU_CONFIG ->
          27
      | UU_DECODE ->
          26
      | UU_ENCODING ->
          25
      | UU_EVENT ->
          24
      | UU_EXCEPTIONTAKEN ->
          23
      | UU_EXECUTE ->
          22
      | UU_FIELD ->
          21
      | UU_FUNCTION ->
          20
      | UU_GUARD ->
          19
      | UU_INSTRUCTION ->
          18
      | UU_INSTRUCTION_SET ->
          17
      | UU_MAP ->
          16
      | UU_NEWEVENT ->
          15
      | UU_NEWMAP ->
          14
      | UU_NOP ->
          13
      | UU_OPCODE ->
          12
      | UU_OPERATOR_ONE ->
          11
      | UU_OPERATOR_TWO ->
          10
      | UU_POSTDECODE ->
          9
      | UU_READWRITE ->
          8
      | UU_REGISTER ->
          7
      | UU_UNALLOCATED ->
          6
      | UU_UNPREDICTABLE ->
          5
      | UU_UNPREDICTABLE_UNLESS ->
          4
      | UU_WRITE ->
          3
      | WHEN ->
          2
      | WHILE ->
          1
  
  and error_terminal =
    0
  
  and token2value : token -> Obj.t =
    fun _tok ->
      match _tok with
      | AMP ->
          Obj.repr ()
      | AMP_AMP ->
          Obj.repr ()
      | AND ->
          Obj.repr ()
      | ARRAY ->
          Obj.repr ()
      | ASSERT ->
          Obj.repr ()
      | BANG ->
          Obj.repr ()
      | BANG_EQ ->
          Obj.repr ()
      | BAR_BAR ->
          Obj.repr ()
      | BIT ->
          Obj.repr ()
      | BITS ->
          Obj.repr ()
      | BITS_LIT _v ->
          Obj.repr _v
      | BOOLEAN ->
          Obj.repr ()
      | BOOL_LIT _v ->
          Obj.repr _v
      | CARET ->
          Obj.repr ()
      | CASE ->
          Obj.repr ()
      | CATCH ->
          Obj.repr ()
      | COLON ->
          Obj.repr ()
      | COMMA ->
          Obj.repr ()
      | CONFIG ->
          Obj.repr ()
      | CONSTANT ->
          Obj.repr ()
      | CONSTRAINED_UNPRED ->
          Obj.repr ()
      | DEBUG ->
          Obj.repr ()
      | DEDENT ->
          Obj.repr ()
      | DIV ->
          Obj.repr ()
      | DO ->
          Obj.repr ()
      | DOT ->
          Obj.repr ()
      | DOT_DOT ->
          Obj.repr ()
      | DOWNTO ->
          Obj.repr ()
      | ELSE ->
          Obj.repr ()
      | ELSIF ->
          Obj.repr ()
      | ENUMERATION ->
          Obj.repr ()
      | EOF ->
          Obj.repr ()
      | EOL ->
          Obj.repr ()
      | EOR ->
          Obj.repr ()
      | EQ ->
          Obj.repr ()
      | EQ_EQ ->
          Obj.repr ()
      | EQ_GT ->
          Obj.repr ()
      | FOR ->
          Obj.repr ()
      | GT ->
          Obj.repr ()
      | GT_EQ ->
          Obj.repr ()
      | GT_GT ->
          Obj.repr ()
      | IDENTIFIER _v ->
          Obj.repr _v
      | IF ->
          Obj.repr ()
      | IFF ->
          Obj.repr ()
      | IMPLEM_DEFINED ->
          Obj.repr ()
      | IMPLIES ->
          Obj.repr ()
      | IN ->
          Obj.repr ()
      | INDENT ->
          Obj.repr ()
      | INTEGER ->
          Obj.repr ()
      | INT_LIT _v ->
          Obj.repr _v
      | IS ->
          Obj.repr ()
      | LBRACE ->
          Obj.repr ()
      | LBRACE_LBRACE ->
          Obj.repr ()
      | LBRACK ->
          Obj.repr ()
      | LET ->
          Obj.repr ()
      | LIMIT ->
          Obj.repr ()
      | LPAREN ->
          Obj.repr ()
      | LT ->
          Obj.repr ()
      | LT_EQ ->
          Obj.repr ()
      | LT_LT ->
          Obj.repr ()
      | MASK_LIT _v ->
          Obj.repr _v
      | MINUS ->
          Obj.repr ()
      | MOD ->
          Obj.repr ()
      | NOT ->
          Obj.repr ()
      | OF ->
          Obj.repr ()
      | OR ->
          Obj.repr ()
      | OTHERWISE ->
          Obj.repr ()
      | PLUS ->
          Obj.repr ()
      | PLUS_COLON ->
          Obj.repr ()
      | PLUS_PLUS ->
          Obj.repr ()
      | QUALIFIER _v ->
          Obj.repr _v
      | QUOT ->
          Obj.repr ()
      | RBRACE ->
          Obj.repr ()
      | RBRACE_RBRACE ->
          Obj.repr ()
      | RBRACK ->
          Obj.repr ()
      | REAL ->
          Obj.repr ()
      | REAL_LIT _v ->
          Obj.repr _v
      | RECORD ->
          Obj.repr ()
      | REM ->
          Obj.repr ()
      | REPEAT ->
          Obj.repr ()
      | RETURN ->
          Obj.repr ()
      | RPAREN ->
          Obj.repr ()
      | SEE ->
          Obj.repr ()
      | SEMICOLON ->
          Obj.repr ()
      | SLASH ->
          Obj.repr ()
      | STAR ->
          Obj.repr ()
      | STRING_LIT _v ->
          Obj.repr _v
      | THEN ->
          Obj.repr ()
      | THROW ->
          Obj.repr ()
      | TO ->
          Obj.repr ()
      | TRY ->
          Obj.repr ()
      | TYPE ->
          Obj.repr ()
      | TYPEOF ->
          Obj.repr ()
      | UNDEFINED ->
          Obj.repr ()
      | UNKNOWN ->
          Obj.repr ()
      | UNPREDICTABLE ->
          Obj.repr ()
      | UNTIL ->
          Obj.repr ()
      | UU_ARRAY ->
          Obj.repr ()
      | UU_BUILTIN ->
          Obj.repr ()
      | UU_CONDITIONAL ->
          Obj.repr ()
      | UU_CONFIG ->
          Obj.repr ()
      | UU_DECODE ->
          Obj.repr ()
      | UU_ENCODING ->
          Obj.repr ()
      | UU_EVENT ->
          Obj.repr ()
      | UU_EXCEPTIONTAKEN ->
          Obj.repr ()
      | UU_EXECUTE ->
          Obj.repr ()
      | UU_FIELD ->
          Obj.repr ()
      | UU_FUNCTION ->
          Obj.repr ()
      | UU_GUARD ->
          Obj.repr ()
      | UU_INSTRUCTION ->
          Obj.repr ()
      | UU_INSTRUCTION_SET ->
          Obj.repr ()
      | UU_MAP ->
          Obj.repr ()
      | UU_NEWEVENT ->
          Obj.repr ()
      | UU_NEWMAP ->
          Obj.repr ()
      | UU_NOP ->
          Obj.repr ()
      | UU_OPCODE ->
          Obj.repr ()
      | UU_OPERATOR_ONE ->
          Obj.repr ()
      | UU_OPERATOR_TWO ->
          Obj.repr ()
      | UU_POSTDECODE ->
          Obj.repr ()
      | UU_READWRITE ->
          Obj.repr ()
      | UU_REGISTER ->
          Obj.repr ()
      | UU_UNALLOCATED ->
          Obj.repr ()
      | UU_UNPREDICTABLE ->
          Obj.repr ()
      | UU_UNPREDICTABLE_UNLESS ->
          Obj.repr ()
      | UU_WRITE ->
          Obj.repr ()
      | WHEN ->
          Obj.repr ()
      | WHILE ->
          Obj.repr ()
  
  and default_reduction =
    (16, "\000\000\000\000\000n\000\000\000\000\000\000\000\000\000\000\000\t\000\000\000\000\000\017\000\007\000\000\0008\000\000\000F\000\000\000\000\000\000\000;\000\000\000\r\000\000\000\000\000\000\000\000\0002\000\006\000\000\0007\000\000\000D\000\000\000\000\000:\000\000\000\015\000\005\000\000\0009\000\000\000H\000\b\000\000\000\000\000\000\000<\000\000\000N\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\235\000\000\000\000\002\238\000\000\002\234\002\237\002\236\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000.\000\000\000\000\002n\000\000\000/\000-\000\000\000\000\000\000\002\206\000\000\002\227\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002h\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0005\000\000\000\000\0006\000\000\000\000\000\000\000\000\002f\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002e\002g\000\000\000\000\0004\002\154\000\000\000\000\002\162\000\000\002\163\000\000\000\000\002j\002\152\000\000\002\199\000\000\002\213\0000\000\000\000\000\000\000\002\202\000\000\002\158\000\000\002\159\000\000\002\219\000\000\000\000\000\000\000\000\002\149\000\000\000\000\002\186\000\000\002\193\000\000\002\194\002\151\000\000\002\198\000\000\002\211\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\b\000\000\000\000\000\000\000\000\002\201\000\000\002\160\000\000\002\161\000\000\002\217\002\150\000\000\002\200\000\000\002\215\002\153\000\000\000\000\000\000\000\000\002\204\000\000\000\000\002\203\000\000\002\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\239\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\244\000\000\000L\000\000\000\000\000\000\002\243\000\000\000J\000\000\000\000\000\000\000\000\000\000\002\245\000\000\002\208\000\000\002\231\000\000\000\000\000\000\000\000\002\207\000\000\002\229\000\000\000\000\000\000\000\000\000\000\000\000\002\209\000\000\002\233\000\000\000\000\002\191\000\000\000\000\000\000\000\000\000\000\002\189\000\000\002\190\002\188\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\195\000\000\000\000\000\000\000\000\000\000\002\196\000\000\000\000\002\197\000\000\000\000\002\146\000\000\000\000\000\000\000\000\000\000\002\144\000\000\000\000\000\000\002\145\000\000\002\192\000\000\000\000\000\000\002Y\001D\000\000\000\000\002\205\000\000\002\225\000\000\002\223\000\000\000\000\000\000\0001\000\000\000\000\000\000\002\241\000\000\000\000\000\000\000\000\002\148\000\000\002\246\000\000\000A\000\000\000X\000\000\000\000\000\000\000\000\000@\000\000\000V\000\000\000\000\000\000\000\000\000\000\000\000\000B\000\000\000Z\000\000\000\000\000\000\000=\000\000\000\000\000\000\000>\000\000\000R\000\000\000P\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0003\000\000\000\004\000\000\000\000\000+\000\000\000\000\000\014\000\000\000\018\000\000\000\000\000?\000\000\000T\000\000\002\242\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001J\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000`\000\000\000c\000\000\000\000\000a\000\000\000b\000\000\000l\000\000\000\000\000f\000\000\000g\000\000\000d\000\000\000e\000\000\000\000\000j\000\000\000k\000i\000\000\002r\000\000\000h\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\182\000\000\000\000\000\000\000\000\001\160\000\000\000\000\000\000\000\000\001\181\000\000\000\000\001\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\180\000\000\000\000\000\000\000\000\001\179\000\000\000\000\001\220\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\184\000\000\000\000\000\000\000\000\001\183\000\000\000\000\001\222\001\231\001\172\000\000\000\000\000\000\000\000\001\171\000\000\000\000\001\216\001\174\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\176\000\000\000\000\000\000\000\000\001\175\000\000\000\000\001\218\000\000\000\000\000\000\000\000\001\173\000\000\000\000\001\217\001\166\000\000\000\000\000\000\000\000\001\165\000\000\000\000\001\213\001\202\000\000\000\000\000\000\000\000\001\201\000\000\000\000\000\000\000\000\000\000\001\188\000\000\000\000\000\000\000\000\001\187\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\194\000\000\000\000\000\000\000\000\001\193\000\000\000^\000\\\000\000\000]\000\000\000\000\000\000\000_\000\000\000\000\002p\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\210\000\000\000\000\000\000\000\000\000\000\001\186\000\000\000\000\000\000\000\000\001\185\000\000\000\000\000\000\000\000\000\000\001\192\000\000\000\000\000\000\000\000\001\191\000\000\000\000\000\000\001\209\000\000\000\000\000\000\000\000\000\000\001\190\000\000\000\000\000\000\000\000\001\189\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\200\000\000\000\000\000\000\000\000\001\199\000\000\000\000\000\000\000\000\001\197\000\000\000\000\000\000\000\000\000\000\001\196\000\000\000\000\000\000\000\000\001\195\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\206\000\000\000\000\000\000\000\000\001\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\204\000\000\000\000\000\000\000\000\001\203\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\208\000\000\000\000\000\000\000\000\001\207\001\235\001\232\001\168\000\000\000\000\000\000\001\225\000\000\000\000\000\000\001\226\000\000\000\000\000\000\000\000\001\167\000\000\000\000\001\214\001\240\000\000\001\239\000\000\000\000\000\000\000\000\001\236\001\162\000\000\000\000\000\000\000\000\001\161\000\000\000\000\001\211\001\170\000\000\000\000\000\000\001\223\000\000\000\000\000\000\001\224\000\000\000\000\000\000\000\000\001\169\000\000\000\000\001\215\001\164\000\000\000\000\000\000\000\000\001\163\000\000\000\000\001\212\001\227\000\000\000\000\000\000\001\228\001\229\000\000\000\000\001\230\001\242\000\000\000\000\000\000\000\000\001\241\000\000\000\000\001\243\001\244\001\178\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\219\001\237\000\000\000\000\000\000\001\238\001\233\000\000\000\000\000\000\001\234\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\132\002\129\002\135\002\130\002~\002\127\002\128\002\134\002\131\002\136\002\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002&\000\000\000\000\000\000\002'\000\000\002(\000\137\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\134\000\000\000\000\000\000\000\135\000\000\000\136\000\127\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\000\000\000\000\130\000\000\000\000\000\000\000\000\000u\000y\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000v\000\000\000\000\000\000\000w\000\000\000x\000\000\000\000\000\000\000\000\000p\000t\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\131\000\000\000\000\000\000\000\132\000\000\000\000\000\000\000\000\000z\000~\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000{\000\000\000\000\000\000\000|\000\000\000}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000q\000\000\000\000\000\000\000r\000\000\000s\000\000\000\000\002H\000\000\000\000\002J\000\000\000\000\000\000\000\000\002I\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002L\000\000\000\000\000\000\000\000\002K\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\n\001\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\011\000\000\000\000\000\000\001\012\000\000\001\r\000\000\000\000\000\000\000\000\000\000\000\000\002*\002.\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002+\000\000\000\000\000\000\002,\000\000\002-\002)\000\000\000\000\000\000\000\000\000\000\000\000\002B\002F\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002C\000\000\000\000\000\000\002D\000\000\002E\002A\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0020\0024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0021\000\000\000\000\000\000\0022\000\000\0023\002/\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0026\002:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0027\000\000\000\000\000\000\0028\000\000\0029\0025\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002<\002@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002=\000\000\000\000\000\000\002>\000\000\002?\002;\000\000\000\000\000\000\000\000\002G\000\000\000\000\000\000\000\000\000\000\000\000\002O\000\000\000\000\000\000\000\000\002P\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001G\001H\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002R\000\000\002V\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002S\000\000\000\000\000\000\000\000\002T\000\000\000\000\002U\000\000\002Q\000\000\000\000\002N\000\000\000\000\000\000\000\000\000\000\002M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002_\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000\000\000\178\000\000\000\000\000\000\000\000\000\161\000\177\000\000\000\000\000\000\002l\000\000\000\000\000\000\000\000\000\180\000\000\000\000\000\000\000\000\000\162\000\179\000\000\000\000\000\000\000\000\000\223\000\000\000\000\000\000\000\000\000\212\000\222\000\000\000\000\000\000\000\000\000\225\000\000\000\000\000\000\000\000\000\213\000\224\000\000\000\000\000\000\000\000\000\147\000\000\000\000\000\000\000\207\000\000\000\000\000\000\000\000\000\000\000\206\000\201\000\000\000\000\000\000\000\000\000\000\000\148\000\000\000\000\000\000\000\000\000\170\000\000\000\000\000\000\000\000\000\157\000\169\000\000\000\000\000\000\000\000\000\172\000\000\000\000\000\000\000\000\000\158\000\171\000\000\000\000\000\000\000\000\000\215\000\000\000\000\000\000\000\000\000\208\000\214\000\000\000\000\000\000\000\000\000\217\000\000\000\000\000\000\000\000\000\209\000\216\000\000\000\000\000\000\000\000\000\145\000\000\000\000\000\000\000\203\000\000\000\000\000\000\000\000\000\000\000\202\000\199\000\000\000\000\000\000\000\149\000\000\000\000\000\000\000\000\000\174\000\000\000\000\000\000\000\000\000\159\000\173\000\000\000\000\000\000\000\000\000\176\000\000\000\000\000\000\000\000\000\160\000\175\000\000\000\000\000\000\000\000\000\219\000\000\000\000\000\000\000\000\000\210\000\218\000\000\000\000\000\000\000\000\000\221\000\000\000\000\000\000\000\000\000\211\000\220\000\000\000\000\000\000\000\000\000\146\000\000\000\000\000\000\000\205\000\000\000\000\000\000\000\000\000\000\000\204\000\200\000\155\000\000\000\000\000\000\000\000\000\000\000\156\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\151\000\000\000\000\000\000\000\000\000\000\000\152\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\154\000\144\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\142\000\000\000\000\000\000\000\000\000\000\000\143\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\139\000\000\000\000\000\000\000\000\000\000\000\140\001\002\000\000\000\000\000\000\000\000\000\000\000\000\001\001\000\192\000\000\000\000\000\000\000\000\000\183\000\191\000\000\000\000\000\000\000\000\000\194\000\000\000\000\000\000\000\000\000\184\000\193\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\244\000\000\000\000\000\000\000\000\000\231\000\243\000\000\000\000\000\000\002\139\000\000\000\000\000\000\002\140\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\246\000\000\000\000\000\000\000\000\000\232\000\245\000\000\000\000\000\000\000\000\000\000\000\242\000\000\000\000\000\000\000\000\000\227\000\241\000\167\000\000\000\000\000\000\000\000\000\000\000\000\000\168\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\163\000\000\000\000\000\000\000\000\000\000\000\000\000\164\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\000\000\000\000\000\000\000\000\000\000\166\000\188\000\000\000\000\000\000\000\000\000\181\000\187\000\000\000\000\000\000\000\000\000\190\000\000\000\000\000\000\000\000\000\182\000\189\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\238\000\000\000\000\000\000\000\000\000\229\000\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\240\000\000\000\000\000\000\000\000\000\230\000\239\000\000\000\000\000\000\000\000\000\000\000\236\000\000\000\000\000\000\000\000\000\226\000\235\001\000\000\000\000\000\000\000\000\000\000\196\000\000\000\000\000\000\000\000\000\185\000\195\000\000\000\000\000\000\000\000\000\198\000\000\000\000\000\000\000\000\000\186\000\197\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\250\000\000\000\000\000\000\000\000\000\233\000\249\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\252\000\000\000\000\000\000\000\000\000\234\000\251\000\000\000\000\000\000\000\000\000\000\000\000\000\255\000\000\000\000\000\000\000\000\000\000\000\248\000\000\000\000\000\000\000\000\000\228\000\247\001\004\000\000\000\000\000\000\000\000\000\000\002\\\000\000\000\000\000\000\001\006\000\000\000\000\000\000\000\000\000\254\000\000\000\000\000\000\001\003\000\000\000\000\000\000\000\000\000\000\001\005\000\000\000\000\000\000\000\000\000\253\000\000\000\003\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\018\000\000\000\000\000\000\001\019\000\000\001\020\0014\0016\000\000\000\000\000\000\000\000\0015\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0018\000\000\000\000\000\000\000\000\0017\000\000\000\000\000\000\000\000\000\000\001\022\001\026\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\023\000\000\000\000\000\000\001\024\000\000\001\025\001\021\000\000\000\000\000\000\000\000\000\000\000\000\001.\0012\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001/\000\000\000\000\000\000\0010\000\000\0011\001-\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\028\001 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\029\000\000\000\000\000\000\001\030\000\000\001\031\001\027\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\001&\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001#\000\000\000\000\000\000\001$\000\000\001%\001!\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001(\001,\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001)\000\000\000\000\000\000\001*\000\000\001+\001'\000\000\000\000\000\000\000\000\0013\001;\000\000\000\000\000\000\000\000\001<\001>\000\000\001B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001?\000\000\000\000\000\000\000\000\001@\000\000\000\000\001A\000\000\001=\001:\000\000\000\000\000\000\000\000\000\000\0019\000\000\002`")
  
  and error =
    (128, "\000\000\000\000\024\000(@\001\001\002\001\192\012\011\b@\000\000\000\189\005\168@!!\022!\192<K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027o\160c\219?\131 \198\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000B\186\005\027o\160s\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000B\186\005\027o\160s\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\004\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\016@9@\161#\006\000\000\002\031(\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\001\nn a\202\006\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027h\160#\027?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\001\nn a\202\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026m c\202\002\131 \198\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\004\nn a\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\026m s\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026n c\202\002\131 \198\000\000\000\000@0\004\026m s\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\b\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nl c\202\002\130 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026h #J\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026h #J\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nl c\202\002\130 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000p\004\026l c\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\0000\004\026l c\202\002\131 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\n @\000\b\018\000\000\002\000\001\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\b\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\2022\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\186\005\027n\160c\219?\131 \198\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000@\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\250\005\027n\160c\219?\131 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\001 \002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\t@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 @\001 \002\004\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\202\003\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\202\003\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\b\000\000\001\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\b\000\000\001\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000@\000\000\001\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016H8@\161#\006\000\000\000\031(\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\003 \000\004\002\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 \000\003 \002\004\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\004\000\002 \000\000\002\002\000\000\000\000\000\000\016@8@\161#\006@\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@<@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 @! \002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000H\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\003 \002\004\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002 \000\004\002\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000 \000!\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\000 \000\000\b\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@9@\161#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@0\004\no q\202\006\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0000\000\nn a\202\006\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 \000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016B8@\161#\006\000\000\000\031(\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0002\000\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\004\000\002\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\00108\011\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 0xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0020\000\nn a\202\n\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\011n a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\016@8@\177#\006\000\000\000\031(\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\177\005(@!!\022\017\000:\011\028\000\000\000\000\000@0@0\n\002\000\000\000\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\017\0008\011\028\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\022\001\0008\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\218\002\129 \198\000\000\000\000\177\005(@!!\022\001\0008\011\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 0xK\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \176xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \176xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 0xK\024@\000\000\000\181\005\168@!!\022 \016xK\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \000xK\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn\160a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198 \000\000\000\000\000\000\004\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \000xK\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000 @\001 \002\004\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000@\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\001\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\016\000\b@\001!\002\000\000\000\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000 @\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\001 \000\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\b(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\006\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\004\nn a\202\002\129 \198\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\001\000\000\000\000\000\000\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\002\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\012@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\b\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\024\000(@\001\001\130\000\192\012\011\b@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\002\000\000\000\000\000\000\016\002\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\000\000\000\004\000\004\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\b@\001\001\002\000\000\000\011\b\000\000\000\000\000\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\024\000(@\001\001\002\000\192\012\011\b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022!\1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\202\003\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\202\003\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024\000\000\000\000\000\000\000\000\000\000\128\000\000@\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn\160a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1768K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0020\000\nn a\202\n\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\011n a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000 \000\000\000\000\000\000\004\000\000\000\000\000@\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn\160a\203\002\129 \198\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0000\000\nn a\203\002\129 \198\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\0010\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1768K\024@\000\000\000\181\005\168@!!\022 \1448K\024\000\000\000\000\177\005(@!!\018\001\0008\011\024@\000\000\000\181\005\168@!!\150 \1288K\024@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\0008\000\nn a\202\002\129 \198\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004\001\000\000\000\000\000\000\000\000\016@8@\161#\006\000\000\000\031(\000\000\000\000\000\176\000\nn a\202\002\129 \198\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\0010\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\177\005(@!!\018\000\0008\011\024\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000@\000\000\000\181\005\168@!!\022 \0008K\024\000\000\000\000\000\000\000\000\000\000\000\000\000@\000\000@\000\000\000\181\005\168@!!\022 \1288K\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\128\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000")
  
  and start =
    2
  
  and action =
    ((16, "\028<\028L\000\000\203\198\000\127\194N\000q\194N\000\000\001\"\194\192\000\000\000\000\000A\000\000\001\212\000\000\000d\000\218\000C\000\000\1952\000\000\194N\194N\194N\1952\000\000\000\000\001\022\000\000\002\134\000\000\194N\000p\000\000\195\164\000\000\000\000\001$\000\000\0038\000\000\000\000\000\252\194N\002\002\000\000\003\234\000\000\194N\001\b\201\172\000\220\001\022)\248\001x\025v\000\000\001n\001\190\000\000\025v\000\000\000\000\000\000\001\224\194NM*\194N\n,\196\022\002\024\194NR\\\194N\n\222\000}\0004\000\000\000<\0004\000\000\002\130\000\000\000\000\194N\011\144\002r\000\000JV\000\000\194N\012B\194N\012\244\194N\r\166\194N\014X\194N\015\n\194N\015\188\194N\016n\194N\025x\194N\017 \194N\017\210\194N\026*\002\152\196\180\194N\196\180\000f\196\180\000\000R\\\194N\018\132\194N\026\220\194N\027\142\194N\000\000\0196\197R\000\000\019\232\194Ne\016\196\180\000\000\194N\020\154\194N\021L\194N\021\254\196\180\000\000\000\000\022\176\003.\000\000\000\000J\226\197R\000\000\003D\000\000R\232\194N\000\000\000\000\002x\000\000Kv\000\000\000\000\002\250\003,\029\252\000\000\197\196\000\000\004*\000\000L\n\000\000\196\022\196\022\194Ne\156\000\000\194N\004\154\000\000\195\164\000\000\004\152\000\000\000\000\002\202\000\000L\158\000\000\194NR\\\194NM*\194Ne\016\194NM*\000\000\004J\194NM*\030\136\000\000\1986\000\000\004\198\000\000M\190\000\000\000\000\003h\000\000NR\000\000\000\000\004\170\194Ne\016\000\028\000\000\196\022\003j\000\000N\230\000\000\196\022\004\188\202\030\005\030\005J*$\005\146\025v\000\000\005\168\202\144\005\152\005\240*P\006V\025v\000\000\004\156\000\000*\228\006l\025v\000\000\005N\000\000M*\194N\150\226\006n\025v\000\000\003|\000\000Oz\000\000+\016\006\148\025v\003\146\000\000P\014\000\000R\232\194N\151n\006\150\025v\003\158\000\000P\162\000\000St\198\168\000\000T\000\196\022T\140\000o\001P\000\000\006\184\000\000\000\000\196\022U\024\196\022U\164\196\022\151\250\196\022V0\196\022V\188\196\022WH\196\022W\212\196\022X`\196\022X\236\196\022Yx\196\022\192D\196\022Z\004\196\022Z\144\006\154\196\180\006\214\000\000\196\022[\028\196\022\192\208\199F\000\000[\168\199\228\000\000\\4\196\022\000\000\196\022\\\192\196\022]L\196\022\000\000\196\022\152\132\196\022\000\000\006\240\000\000\006\176\001\224\198\168\000\000\000\000\006\248\003\170\000\000Q6\000\000Q\202\000\000]\216^d\0070\000\000 \254\196\022\0078\000\000\006\206\025v\001&\025v\000\000\007b\000\000\003\184\000\000\006\000\000\000+<\007D\025v\003\202\000\000\006\178\000\000e\016\194N\153\014\007F\025v\003\214\000\000\007d\000\000\023b\149\208\000j\000\000\196\022\007X\003\220\000\000\b\022\000\000\b\200\000\000\007l\000\000\150V\194NM*\007\004\194N\024\020\007b\000\000f(\000\000\194N\007t\000\000\024\198\007x\000\000\007z\000\000\150V\003\222\000\000\tz\000\000\150\226\000\000\000\234\007\012\0072\000\016\007&\203\198\000\023\007\030\007F\007^\025v\007N\007\164\025v\000\000\007\144\007\168\007D\203\198\0078\007^\000;\025v\003\020\007N\203\198\026\218\000~\007\128\030\212\007Z\007~\031F\194NM*\194NR\\\007f\007\134\031F\000zf\206\001\238gZ\007\168\194N\151n\0036\007~\194NR\\g\230\007\142\007\228hr\000\184\007\230h\254\194Ni\138\000\137\200V\007\236j\022\003\166\007\140\194N\153\014j\162\007~\007\160\001\168\007\148\194N\153\160k.\000\000\0262\000\000\007\132\007\166\000\000\0262\000\000\007\238\000\000\000=\196\022\000\000\007\168\000\000\199F\000\000\007\242\000\000\003\156\002\178\000\000\007\250\000\000\000\000\0262\000\000\b\020\000\000\003\174\007\186\194N\1542k\186\000@\b\030lF\002Z\007\190\194N\154\196l\210\194N\155Vm^\b\"m\234%:\007\238\194N\153\014\003\230\007\196\194N\155\232nv\003\232\007\200\194N\156zo\002\007\248\194N\153\160\0010\007\206\194N\157\012o\142\003\242\007\208\194N\157\158p\026\194N\1580p\166\007\252\203\002\007\202\007\240+\208\b&\025v\003\248\007\238\194N\158\194q2\000\000\000*\194N\159Tq\190\000\000\001\006\194N\159\230rJ\000\000\bTr\214\000\000,\\\b0\025v\004\000\007\246\194N\160xsb\000\000\001~\194N\161\ns\238\000\000\bZtz\000\000\150V\194N\161\150\b6\025v\004\020\007\252\194N\162(u\006\000\000\001\172\194N\162\186u\146\000\000\bdv\030\000\000\000\000\000\000\001\178\194N\163Lv\170\000\000\bfw6\000\000\000\000\196\022\bR\004$\b\016\194N\163\222w\194\000\000\001\218\194N\164pxN\000\000\bxx\218\000\000\001\240\194N\165\002yf\000\000\b~y\242\000\000\000\000\002\026\194N\165\148z~\000\000\b\128{\n\000\000\000\000\b.\194N\166&{\150\000\000\004&\b0\194N\166\184|\"\000\000\b2\194N\167J|\174\000\000\b\"\bD\004,\b<\194N\167\220}:\000\000\b>\194N\168n}\198\000\000\001\148\000\000\000\000\001\148\000\000\b \001\148\b\162\000\000\004\014\001\148\000\000\b$\001\148\b\166\bJ\194N\169\000~R\000\000\004X\bP\194N\169\146~\222\000\000\bR\194N\170$\127j\000\000\002\128\bT\194N\170\182\127\246\000\000\b\\\194N\171H\128\130\000\000\194N\171\218\129\014\000\000\004`\bh\194N\172l\129\154\000\000\bl\194N\172\254\130&\000\000\b\154\194N\1542\002\022\bp\194N\173\144\130\178\000\000\196\022\b\190\004p\bt\194N\174\"\131>\000\000\bv\194N\174\180\131\202\000\000\bz\194N\175F\132V\000\000\004~\b~\194N\175\216\132\226\000\000\b\128\194N\176j\133n\000\000\b\168\203t\bv\b\156,\232\b\208\025v\004\150\b\156\194N\176\252\133\250\000\000\b\160\194N\177\142\134\134\000\000-t\b\224\025v\004\152\b\166\194N\178 \135\018\000\000\b\168\194N\178\178\135\158\000\000\150\226\194N\179>\b\230\025v\004\154\b\172\194N\179\208\136*\000\000\b\174\194N\180b\136\182\000\000\000\000\000\000\000\000\200\200\t\022\137B\000\000\t\020\t\026\137\206\000\000\002\160\194N\180\244\138Z\000\000\t$\138\230\000\000\000\000\139r\000\000\b\214\t,\t2\139\254\000\000\000\000\002\162\194N\181\134\140\138\000\000\tB\141\022\000\000\000\000\201:\tD\141\162\000\000\tB\tH\142.\000\000\002\238\194N\182\024\142\186\000\000\tJ\143F\000\000\000\000\003\022\194N\182\170\143\210\000\000\tP\144^\000\000\000\000\tN\tV\144\234\000\000\000\000\183<\145v\000\000\000\000\194N\154\196\tX\146\002\000\000\tZ\146\142\000\000\000\000\000\000\003\028\194N\183\206\147\026\000\000\t\\\147\166\000\000\000\000\tZ\td\1482\000\000\000\000\tb\th\148\190\000\000\t\n\t4\031F\t\026\t:\031F\194N\150\226\031F\029\014\031F\t0\t$\194NM*\194NR\\\194NM*\t@\031F\194NM*\t$\tF\001D\210\014_\n\210\014_\150\210\014`\"\210\014\t\030\t@`\174\210\014a:\210\014a\198\210\014\196\180\t\128bR\210\014b\222\210\014cj\210\014c\246\210\014d\130\210\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\149J\194N\151n\031F\000\018\194N\153\014\031F\000\018\000\000\003f\001D \000\001D\031F\t\"\001D\000\000\001p\194N\153\160\031F\000\018\004\004.2\000\000\031F\t<.\236\000\000/\166\000\000\000\000\002\244\194N\1542\031F\000\018\004\024\001D\000\000\031F\tB\001D\000\000\001D\000\000\000\000\031F\tJ\001D\000\000\193@\194N\154\196\031F\000\018\004B\001D\000\000\031F\tN\001D\000\000\001\246\031F\t>\001D\000\000\000\000\003p\194N\155V\031F\000\018\004P\001D\000\000\031F\tT\001D\000\000\001D\000\000\002\168\031F\tB\001D\000\000\000\000\194NM*\193\194\194N\155\232\031F\000\018\004p\001D\000\000\031F\tX\001D\000\000\002\198\031F\tF\001D\000\000\000\000\004\000\194N\156z\031F\000\018\004t\001D\000\000\031F\t\\\001D\000\000\001D\000\000\004\"\194N\157\012\031F\000\018\004v\001D\000\000\031F\tb\001D\000\000\001D\000\000\tP0`\000\000\tR1\026\000\000\t\142\031F\tb1\212\000\000\194NR\232\194Ne\016\t\154\031F\tj2\142\000\000\t\172\031F\t|3H\000\000\t~\029\006\194N\157\158 \186\029\006\031F\t\128\029\006\000\000\000\000\004\178\194N\1580\031F\000\018\004\152\029\006\000\000\031F\t\150\029\006\000\000\029\006\000\000\031F!t \000\031F\t\1364\002\000\000\000\000\004\196\194N\158\194\031F\000\018\004\1824\188\000\000\031F\t\1585v\000\00060\000\000\000\000 \186\".!t\031F\t\1426\234\000\000\000\000\004\200\194N\159T\031F\000\018\004\1847\164\000\000\031F\t\1648^\000\0009\024\000\000\000\000\000\163\194N\159\230\031F\000\018\004\202\029\006\".\"\232\"\232\031F\t\1469\210\000\000\000\000\004\234\194N\160x\031F\000\018\004\204:\140\000\000\031F\t\168;F\000\000<\000\000\000\000\000\031F\t\170\029\006#\162#\162$\\\031F\t\156<\186\000\000\000\000\004\242\194N\161\n\031F\000\018\004\238=t\000\000\031F\t\178>.\000\000>\232\000\000\000\000\029\006%\022$\\%\208\031F\t\160?\162\000\000\000\000\005\004\194N\161\150\031F\000\018\004\244@\\\000\000\031F\t\188A\022\000\000A\208\000\000\000\000\t\184\031F\t\200B\138\000\000\t\184\nN\194Ne\016\t\208CD\000\000\194N\184`\t\210C\254\000\000\t\192\t\180\t\236\t\222\t\254\002\230\194Ne\156\002\230\031F\t\206\003T\000\000\000\000\005\n%\022\003\174\031F\t\212\t\218D\184\000\000Er\000\000\005\022\194N\162(\031F\000\018\004\248\t\224F,\000\000\031F\t\252\t\236F\230\000\000\t\240G\160\000\000HZ\000\000\t\242I\020\000\000\n\b\n(\031F\t\248I\206\000\000\t\250\203\198\000x\031j\005p\n\020\203\198\005\\\n\b\n*\nH\005v\002\182\005v\000\000\nx\n\148\n0\203\198\025v\000\246\nD\194N\184\242\nB\203\198\025v\001 \nH\194N\185\132\nF\203\198\025v\002\188\nr\194Ne\156\n\180\nP\203\198\0032\000\182\nT\203\198\000\000 $\005\136\nV\203\198\000\000\203\198\031F\nD\203\198\000\000\000\000\nl\002\150\025v\000\000\n\190\005\144\nb\203\198\000\000\204(\031F\nP\203\198\000\000\000\000\025v\005\156\nf\203\198\000\000\204z\031F\nZ\203\198\000\000\000\000\n\198\005\160\nz\203\198\000\000\204\170\031F\nj\203\198\000\000\000\000\194N\186\022\n\128\203\198\000\000\005\148\n\130\203\198\000\000\031F\np\204(\n\134\203\198\000\000\000\000\nz\n\158\000\194\n\144\203\198\000\000 \222\005\170\n\146\203\198\000\000\204\232\031F\n\128\203\198\000\000\000\000\n\252\005\182\n\160\203\198\000\000\205\024\031F\n\146\203\198\000\000\000\000\026\218\005\200\n\174\203\198\000\000\205V\031F\n\158\203\198\000\000\000\000\011\n\005\208\n\184\203\198\000\000\205\134\031F\n\166\203\198\000\000\000\000\194N\186\168\n\188\203\198\000\000\005\150\n\190\203\198\000\000\031F\n\172\204z\n\198\203\198\000\000\000\000\000\250\n\200\203\198\000\000!\152\005\216\n\202\203\198\000\000\205\196\031F\n\192\203\198\000\000\000\000\011<\005\224\n\224\203\198\000\000\205\244\031F\n\206\203\198\000\000\000\000\030\212\005\226\n\242\203\198\000\000\2062\031F\n\224\203\198\000\000\000\000\011J\005\234\n\248\203\198\000\000\206b\031F\n\230\203\198\000\000\000\000\194N\187:\011\000\203\198\000\000\005\204\011\002\203\198\000\000\031F\n\242\204\232\011\b\203\198\000\000\000\000\000\000\194N\187\198\011p\011\012\203\198\000\000\011\000\011&\011@\194Nf(\011~\011 \203\198\000\000\194N\188R\011\138\011,\203\198\000\000\011Z\194N\149\208\011\152\0114\203\198\000\000\194N\188\222\011\156\0118\203\198\000\000\000\000\011,\011P\011F\194N\189p\011D\203\198\000\000\011J\194N\190\002\011L\203\198\000\000\000\000\011D\011j\011d\194N\190\148\011d\203\198\000\000\011l\194N\191&\011j\203\198\000\000\000\000\011\146\005v\011\190\011\214\011r\203\198\000\000\000\000\206\160\031F\011d\203\198\000\000\000\000\011\220\005\236\011|\203\198\000\000\206\208\031F\011r\203\198\000\000\000\000-\192\011\144\025v\011\164\006\024\011\148\203\198\000\000\207\014\031F\011\144\203\198\000\000\000\000\000W\005\188\025v\000\000\011\184\005\246\025v\000\000\011\252\011\174\025v\011\190\006\026\011\178\203\198\000\000\207>\031F\011\160\203\198\000\000\000\000\025v\011\202\006\"\011\186\203\198\000\000\207|\031F\011\168\203\198\000\000\000\000\000\000\012 \011\192\011\228\031F\011\180\203\198\000\000\011\188\011\228\012\006\"R\011\222\012\000\031F\011\208\203\198\000\000\012H\011\232\012\b\031F\011\216\203\198\000\000\012 #\012\011\244\012\020\031F\011\228\203\198\000\000\012`\012\004\012(\031F\011\254\203\198\000\000\000\000\207\172\031F\012\002\203\198\000\000\000\000\012|\006(\012\028\203\198\000\000\207\234\031F\012\n\203\198\000\000\000\000^\152\012$\025v\0124\006:\012$\203\198\000\000\208\026\031F\012\022\203\198\000\000\000\000\012\128\0122\025v\012J\006B\012>\203\198\000\000\208X\031F\0120\203\198\000\000\000\000\025v\012X\006N\012V\203\198\000\000\208\136\031F\012D\203\198\000\000\000\000\000\000#\198\006\\\012Z\203\198\000\000\208\198\031F\012H\203\198\000\000\000\000\012\192\006h\012d\203\198\000\000\208\246\031F\012R\203\198\000\000\000\000f\\\012n\025v\012~\006\130\012n\203\198\000\000\2094\031F\012\\\203\198\000\000\000\000\012\198\012|\025v\012\140\006\138\012|\203\198\000\000\209d\031F\012p\203\198\000\000\000\000\012\174\025v\012\224\012\250\012\150\203\198\000\000\025v\012\170\006\144\012\154\203\198\000\000\209\162\031F\012\136\203\198\000\000\000\000\000\000\012\206\025v\012\180\005\138$\128\000\000\r\b\012\168\203\198\000\000\025v\r\016\012\176\203\198\000\000\002&\012\182\203\198\000\000\012\236\025v\r&\012\200\203\198\000\000\025v\r2\012\206\203\198\000\000\012\206\000\000\000\000\028L\000\000&\138\194Ne\156\194NR\232\012\210\012\242\031F\012\194&\138\012\220\012\252\031F\012\204\012\200\r\002\012\246\r\022\002\230\005\232%\208\006\"\031F\012\244\012\246&\138\r\012\r,\031F\012\252\r\150\194N\149\208\r\024&\138\194N\162\186&\138\029v\031F\r\b\029\006&\138\r0\r$\194NR\232\194Nf(\194N\149\208\r@\031F\r\016&\138\194NR\\\r*\rJ\001D\r\026&\138\006f\194N\163L\031F\000\018\0060&\138\000\000\031F\r6&\138\000\000&\138\000\000\000\000\000\000\rX\031F\r.&\138\000\000\194N\150V\194N\150\226\rd\031F\r4&\138\000\000\rh\031F\r8&\138\000\000'D&\138\031F\r:&\138\000\000\000\000\006n\194N\163\222\031F\000\018\006X&\138\000\000\031F\rP&\138\000\000&\138\000\000\000\000'D'\254'D\031F\r@&\138\000\000\000\000\006\142\194N\164p\031F\000\018\006\140&\138\000\000\031F\rX&\138\000\000&\138\000\000\000\000\001J\194N\165\002\031F\000\018\006\146\029\006'\254(\184'\254\031F\rF&\138\000\000\000\000\006\200\194N\165\148\031F\000\018\006\174&\138\000\000\031F\r\\&\138\000\000&\138\000\000\000\000\031F\rb\029\006(\184)r(\184\031F\rT&\138\000\000\000\000\006\218\194N\166&\031F\000\018\006\204&\138\000\000\031F\rn&\138\000\000&\138\000\000\000\000\029\006)r.2)r\031F\rb&\138\000\000\000\000\006\222\194N\166\184\031F\000\018\006\206&\138\000\000\031F\rz&\138\000\000&\138\000\000\000\000\rv\031F\r\128&\138\000\000\000\000\194N\191\184\r\130&\138\000\000\000\000&\138\000\000\006\244\194N\167J\031F\000\018\006\226\rp&\138\000\000\031F\r\134\rt&\138\000\000\rz&\138\000\000&\138\000\000\000\000\r\144\r\176\031F\r\136&\138\000\000\r\160\000\000"), (16, "\000R\000:\001\137\007\178\019\186\000%\001\137\000%\000\022\000%\000%\000%\001:\000%\020\150\000\030\t\193\016\"\0049\004z\000%\011\181\000%\t\193\001V\001\137\000%\000%\011\181\000%\000%\004\138\000%\000%\001\137\000%\000%\000%\000V\000%\b\026\000%\007\022\027r\b*\028\222\006\218\003z\000%\000%\003\214\000>\006\206\000%\000%\000%\000%\011\181\000%\000%\029\130\000%\000%\029\218\029N\000%\000%\000%\000%\000%\000%\000%\b:\bz\t\177\030J\r\206\000%\000%\001>\bR\000%\030f\t\177\027~\030\154\006.\000%\000%\000\142\003~\b\026\000%\000%\000)\b*\000)\005\142\000)\000)\000)\030\194\000)\r\214\0049\007b\t\141\016\"\0049\000)\011\177\000)\001B\007.\tZ\000)\000)\011\177\000)\000)\028\022\000)\000)\b:\000)\000)\000)\000\146\000)\0062\000)\022\022\014\254\007\158\0276\022\182\006J\000)\000)\003\238\001F\023\206\000)\000)\000)\000)\011\177\000)\000)\028Z\000)\000)\000J\027\198\000)\000)\000)\000)\000)\000)\000)\001\222\022\194\014\158\015v\023*\000)\000)\023\218\024\206\000)\0242\000z\022^\006\194\t\177\000)\000)\014\178\000\162\026\150\000)\000)\000-\023\130\000-\023\150\000-\000-\000-\024\138\000-\024\158\nI\022z\000N\024\218\000\182\000-\0252\000-\026Z\b\242\030\214\000-\000-\000\210\000-\000-\026\182\000-\000-\000\218\000-\000-\000-\000*\000-\025\138\000-\025\158\004~\000~\016>\tn\000\222\000-\000-\nF\000\166\026z\000-\000-\000-\000-\t\177\000-\000-\n\134\000-\000-\001F\016F\000-\000-\000-\000-\000-\000-\000-!b\000\230\011F\015v\001B\000-\000-\005\194\t\177\000-\">\t\177\007\222\016\"\0049\000-\000-\001\185\011J\016Z\000-\000-\001\017\011N\001\017\000B\001\017\001\017\001\017\016\134\001\017\t\177\001\129\014\018\t\178\000\242\001\129\001\017\011R\001\017\000\190\007j\t\177\001\017\001\017\tY\001\017\001\017\0142\001\017\001\017\001F\001\017\001\017\001\017\001\129\001\017\t\254\001\017\000\246\n&\001\014\016>\t\177\001\129\001\017\001\017\0126\014\234\030\218\001\017\001\017\001\017\001\017\001F\001\017\001\017\001F\001\017\001\017\nj\017\018\001\017\001\017\001\017\001\017\001\017\001\017\001\017\001&\000\194\n\138\015v\012J\001\017\001\017\001f\001F\001\017\002\134\005n\b\134\030\230\012~\001\017\001\017\001\185\015v\001F\001\017\001\017\001\t\n\174\001\t\000\130\001\t\001\t\001\t\030\254\001\t\011\194\001\133\r\138\021R\001R\001\133\001\t\t\169\001\t\001F\t\177\t\177\001\t\001\t\t\169\001\t\001\t\r\170\001\t\001\t\002\246\001\t\001\t\001\t\001\133\001\t\001j\001\t\bB\002\138\022\150\016>\tq\001\133\001\t\001\t\011\214\025\230\001\206\001\t\001\t\001\t\001\t\011\234\001\t\001\t\016>\001\t\001\t\t\177\017b\001\t\001\t\001\t\001\t\001\t\001\t\001\t\021R\r\174\r\242\001B\005\021\001\t\001\t\017\178\026\"\001\t\007\030\t\177\002\250\022\246\t\177\001\t\001\t\001\185\001F\001F\001\t\001\t\001\025\021^\001\025\000\170\001\025\001\025\001\025\022>\001\025\022\178\001\185\007~\002V\016\150\002n\001\025\023\194\001\025\0146\003Z\003\134\001\025\001\025\016\194\001\025\001\025\005\021\001\025\001\025\004\018\001\025\001\025\001\025\002\154\001\025\001F\001\025\005\017\014Z\028\154\004.\014\202\002\158\001\025\001\025\024\202\004R\014\198\001\025\001\025\001\025\001\025\005\130\001\025\001\025\001F\001\025\001\025\001F\005\214\001\025\001\025\001\025\001\025\001\025\001\025\001\025\007\194\005\242\003^\003\138\bf\001\025\001\025\006\022\017*\001\025\006>\006\170\004\022\016:\005\017\001\025\001\025\016\206\017V\b>\001\025\001\025\0011\0042\0011\000\198\0011\0011\0011\004V\0011\bN\b\190\b\210\021~\005\134\014V\0011\t\006\0011\r\238\tB\005\218\0011\0011\t\154\0011\0011\t\185\0011\0011\005\246\0011\0011\0011\t\230\0011\006\026\0011\021\146\006B\006\174\002\178\nR\n\230\0011\0011\011\026\n\206\n\170\0011\0011\0011\0011\n\"\0011\0011\tj\0011\0011\017\202\t\174\0011\0011\0011\0011\0011\0011\0011\011\150\017\246\t\250\016n\011\254\0011\0011\016v\018\002\0011\nf\n\250\012V\016\170\011.\0011\0011\016\178\018.\012\150\0011\0011\001)\011j\001)\003\218\001)\001)\001)\002\218\001)\012\222\r\022\rV\016\246\002\234\011\170\001)\016\254\001)\012\018\017>\003*\001)\001)\017F\001)\001)\012j\001)\001)\003F\001)\001)\001)\012\170\001)\017\150\001)\017\222\018\022\017\158\003n\017\230\018\030\001)\001)\012\242\r*\rj\001)\001)\001)\001)\003\154\001)\001)\018\222\001)\001)\018\202\018\230\001)\001)\001)\001)\001)\001)\001)\019\"\018\246\019~\0196\019\146\001)\001)\019>\019\154\001)\019N\021v\019\170\019\206\020\n\001)\001)\020.\020\018\019\246\001)\001)\001!\020^\001!\003\242\001!\001!\001!\020\"\001!\020r\020\190\020\138\020\210\020z\021\178\001!\020\218\001!\021\190\021\158\020\234\001!\001!\022\030\001!\001!\022*\001!\001!\021\210\001!\001!\001!\021\222\001!\022\202\001!\tu\te\023\006\003\162\023\154\024\162\001!\001!\0232\003\166\023^\001!\001!\001!\001!\023\226\001!\001!\026\210\001!\001!\024\014\003\174\001!\001!\001!\001!\001!\001!\001!\024:\022:\025\162\n!\024f\001!\001!\026\242\024\226\001!\023\166\024\174\025\014\025:\003\186\001!\001!\025f\027\018\022\214\001!\001!\001Y\023\018\001Y\005\222\001Y\001Y\001Y\023>\001Y\023j\n%\031v\003\194\030\170\023\238\001Y\025\174\001Y\027J\027\162\024\026\001Y\001Y\027\210\001Y\001Y\028\186\001Y\001Y\024F\001Y\001Y\001Y\024r\001Y\028\242\001Y\024\238\027v\029*\003\198\025\026\025F\001Y\001Y\029Z\025r\027\030\001Y\001Y\001Y\001Y\029\138\001Y\001Y#\026\001Y\001Y\029\182\031~\001Y\001Y\001Y\001Y\001Y\001Y\001Y\027\134\003\206\027V\027\174\029\238\001Y\001Y\027\222\030&\001Y\028\198\030r\003\230\004\006 6\001Y\001Y\"\206 >\028\254\001Y\001Y\001Q\0296\001Q\005\250\001Q\001Q\001Q\029f\001Q \"\004&\004J \222 \202\029\150\001Q \230\001Q\004\134 N\029\194\001Q\001Q \246\001Q\001Q\004\250\001Q\001Q!&\001Q\001Q\001Q\029\250\001Q\005\002\001Q\0302!:!R\030~!v!B\001Q\001Q!\214\005b\005j\001Q\001Q\001Q\001Q\005~\001Q\001Q!\178\001Q\001Q!\158!\186\001Q\001Q\001Q\001Q\001Q\001Q\001Q\"\006!\202\"f\"\026\"z\001Q\001Q\"\"\"\130\001Q\"2\005\162\"\146\"\218\"\238\001Q\001Q\005\178\"\250\005\186\001Q\001Q\001a#\014\001a\006\030\001a\001a\001a\005\206\001a\005\234\006\014\006:\006V\006j\006v\001a\006\138\001a\006\150\006\158\006\198\001a\001a\006\202\001a\001a\006\210\001a\001a\006\222\001a\001a\001a\006\226\001a\006\230\001a\006\238\006\242\006\254\007\002\007\006\007\014\001a\001a\007\018\007\"\0072\001a\001a\001a\001a\007:\001a\001a\007>\001a\001a\007V\007Z\001a\001a\001a\001a\001a\001a\001a\007r\007\130\007\146\007\150\007\162\001a\001a\007\186\007\198\001a\007\214\007\218\007\226\007\254\b\002\001a\001a\b\018\b&\b6\001a\001a\001A\bJ\001A\006F\001A\001A\001A\b^\001A\bj\b~\b\138\b\166\b\178\b\194\001A\b\214\001A\b\230\b\246\t\n\001A\001A\t&\001A\001A\t.\001A\001A\t2\001A\001A\001A\t:\001A\tF\001A\t\130\t\146\t\158\t\198\t\222\t\234\001A\001A\n\018\n:\nN\001A\001A\001A\001A\nV\001A\001A\n~\001A\001A\n\158\n\194\001A\001A\001A\001A\001A\001A\001A\n\210\n\234\n\254\011\018\011\022\001A\001A\011\030\0112\001A\011Z\011b\011v\011~\011\130\001A\001A\011\154\011\174\011\198\001A\001A\0019\011\218\0019\006N\0019\0019\0019\012\002\0019\012\022\012*\012:\012R\012Z\012n\0019\012\130\0019\012\154\012\174\012\194\0019\0019\012\202\0019\0019\012\206\0019\0019\012\214\0019\0019\0019\012\226\0019\012\246\0019\r\014\r\026\r.\rN\rZ\rn\0019\0019\r\146\r\158\r\162\0019\0019\0019\0019\r\194\0019\0019\r\218\0019\0019\r\222\r\226\0019\0019\0019\0019\0019\0019\0019\014\006\014\026\014&\014*\014J\0019\0019\014n\014~\0019\014\130\014\170\014\182\014\222\014\238\0019\0019\014\242\015\002\015\006\0019\0019\001I\015\018\001I\006\178\001I\001I\001I\015\022\001I\015\030\015\"\015>\015B\015^\015n\001I\015r\001I\015\150\015\154\015\186\001I\001I\016N\001I\001I\016~\001I\001I\016\186\001I\001I\001I\016\214\001I\017\006\001I\017\026\017N\017j\017\166\017\186\017\238\001I\001I\018&\018:\018F\001I\001I\001I\001I\018R\001I\001I\018Z\001I\001I\018v\018~\001I\001I\001I\001I\001I\001I\001I\018\138\018\146\018\158\018\186\018\238\001I\001I\019\018\019F\001I\019n\019\162\019\230\020\026\0206\001I\001I\020N\020\130\020\174\001I\001I\000\137\020\226\000\137\020\250\000\137\000\137\000\137\021\002\000\137\021\014\021\018\021\030\0212\021>\021B\000\137\021F\000\137\021J\021N\021f\000\137\000\137\021\134\000\137\000\137\021\138\000\137\000\137\021\182\000\137\000\137\000\137\021\198\000\137\021\202\001\030\021\214\021\234\021\246\021\250\022\002\022\014\000\137\000\137\022\"\022.\0222\000\137\000\137\000\137\000\137\0226\000\137\000\137\022J\000\137\000\137\022N\022R\000\137\000\137\000\137\000\137\0016\000\137\000\137\022b\022n\022~\022\138\022\154\000\137\000\137\022\166\022\170\001Z\022\186\022\206\022\226\022\242\023\002\000\137\000\137\023\n\023\030\0236\000\137\000\137\000\145\023J\000\145\023Z\000\145\000\145\000\145\023b\000\145\023v\023\142\023\158\023\174\023\182\023\198\000\145\023\202\000\145\023\210\023\230\023\250\000\145\000\145\024\n\000\145\000\145\024\018\000\145\000\145\024&\000\145\000\145\000\145\024>\000\145\024R\001\030\024b\024j\024~\024\150\024\166\024\182\000\145\000\145\024\190\024\210\024\230\000\145\000\145\000\145\000\145\024\250\000\145\000\145\025\n\000\145\000\145\025\018\025&\000\145\000\145\000\145\000\145\0016\000\145\000\145\025>\025R\025b\025j\025~\000\145\000\145\025\150\025\166\001Z\025\182\025\190\025\218\025\222\025\234\000\145\000\145\025\238\025\242\025\254\000\145\000\145\000\157\026\002\000\157\026\022\000\157\000\157\000\157\026\026\000\157\026&\0262\0266\026J\026N\026^\000\157\026b\000\157\026f\026r\026~\000\157\000\157\026\138\000\157\000\157\026\154\000\157\000\157\026\158\000\157\000\157\000\157\026\162\000\157\026\174\001\030\026\186\026\198\026\214\026\222\026\226\026\230\000\157\000\157\026\254\027\014\027\022\000\157\000\157\000\157\000\157\027*\000\157\000\157\027>\000\157\000\157\027F\027N\000\157\000\157\000\157\000\157\0016\000\157\000\157\027b\027\130\027\146\027\150\027\158\000\157\000\157\027\166\027\186\000\157\027\206\027\214\027\234\027\254\028\002\000\157\000\157\028\006\028\014\028\026\000\157\000\157\000}\028\030\000}\028\"\001\022\001.\000}\028*\000}\028.\0286\028B\028F\028J\028R\000}\028^\000}\028f\028j\028r\000}\000}\028~\000}\000}\028\130\001z\000}\028\134\001\130\000}\000}\028\142\000}\028\166\001\030\028\182\028\190\028\210\028\230\028\238\028\246\000}\000}\029\n\029\026\029\030\000}\001\138\000}\000}\029&\000}\000}\029.\000}\000}\029B\029V\000}\000}\000}\000}\0016\000}\001\146\029^\029r\029\142\029\162\029\178\000}\000}\029\186\029\206\001Z\029\226\029\234\029\242\030\006\030\022\000}\000}\030\026\030\"\030*\000}\000}\000\133\030>\000\133\030N\000\133\000\133\000\133\030V\000\133\030Z\030^\030n\030v\030\138\030\158\000\133\030\166\000\133\030\182\030\186\030\202\000\133\000\133\030\206\000\133\000\133\030\222\000\133\000\133\030\234\000\133\000\133\000\133\030\242\000\133\030\246\001\030\031\006\031\n\031\023\031>\031B\031J\000\133\000\133\031R\031V\031^\000\133\000\133\000\133\000\133\031b\000\133\000\133\031f\000\133\000\133\031j\031n\000\133\000\133\000\133\000\133\0016\000\133\000\133\031\134\031\138\031\146\031\150\031\158\000\133\000\133\031\162\031\174\001Z\031\202\031\214\031\218\031\246\031\254\000\133\000\133 \014 \018 \026\000\133\000\133\000\149 F\000\149 b\000\149\000\149\000\149 j\000\149 \134 \142 \154 \162 \186 \238\000\149!\022\000\149!J!\142!\194\000\149\000\149!\222\000\149\000\149!\246\000\149\000\149\"*\000\149\000\149\000\149\"V\000\149\"\138\001\030\"\162\"\170\"\194\"\242#\002#\006\000\149\000\149#\018#*#.\000\149\000\149\000\149\000\149#6\000\149\000\149#C\000\149\000\149\000\000\000\000\000\149\000\149\000\149\000\149\0016\000\149\000\149\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\149\000\149\000\000\000\000\000\000\000\149\000\149\000\153\000\000\000\153\000\000\000\153\000\153\000\153\000\000\000\153\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\000\000\153\000\000\000\000\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\153\000\000\000\153\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\000\153\000\153\000\153\000\153\000\000\000\153\000\153\000\000\000\153\000\153\000\000\000\000\000\153\000\153\000\153\000\153\0016\000\153\000\153\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\153\000\153\000\000\000\000\000\000\000\153\000\153\000a\000\000\000a\000\000\000a\000a\000a\000\000\000a\000\000\000\000\000\000\000\000\000\000\000\000\000a\000\000\000a\000\000\000\000\000\000\000a\000a\000\000\000a\000a\000\000\000a\000a\000\000\000a\000a\000a\000\000\000a\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\000\000\000a\000a\000a\000a\000\000\000a\000a\000\000\000a\000a\000\000\000\000\000a\000a\000a\000a\0016\000a\000a\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000a\000a\000\000\000\000\000\000\000a\000a\000\141\000\000\000\141\000\000\001\022\001.\000\141\000\000\000\141\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\000\000\141\000\000\000\000\000\000\000\141\000\141\000\000\000\141\000\141\000\000\001z\000\141\000\000\001\130\000\141\000\141\000\000\000\141\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\001\138\000\141\000\141\000\000\000\141\000\141\000\000\000\141\000\141\000\000\000\000\000\141\000\141\000\141\000\141\0016\000\141\001\146\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\141\000\141\000\000\000\000\000\000\000\141\000\141\000\129\000\000\000\129\000\000\001\022\001.\000\129\000\000\000\129\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\000\000\129\000\000\000\000\000\000\000\129\000\129\000\000\000\129\000\129\000\000\001z\000\129\000\000\001\130\000\129\000\129\000\000\000\129\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\001\138\000\129\000\129\000\000\000\129\000\129\000\000\000\129\000\129\000\000\000\000\000\129\000\129\000\129\000\129\0016\000\129\001\146\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\129\000\129\000\000\000\000\000\000\000\129\000\129\000e\000\000\000e\000\000\001\022\001.\000e\000\000\000e\000\000\000\000\000\000\000\000\000\000\000\000\000e\000\000\000e\000\000\000\000\000\000\000e\000e\000\000\000e\000e\000\000\001z\000e\000\000\001\130\000e\000e\000\000\000e\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\000\000\000e\001\138\000e\000e\000\000\000e\000e\000\000\000e\000e\000\000\000\000\000e\000e\000e\000e\0016\000e\001\146\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000e\000e\000\000\000\000\000\000\000e\000e\000U\000\000\000U\000\000\001\022\001.\000U\000\000\000U\000\000\000\000\000\000\000\000\000\000\000\000\000U\000\000\000U\000\000\000\000\000\000\000U\000U\000\000\000U\000U\000\000\001z\000U\000\000\001\130\000U\000U\000\000\000U\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\000\000\000U\001\138\000U\000U\000\000\000U\000U\000\000\000U\000U\000\000\000\000\000U\000U\000U\000U\0016\000U\001\146\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000U\000U\000\000\000\000\000\000\000U\000U\000u\000\000\000u\000\000\001\022\001.\000u\000\000\000u\000\000\000\000\000\000\000\000\000\000\000\000\000u\000\000\000u\000\000\000\000\000\000\000u\001r\000\000\001\154\000u\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000u\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000u\000\000\000\000\000\000\000u\001\138\001\242\001\250\000\000\000u\002\002\000\000\001\178\000u\000\000\000\000\000u\000u\000u\000u\0016\000u\001\146\000\000\000\000\000\000\000\000\000\000\000u\000u\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000u\002\014\000\000\000\000\000\000\001\186\000u\000i\000\000\000i\000\000\001\022\001.\000i\000\000\000i\000\000\000\000\000\000\000\000\000\000\000\000\000i\000\000\000i\000\000\000\000\000\000\000i\001r\000\000\001\154\000i\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000i\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000i\000\000\000\000\000\000\000i\001\138\001\242\001\250\000\000\000i\000i\000\000\001\178\000i\000\000\000\000\000i\000i\000i\000i\0016\000i\001\146\000\000\000\000\000\000\000\000\000\000\000i\000i\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000i\000i\000\000\000\000\000\000\001\186\000i\000m\000\000\000m\000\000\001\022\001.\000m\000\000\000m\000\000\000\000\000\000\000\000\000\000\000\000\000m\000\000\000m\000\000\000\000\000\000\000m\001r\000\000\001\154\000m\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000m\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000m\000\000\000\000\000\000\000m\001\138\001\242\001\250\000\000\000m\000m\000\000\001\178\000m\000\000\000\000\000m\000m\000m\000m\0016\000m\001\146\000\000\000\000\000\000\000\000\000\000\000m\000m\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000m\000m\000\000\000\000\000\000\001\186\000m\001i\000\000\001i\000\000\001\022\001.\001i\000\000\001i\000\000\000\000\000\000\000\000\000\000\000\000\001i\000\000\001i\000\000\000\000\000\000\001i\001r\000\000\001\154\001i\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\001i\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\001i\001\138\001\242\001\250\000\000\001i\002\002\000\000\001\178\001i\000\000\000\000\001i\001i\001i\001i\0016\001i\001\146\000\000\000\000\000\000\000\000\000\000\001i\001i\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000]\000\000\000]\000\000\001\022\001.\000]\000\000\000]\000\000\000\000\000\000\000\000\000\000\000\000\000]\000\000\000]\000\000\000\000\000\000\000]\001r\000\000\001\154\000]\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000]\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000]\000\000\000\000\000\000\000]\001\138\001\242\001\250\000\000\000]\002\002\000\000\001\178\000]\000\000\000\000\000]\000]\000]\000]\0016\000]\001\146\000\000\000\000\000\000\000\000\000\000\000]\000]\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000]\002\014\000\000\000\000\000\000\001\186\000]\000Y\000\000\000Y\000\000\001\022\001.\000Y\000\000\000Y\000\000\000\000\000\000\000\000\000\000\000\000\000Y\000\000\000Y\000\000\000\000\000\000\000Y\001r\000\000\001\154\000Y\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000Y\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\000Y\000\000\000\000\000\000\000Y\001\138\001\242\001\250\000\000\000Y\002\002\000\000\001\178\000Y\000\000\000\000\000Y\000Y\000Y\000Y\0016\000Y\001\146\000\000\000\000\000\000\000\000\000\000\000Y\000Y\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000Y\002\014\000\000\000\000\000\000\001\186\000Y\000M\000\000\000M\000\000\001\022\001.\000M\000\000\000M\000\000\000\000\000\000\000\000\000\000\000\000\000M\000\000\000M\000\000\000\000\000\000\000M\000M\000\000\000M\000M\000\000\001z\000M\000\000\001\130\000M\000M\000\000\000M\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\000\000\000M\001\138\000M\000M\000\000\000M\000M\000\000\000M\000M\000\000\000\000\000M\000M\000M\000M\0016\000M\001\146\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000M\000M\000\000\000\000\000\000\000M\000M\000I\000\000\000I\000\000\000I\000I\000I\000\000\000I\000\000\000\000\000\000\000\000\000\000\000\000\000I\000\000\000I\000\000\000\000\000\000\000I\000I\000\000\000I\000I\000\000\000I\000I\000\000\000I\000I\000I\000\000\000I\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000\000\000I\000I\000I\000I\000\000\000I\000I\000\000\000I\000I\000\000\000\000\000I\000I\000I\000I\0016\000I\000I\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000I\000\000\000\000\000\000\000\000\000\000\000I\000I\000\000\000\000\000\000\000I\000I\000\173\000\000\000\173\000\000\001\022\001.\000\173\000\000\000\173\000\000\000\000\000\000\000\000\000\000\000\000\000\173\000\000\000\173\000\000\000\000\000\000\000\173\001r\000\000\001\154\000\173\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\173\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\173\001\138\001\242\001\250\000\000\000\173\002\002\000\000\001\178\000\173\000\000\000\000\000\173\000\173\000\173\000\173\0016\000\173\001\146\000\000\000\000\000\000\000\000\000\000\000\173\002*\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000Q\000\000\000Q\000\000\000Q\000Q\000Q\000\000\000Q\000\000\000\000\000\000\000\000\000\000\000\000\000Q\000\000\000Q\000\000\000\000\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000Q\000\000\000Q\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\000\000\000\000Q\000Q\000Q\000Q\000\000\000Q\000Q\000\000\000Q\000Q\000\000\000\000\000Q\000Q\000Q\000Q\0016\000Q\000Q\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\000\000Q\000\000\000\000\000\000\000\000\000\000\000Q\000Q\000\000\000\018\000\000\000Q\000Q\000y\000\000\000y\000\000\001\022\001.\000y\007\026\000y\000\000\000\000\000\000\000\000\000\234\023.\000y\005!\000y\000\238\000\000\000\000\000y\001r\000\000\001\154\000y\000\000\001z\001\162\000\000\001\130\000\000\000\250\000\000\000y\003\186\001\030\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000y\000\000\000\000\001\002\000y\001\138\000\000\000\000\000\000\000y\000y\000\000\001\178\000y\000\000\000\000\000y\000y\000y\000y\0016\000y\001\146\000\000\000\000\000\000\000\000\000\000\000y\000y\000\000\000\000\001Z\001\006\000\000\001\n\003\178\000\000\000y\000y\000\000\003\182\000\000\001\186\000y\000\161\000\000\000\161\000\000\001\022\001.\000\161\000\000\000\161\000\000\000\000\000\000\000\000\000\000\000\000\000\161\007\246\000\161\000\000\000\000\000\000\000\161\001r\007\250\001\154\000\161\000\000\001z\001\162\000\000\001\130\000\000\007\238\000\000\000\161\000\000\001\030\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\161\000\000\000\000\000\000\000\161\001\138\000\000\000\000\b\n\000\161\000\161\000\000\001\178\000\161\000\000\000\000\000\161\000\161\000\161\000\161\0016\000\161\001\146\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\161\000\161\000\000\000\018\000\000\001\186\000\161\000q\000\000\000q\000\000\001\022\001.\000q\007*\000q\000\000\000\000\000\000\000\000\000\234\0246\000q\000\000\000q\000\238\000\000\000\000\000q\001r\000\000\001\154\000q\000\000\001z\001\162\000\000\001\130\000\000\000\250\000\000\000q\000\000\001\030\000\000\000\000\000\000\000\254\000\000\000\000\000\000\000q\000\000\000\000\001\002\000q\001\138\000\000\000\000\000\000\000q\000q\000\000\001\178\000q\000\000\000\000\000q\000q\000q\000q\0016\000q\001\146\000\000\000\000\000\000\000\000\000\000\000q\000q\000\000\000\000\001Z\001\006\000\000\001\n\003\178\000\000\000q\000q\000\000\003\182\000\000\001\186\000q\000\165\000\000\000\165\000\000\001\022\001.\000\165\000\000\000\165\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\165\000\000\000\000\000\000\000\165\001r\000\000\001\154\000\165\000\000\001z\001\162\000\000\001\130\000\000\000\000\000\000\000\165\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\165\000\000\000\000\000\000\000\165\001\138\000\000\000\000\000\000\000\165\000\165\000\000\001\178\000\165\001\177\000\000\000\165\000\165\000\165\000\165\0016\000\165\001\146\000\000\000\000\000\000\000\000\000\000\000\165\000\165\000\000\000\000\001Z\000\000\000\000\000\000\000\000\000\000\000\165\000\165\001\177\001\177\000\000\001\186\000\165\001\177\000\000\001\177\001\177\001\177\001\177\000\000\001\177\000\000\000\000\001\177\000\000\001\177\001\177\000\000\001\177\001\177\001\177\001\177\000\000\001\177\000\000\000\000\000\000\000\000\001\177\000\000\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\177\000\000\000\000\000\000\000\000\001\177\000\000\000\000\001\177\000\000\000\000\000\000\001\177\001\177\000\000\000\000\000\000\001\177\000\000\001\177\001\177\000\006\001\177\001\177\001\177\000\000\000\000\000\000\004!\000\006\001\177\001\177\004!\000\000\001\177\001\177\000\000\000\000\000\000\000\000\001\177\001\177\001\177\001\177\001\177\001\177\000\000\001\177\000\000\000\000\001\177\000\000\001\177\001\177\000\000\000\000\000\000\001\177\001\177\004!\000\000\004!\004!\004!\004!\004!\004!\000\000\004!\000\000\004!\000\000\004!\000\000\004!\004!\004!\004!\004!\004!\000\000\004!\000\000\004!\004!\000\000\000\000\000\000\004!\000\000\000\000\000\000\000\000\004!\000\000\000\000\000\000\004!\004!\000\000\000\000\004!\004!\000\000\000\000\004!\004!\018\178\000\000\000\000\004!\0156\004!\004!\004!\004!\004!\004!\004!\000\000\004!\004!\004!\004!\000\000\018\162\004!\000\000\004!\018\162\004!\004!\004!\004!\004!\004!\004!\004!\004!\004!\004!\000\000\000\000\004!\004!\004!\004!\004!\000\000\004!\004!\004!\000\000\000\000\004!\004!\000\000\004!\000\000\000\000\000\000\000\000\004!\031\194\000\000\000\000\004!\000\000\004!\004!\000\000\000\000\000\000\004!\000\000\000\000\000\000\000\000\000\000\004!\000\000\018\162\004!\002\162\000\000\000\000\000\000\000\000\000\000\004!\004!\004!\ni\ni\000\000\000\000\004!\000\000\000\000\004!\000\000\004!\004!\ni\000\000\000\000\004!\004!\000\000\ni\ni\000\000\ni\000\000\000\000\ni\ni\000\000\ni\ni\000\000\002\166\000\000\000\000\ni\000\000\000\000\000\000\000\000\000\000\000\000\ni\ni\002\182\000\000\000\000\ni\ni\ni\ni\000\000\000\000\ni\000\000\ni\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ni\0036\ni\000\000\000\000\000\000\000\000\000\000\ni\ni\nm\nm\ni\000\000\000\000\000\000\000\000\000\000\ni\ni\000\000\nm\000\000\ni\ni\000\000\000\000\nm\nm\000\000\nm\000\000\000\000\nm\nm\000\000\nm\nm\000\000\003:\000\000\000\018\nm\000\000\000\000\000\000\000\000\000\000\000\000\nm\nm\003J\0076\000\000\nm\nm\nm\nm\000\234\0256\nm\000\000\nm\000\238\007B\000\000\000\000\000\000\000\000\000\000\nm\000\000\nm\000\000\000\000\000\000\000\000\000\250\nm\nm\000\000\000\000\nm\000\000\000\000\000\254\000\000\000\000\nm\nm\000\000\000\000\001\002\nm\nm\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\001\006\000\000\001\n\003\178\000\000\022\026\000\000\007\238\003\182\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\0152\000\000\000\254\000\000\019\002\000\000\000\000\000\000\000\000\001\002\007\221\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\022\198\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\019\n\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\016B\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\007\241\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\023\222\000\000\007\238\011\189\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\011\189\bb\011\189\000\000\000\000\bv\011\189\015&\b\130\000\000\000\000\000\250\015:\011\189\000\000\000\000\007B\018\174\000\000\000\254\000\000\019^\000\000\000\000\000\000\000\000\001\002\b=\b\150\b\162\b\170\000\000\005\170\000\000\000\000\015b\000\000\000\000\b\206\011\189\b\226\t\002\011\189\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\011\189\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\024\222\000\000\007\238\000\000\011\189\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\019f\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\019\006\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\bQ\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\028&\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\019b\000\000\000\254\000\000\019\214\000\000\000\000\000\000\000\000\001\002\007\245\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\028b\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\019\222\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\019\218\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\b\t\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\029\134\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\020B\000\000\000\254\000\000\020>\000\000\000\000\000\000\000\000\001\002\b\r\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\000\018\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\ti\000\000\007\238\000\000\000\000\000\000\000\234\007\242\000\000\000\000\b\006\000\238\000\000\000\000\000\000\bb\020F\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\250\015:\000\000\000\000\000\000\007B\020\162\000\000\000\254\000\000\000\000\000\000\000\000\000\000\000\000\001\002\b!\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\001\006\000\000\001\n\003\178\007\154\000\000\007\166\015\026\003\182\007\174\000\000\007\190\b\174\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\n\226\007\242\000\000\000\000\b\006\011\014\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\011B\015:\000\000\000\000\000\000\007B\021z\000\000\011\146\000\000\020\158\000\000\000\000\000\000\000\000\011\190\b%\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\011\250\000\000\012&\012\146\007\154\000\000\007\166\015\026\012\190\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\020\166\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\031*\031z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b9\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb \178\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031*\031\190\004A\000\000\000\000 \170\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb!\014\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031* \174\004A\000\000\000\000!\006\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb!\134\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031*!\n\004A\000\000\000\000!~\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb!\238\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\031*!\130\004A\000\000\000\000!\230\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000\000\000\000\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\031N\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\031\142\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\"N\000\000\000\000\bv\000\000\031\178\b\130\000\000\000\000\000\000\031\210\000\000\000\000\000\000\000\000!\234\004A\000\000\000\000\"F\000R\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\000%\000%\000\000\000\000 \002\000\000\000\000\b\206\000\000\b\226\t\002\000\226\000\000\000R\t\022\t\"\000\000\000\000\000%\000\000\000%\000\000\000%\000%\000%\000\000\000%\000%\000%\000V\000\000\000\000\000%\003\170\000\000\000R\000\000\000\000\000\000\000%\000%\003\214\000%\000\000\000%\000%\000%\000%\000%\000%\000%\000V\000%\000\000\000%\003\202\000\000\000\000\000\000\000%\000%\000%\000%\003\214\000%\000\000\000\000\000%\000%\000%\000%\000%\000%\000V\000%\000\000\000%\000\000\000%\000%\000\000\000%\000%\000%\000%\003\214\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000%\000%\000\000\000%\000%\000%\000%\000\000\000\000\000\142\000\000\000\000\000\000\000%\000\000\000\000\000%\000\000\000)\000)\000\000\000\000\000%\000%\000\000\000\000\000\000\000%\000%\003\226\000\000\000\142\000\000\000\000\000\000\000\000\000)\000\000\000)\000\000\000)\000)\000)\000\000\000)\000)\000)\000\146\000\000\000\000\000)\004\"\000\000\000\142\000\000\000\000\000\000\000)\000)\003\238\000)\000\000\000)\000)\000)\000)\000)\000)\000)\000\146\000)\000\000\000)\005\230\000\000\000\000\000\000\000)\000)\000)\000)\003\238\000)\000\000\000\000\000)\000)\000)\000)\000)\000)\000\146\000)\000\000\000)\000\000\000)\000)\000\000\000)\000)\000)\000)\003\238\000\000\000\000\000\000\000)\000)\000)\000\000\000\000\000)\000\000\000)\000\000\000\000\000\000\000)\000)\000\000\000)\000)\000)\000)\000\000\000\000\000R\000\000\000\000\000\000\000)\000\000\000\000\000)\000\000\000%\000%\000\000\000\000\000)\000)\000\000\000\000\000\000\000)\000)\t6\000\000\000\000\000\000\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000V\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\003\214\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\142\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000)\000)\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\t\142\000\000\000%\000%\000\000\000\000\000\000\000)\000\000\000)\000\000\000\000\000)\000)\000\000\000)\000)\000)\000\146\000\000\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\003\238\000\000\000\000\000\000\000)\000)\000)\000\000\000\000\000)\000\000\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\000R\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000%\000%\000)\000\000\000\000\000\000\000\000\000\000\000)\000)\000\000\012\210\000\000\000)\000)\000\000\000\000\000\000\000%\000\000\000%\000\000\000\000\000%\000%\000\000\000%\000%\000%\000V\000\000\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\003\214\000\000\000\000\000\000\000%\000%\000%\000\000\000\000\000%\000\000\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000%\000\142\000%\000\000\000\000\000\000\000\000\000\000\000\000\000%\000)\000)\000%\000\000\000\000\000\000\000\000\000\000\000%\000%\000\000\r\n\000\000\000%\000%\000\000\000\000\000\000\000)\000\000\000)\000\000\000\000\000)\000)\000\000\000)\000)\000)\000\146\000\000\000\018\000)\000\000\000\000\000\000\000\000\000\000\000\000\000)\000)\003\238\000\000\000\000\000\000\000)\000)\000)\000\234\027:\000)\000\000\000)\000\238\007B\000\000\000\000\000\000\000\000\000)\000)\000\000\000)\000\000\000\000\000\000\000\000\000\250\000\000\000)\000\000\000\000\000)\000\000\000\000\000\254\000\000\000\000\000)\000)\000\000\000\000\001\002\000)\000)\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\001\006\000\000\001\n\003\178\000\000\000\000\000\000\007\238\003\182\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\"J\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\209\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\213\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\217\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bY\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\ba\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b]\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bi\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\be\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\225\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\229\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\233\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\237\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bA\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bE\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bI\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bM\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\249\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\253\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\001\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\005\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\017\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\021\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\025\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\029\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b)\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b-\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b1\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b5\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bU\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bu\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\by\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\129\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\145\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\133\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\137\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\141\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b}\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\007B\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bq\b\150\b\162\b\170\000\000\000\000\000\000\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\000\000\000\000\t\022\t\"\007^\000\000\007f\007n\000\000\015\014\000\000\007\142\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\166\015\026\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\015&\b\130\000\000\000\000\000\000\015:\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\bm\b\150\b\162\b\170\001n\011\133\011\133\000\000\015b\000\000\000\000\b\206\000\000\b\226\t\002\000\000\011\133\000\000\t\022\t\"\000\000\000\000\011\133\011\133\000\000\011\133\000\000\000\000\011\133\011\133\000\000\011\133\011\133\000\000\000\000\000\000\000\000\011\133\000\000\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\000\000\000\000\011\133\011\133\011\133\011\133\000\000\000\000\011\133\000\000\011\133\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\133\000\000\011\133\000\000\000\000\000\000\000\000\000\000\011\133\011\133\nq\nq\011\133\000\000\000\000\000\000\000\000\000\000\011\133\011\133\000\000\nq\000\000\011\133\011\133\000\000\000\000\nq\nq\000\000\nq\000\000\000\000\nq\nq\000\000\nq\nq\000\000\002b\000\000\000\000\nq\000\000\000\000\000\000\000\000\000\000\000\000\nq\nq\000\000\000\000\000\000\nq\nq\nq\nq\000\000\000\000\nq\000\000\nq\000\000\000\000\000\000\000\000\000\000\000\000\000\000\nq\000\000\nq\000\000\000\000\000\000\000\000\000\000\nq\nq\000\000\000\000\nq\002\142\011M\011M\000\000\000\000\nq\nq\000\000\000\000\000\000\nq\nq\011M\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\011M\000\000\000\000\011M\011M\000\000\011M\011M\000\000\000\000\000\000\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\011M\011M\011M\000\000\000\000\011M\000\000\011M\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011M\000\000\011M\000\000\000\000\000\000\000\000\000\000\011M\011M\000\000\000\000\011M\002\186\011e\011e\000\000\000\000\011M\011M\000\000\000\000\000\000\011M\011M\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\011e\000\000\000\000\011e\011e\000\000\011e\011e\000\000\000\000\000\000\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011e\011e\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011e\000\000\011e\000\000\000\000\000\000\000\000\000\000\011e\011e\000\000\000\000\011e\002\254\011E\011E\000\000\000\000\011e\011e\000\000\000\000\000\000\011e\011e\011E\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\011E\000\000\000\000\011E\011E\000\000\011E\011E\000\000\000\000\000\000\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\011E\011E\000\000\000\000\000\000\011E\011E\011E\011E\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011E\000\000\011E\000\000\000\000\000\000\015J\000\000\011E\011E\001\022\001.\011E\000\000\005\166\000\000\000\000\000\000\011E\011E\000\000\n\233\000\000\011E\011E\000\000\000\000\n\233\001r\000\000\001\154\015j\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\007J\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\n\233\001\138\001\242\001\250\000\000\017~\002\002\000\000\001\178\015Z\000\000\000\000\003\018\004\025\018b\003\250\0016\021\242\001\146\000\000\000\000\000\000\000\000\000\000\n\233\002*\000\000\000\000\001Z\003N\011]\011]\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\011]\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\011]\000\000\000\000\011]\011]\000\000\011]\011]\000\000\000\000\000\000\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\011]\011]\011]\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011]\000\000\011]\000\000\000\000\000\000\000\000\000\000\011]\011]\000\000\000\000\011]\003b\011U\011U\000\000\000\000\011]\011]\000\000\000\000\000\000\011]\011]\011U\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\011U\000\000\000\000\011U\011U\000\000\011U\011U\000\000\000\000\000\000\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\000\000\011U\011U\011U\011U\000\000\000\000\011U\000\000\011U\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011U\000\000\011U\000\000\000\000\000\000\000\000\000\000\011U\011U\000\000\000\000\011U\003\142\011m\011m\000\000\000\000\011U\011U\000\000\000\000\000\000\011U\011U\011m\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\011m\000\000\000\000\011m\011m\000\000\011m\011m\000\000\000\000\000\000\000\000\011m\000\000\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\011m\011m\011m\000\000\000\000\011m\000\000\011m\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011m\000\000\011m\000\000\000\000\000\000\000\000\000\000\011m\011m\000\000\000\000\011m\004\026\011\149\011\149\000\000\000\000\011m\011m\000\000\000\000\000\000\011m\011m\011\149\000\000\000\000\000\000\000\000\000\000\011\149\011\149\000\000\011\149\000\000\000\000\011\149\011\149\000\000\011\149\011\149\000\000\000\000\000\000\000\000\011\149\000\000\000\000\000\000\000\000\000\000\000\000\011\149\011\149\000\000\000\000\000\000\011\149\011\149\011\149\011\149\000\000\000\000\011\149\000\000\011\149\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\149\000\000\011\149\000\000\000\000\000\000\000\000\000\000\011\149\011\149\000\000\000\000\011\149\0046\011\141\011\141\000\000\000\000\011\149\011\149\000\000\000\000\000\000\011\149\011\149\011\141\000\000\000\000\000\000\000\000\000\000\011\141\011\141\000\000\011\141\000\000\000\000\011\141\011\141\000\000\011\141\011\141\000\000\000\000\000\000\000\000\011\141\000\000\000\000\000\000\000\000\000\000\000\000\011\141\011\141\000\000\000\000\000\000\011\141\011\141\011\141\011\141\000\000\000\000\011\141\000\000\011\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\141\000\000\011\141\000\000\000\000\000\000\000\000\000\000\011\141\011\141\000\000\000\000\011\141\004Z\011\157\011\157\000\000\000\000\011\141\011\141\000\000\000\000\000\000\011\141\011\141\011\157\000\000\000\000\000\000\000\000\000\000\011\157\011\157\000\000\011\157\000\000\000\000\011\157\011\157\000\000\011\157\011\157\000\000\000\000\000\000\000\000\011\157\000\000\000\000\000\000\000\000\000\000\000\000\011\157\011\157\000\000\000\000\000\000\011\157\011\157\011\157\011\157\000\000\000\000\011\157\000\000\011\157\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011\157\000\000\011\157\000\000\000\000\000\000\000\000\000\000\011\157\011\157\000\000\000\000\011\157\005\138\011}\011}\000\000\000\000\011\157\011\157\000\000\000\000\000\000\011\157\011\157\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\011}\000\000\000\000\011}\011}\000\000\011}\011}\000\000\000\000\000\000\000\000\011}\000\000\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011}\011}\000\000\000\000\011}\000\000\011}\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011}\000\000\011}\000\000\000\000\000\000\000\000\000\000\011}\011}\000\000\000\000\011}\005\146\011u\011u\000\000\000\000\011}\011}\000\000\000\000\000\000\011}\011}\011u\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\011u\000\000\000\000\011u\011u\000\000\011u\011u\000\000\000\000\000\000\000\000\011u\000\000\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\000\000\000\000\011u\011u\011u\011u\000\000\000\000\011u\000\000\011u\000\000\000\000\000\000\000\000\000\000\000\000\000\000\011u\000\000\011u\000\000\000\000\000\000\000\000\000\000\011u\011u\000\000\003\n\011u\001\022\001.\007\138\000\000\001b\011u\011u\000\000\000\000\000\000\011u\011u\000\000\t\129\000\000\000\000\000\000\000\000\001r\000\000\001\154 \n\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\015R\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\018N\000\000\000\000\000\000\000\000\000\000\002\026\0016\007R\001\146\000\000\000\000\000\000\031\226\000\000\002B\002*\001\022\001.\001Z\000\000\t\161\000\000\000\000\000\000\0022\002\014\000\000\t\161\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\018j\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\018\134\000\000\000\000\000\000\000\000 r\004>\0016\031:\001\146\000\000\000\000\000\000\000\000\000\000\002v\002*\n\141\n\141\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\n\141\000\000\001\186\002:\000\000\000\000\n\141\n\141\000\000\n\141\000\000\000\000\n\141\n\141\000\000\n\141\n\141\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\141\n\141\000\000\000\000\000\000\n\141\n\141\n\141\n\141\000\000\000\000\n\141\000\000\n\141\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\141\000\000\000\000\000\000\000\000\000\000\n\141\n\141\004n\004\150\n\141\000\000\000\000\000\000\000\000\000\000\n\141\n\141\000\000\n1\000\000\n\141\n\141\000\000\000\000\004\158\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\005\006\000\000\000\000\000\000\n1\004\190\005\014\n1\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\005F\005N\n\205\n\205\004\142\000\000\000\000\000\000\000\000\000\000\0056\005\"\000\000\n\205\000\000\004\238\005>\000\000\000\000\n\205\n\205\000\000\n\205\000\000\000\000\n\205\n\205\000\000\n\205\n\205\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\205\n\205\000\000\000\000\000\000\n\205\n\205\n\205\n\205\000\000\000\000\n\205\000\000\n\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\205\000\000\000\000\000\000\000\000\000\000\n\205\n\205\n\225\n\225\004\142\000\000\000\000\000\000\000\000\000\000\n\205\n\205\000\000\n\225\000\000\n\205\n\205\000\000\000\000\n\225\n\225\000\000\n\225\000\000\000\000\n\225\n\225\000\000\n\225\n\225\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\000\000\000\000\n\225\n\225\n\225\n\225\000\000\000\000\n\225\000\000\n\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\n\213\n\213\n\225\000\000\000\000\000\000\000\000\000\000\n\225\n\225\000\000\n\213\000\000\n\225\n\225\000\000\000\000\n\213\n\213\000\000\n\213\000\000\000\000\n\213\n\213\000\000\n\213\n\213\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\213\n\213\000\000\000\000\000\000\n\213\n\213\n\213\n\213\000\000\000\000\n\213\000\000\n\213\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\213\000\000\000\000\000\000\000\000\000\000\n\213\n\213\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\213\n\213\000\000\n\193\000\000\n\213\n\213\000\000\000\000\n\193\n\193\000\000\n\193\000\000\000\000\004\174\n\193\000\000\004\182\n\193\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\193\n\193\000\000\000\000\000\000\n\193\004\190\n\193\n\193\000\000\000\000\n\193\000\000\n\193\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\193\n\193\n\201\n\201\004\142\000\000\000\000\000\000\000\000\000\000\n\193\n\193\000\000\n\201\000\000\n\193\n\193\000\000\000\000\n\201\n\201\000\000\n\201\000\000\000\000\n\201\n\201\000\000\n\201\n\201\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\201\n\201\000\000\000\000\000\000\n\201\n\201\n\201\n\201\000\000\000\000\n\201\000\000\n\201\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\201\000\000\000\000\000\000\000\000\000\000\n\201\n\201\n\217\n\217\004\142\000\000\000\000\000\000\000\000\000\000\n\201\n\201\000\000\n\217\000\000\n\201\n\201\000\000\000\000\n\217\n\217\000\000\n\217\000\000\000\000\n\217\n\217\000\000\n\217\n\217\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\217\n\217\000\000\000\000\000\000\n\217\n\217\n\217\n\217\000\000\000\000\n\217\000\000\n\217\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\217\000\000\000\000\000\000\000\000\000\000\n\217\n\217\n\221\n\221\004\142\000\000\000\000\000\000\000\000\000\000\n\217\n\217\000\000\n\221\000\000\n\217\n\217\000\000\000\000\n\221\n\221\000\000\n\221\000\000\000\000\n\221\n\221\000\000\n\221\n\221\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\221\n\221\000\000\000\000\000\000\n\221\n\221\n\221\n\221\000\000\000\000\n\221\000\000\n\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\221\000\000\000\000\000\000\000\000\000\000\n\221\n\221\n\165\n\165\004\142\000\000\000\000\000\000\000\000\000\000\n\221\n\221\000\000\n\165\000\000\n\221\n\221\000\000\000\000\n\165\n\165\000\000\n\165\000\000\000\000\n\165\n\165\000\000\n\165\n\165\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\165\n\165\000\000\000\000\000\000\n\165\n\165\n\165\n\165\000\000\000\000\n\165\000\000\n\165\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\n\165\000\000\000\000\000\000\000\000\000\000\n\165\n\165\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\165\n\165\000\000\n\209\000\000\n\165\n\165\000\000\000\000\n\209\n\209\000\000\n\209\000\000\000\000\004\174\n\209\000\000\004\182\n\209\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\209\n\209\000\000\000\000\000\000\n\209\004\190\n\209\n\209\000\000\000\000\n\209\000\000\n\209\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\209\n\209\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\209\n\209\000\000\n\197\000\000\n\209\n\209\000\000\000\000\n\197\n\197\000\000\n\197\000\000\000\000\004\174\n\197\000\000\004\182\n\197\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\197\n\197\000\000\000\000\000\000\n\197\004\190\n\197\n\197\000\000\000\000\n\197\000\000\n\197\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\197\n\197\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\197\n\197\000\000\n\169\000\000\n\197\n\197\000\000\000\000\n\169\n\169\000\000\n\169\000\000\000\000\004\174\n\169\000\000\004\182\n\169\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\169\n\169\000\000\000\000\000\000\n\169\004\190\n\169\n\169\000\000\000\000\n\169\000\000\n\169\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\169\n\169\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\169\n\169\000\000\n\153\000\000\n\169\n\169\000\000\000\000\n\153\n\153\000\000\n\153\000\000\000\000\004\174\n\153\000\000\004\182\n\153\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\153\n\153\000\000\000\000\000\000\n\153\004\190\n\153\n\153\000\000\000\000\n\153\000\000\n\153\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\153\n\153\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\153\n\153\000\000\n\185\000\000\n\153\n\153\000\000\000\000\n\185\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\185\000\000\000\000\000\000\n\185\004\190\005\014\n\185\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\185\n\185\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\185\005\"\000\000\n\173\000\000\004\238\n\185\000\000\000\000\n\173\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\173\000\000\000\000\000\000\n\173\004\190\005\014\n\173\000\000\000\000\n\173\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\173\n\173\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\173\n\173\000\000\n\177\000\000\004\238\n\173\000\000\000\000\n\177\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\177\000\000\000\000\000\000\n\177\004\190\005\014\n\177\000\000\000\000\n\177\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\177\n\177\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\177\n\177\000\000\n\161\000\000\004\238\n\177\000\000\000\000\n\161\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\161\000\000\000\000\000\000\n\161\004\190\005\014\n\161\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\161\n\161\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\161\005\"\000\000\n\157\000\000\004\238\n\161\000\000\000\000\n\157\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\n\157\000\000\000\000\000\000\n\157\004\190\005\014\n\157\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\157\n\157\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\157\005\"\000\000\n\145\000\000\004\238\n\157\000\000\000\000\n\145\n\145\000\000\n\145\000\000\000\000\004\174\n\145\000\000\004\182\n\145\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\n\145\n\145\000\000\000\000\000\000\n\145\004\190\n\145\n\145\000\000\000\000\n\145\000\000\n\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\145\n\145\n\149\n\149\004\142\000\000\000\000\000\000\000\000\000\000\n\145\n\145\000\000\n\149\000\000\n\145\n\145\000\000\000\000\n\149\n\149\000\018\n\149\000\000\000\000\n\149\n\149\000\000\n\149\n\149\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\234\028\226\000\000\n\149\n\149\000\238\000\000\000\000\n\149\n\149\n\149\n\149\000\000\000\000\n\149\000\000\n\149\000\000\000\000\000\250\000\000\000\000\000\000\000\000\004v\000\000\n\149\000\254\000\000\000\000\000\000\000\000\n\149\n\149\001\002\000\000\n\149\t\229\000\000\t\229\t\229\000\000\n\149\n\149\t\229\000\000\000\000\n\149\n\149\000\000\t\229\000\000\t\229\000\000\000\000\t\229\000\000\t\229\000\000\000\000\000\000\000\000\t\229\000\000\001\006\000\000\001\n\003\178\000\000\000\000\000\000\t\229\003\182\000\000\000\000\000\000\t\229\000\000\000\000\t\229\000\000\000\000\000\000\000\000\t\229\000\000\000\000\000\000\t\229\000\000\t\229\t\229\000\000\000\000\000\000\000\000\t\229\000\000\000\000\000\000\t\229\000\000\000\000\000\000\000\000\000\000\000\000\t\241\000\000\t\241\t\241\t\229\t\229\t\229\t\241\015~\000\000\000\000\000\000\000\000\t\241\t\229\t\241\t\229\t\229\t\241\000\000\t\241\t\229\t\229\t\229\000\000\t\241\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\241\000\000\000\000\000\000\000\000\t\241\000\000\000\000\t\241\000\000\000\000\000\000\000\000\t\241\000\000\000\000\000\000\t\241\000\000\t\241\t\241\000\000\000\000\000\000\000\000\t\241\000\000\000\000\000\000\t\241\000\000\000\000\000\000\000\000\000\000\000\000\t\221\000\000\t\221\t\221\t\241\t\241\t\241\t\221\015\134\000\000\000\000\000\000\000\000\t\221\t\241\t\221\t\241\t\241\t\221\000\000\t\221\t\241\t\241\t\241\000\000\t\221\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\221\000\000\000\000\000\000\000\000\t\221\000\000\000\000\t\221\000\000\000\000\000\000\000\000\t\221\000\000\000\000\000\000\t\221\000\000\t\221\t\221\000\000\000\000\000\000\000\000\t\221\000\000\000\000\000\000\t\221\000\000\000\000\000\000\000\000\000\000\000\000\t\233\000\000\t\233\t\233\t\221\t\221\t\221\t\233\015\142\000\000\000\000\000\000\000\000\t\233\t\221\t\233\t\221\t\221\t\233\000\000\t\233\t\221\t\221\t\221\000\000\t\233\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\233\000\000\000\000\000\000\000\000\t\233\000\000\000\000\t\233\000\000\000\000\000\000\000\000\t\233\000\000\000\000\000\000\t\233\000\000\t\233\t\233\000\000\000\000\000\000\000\000\t\233\000\000\000\000\000\000\t\233\000\000\000\000\000\000\000\000\000\000\000\000\t\209\000\000\t\209\t\209\t\233\t\233\t\233\t\209\015\158\000\000\000\000\000\000\000\000\t\209\t\233\t\209\t\233\t\233\t\209\000\000\t\209\t\233\t\233\t\233\000\000\t\209\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\209\000\000\000\000\000\000\000\000\t\209\000\000\000\000\t\209\000\000\000\000\000\000\000\000\t\209\000\000\000\000\000\000\t\209\000\000\t\209\t\209\000\000\000\000\000\000\000\000\t\209\000\000\000\000\000\000\t\209\000\000\000\000\000\000\000\000\000\000\000\000\t\205\000\000\t\205\t\205\t\209\t\209\t\209\t\205\015\166\000\000\000\000\000\000\000\000\t\205\t\209\t\205\t\209\t\209\t\205\000\000\t\205\t\209\t\209\t\209\000\000\t\205\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\000\000\t\205\000\000\000\000\t\205\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\t\205\000\000\t\205\t\205\000\000\000\000\000\000\000\000\t\205\000\000\000\000\000\000\t\205\000\000\000\000\000\000\000\000\000\000\000\000\t\201\000\000\t\201\t\201\t\205\t\205\t\205\t\201\015\174\000\000\000\000\000\000\000\000\t\201\t\205\t\201\t\205\t\205\t\201\000\000\t\201\t\205\t\205\t\205\000\000\t\201\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\201\000\000\000\000\000\000\000\000\t\201\000\000\000\000\t\201\000\000\000\000\000\000\000\000\t\201\000\000\000\000\000\000\t\201\000\000\t\201\t\201\000\000\000\000\000\000\000\000\t\201\000\000\000\000\000\000\t\201\000\000\000\000\000\000\000\000\000\000\000\000\t\217\000\000\t\217\t\217\t\201\t\201\t\201\t\217\015\190\000\000\000\000\000\000\000\000\t\217\t\201\t\217\t\201\t\201\t\217\000\000\t\217\t\201\t\201\t\201\000\000\t\217\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\217\000\000\000\000\000\000\000\000\t\217\000\000\000\000\t\217\000\000\000\000\000\000\000\000\t\217\000\000\000\000\000\000\t\217\000\000\t\217\t\217\000\000\000\000\000\000\000\000\t\217\000\000\000\000\000\000\t\217\000\000\000\000\000\000\000\000\000\000\000\000\t\237\000\000\t\237\t\237\t\217\t\217\t\217\t\237\015\198\000\000\000\000\000\000\000\000\t\237\t\217\t\237\t\217\t\217\t\237\000\000\t\237\t\217\t\217\t\217\000\000\t\237\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\237\000\000\000\000\000\000\000\000\t\237\000\000\000\000\t\237\000\000\000\000\000\000\000\000\t\237\000\000\000\000\000\000\t\237\000\000\t\237\t\237\000\000\000\000\000\000\000\000\t\237\000\000\000\000\000\000\t\237\000\000\000\000\000\000\000\000\000\000\000\000\t\213\000\000\t\213\t\213\t\237\t\237\t\237\t\213\015\206\000\000\000\000\000\000\000\000\t\213\t\237\t\213\t\237\t\237\t\213\000\000\t\213\t\237\t\237\t\237\000\000\t\213\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\213\000\000\000\000\000\000\000\000\t\213\000\000\000\000\t\213\000\000\000\000\000\000\000\000\t\213\000\000\000\000\000\000\t\213\000\000\t\213\t\213\000\000\000\000\000\000\000\000\t\213\000\000\000\000\000\000\t\213\000\000\000\000\000\000\000\000\000\000\000\000\t\225\000\000\t\225\t\225\t\213\t\213\t\213\t\225\015\214\000\000\000\000\000\000\000\000\t\225\t\213\t\225\t\213\t\213\t\225\000\000\t\225\t\213\t\213\t\213\000\000\t\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\225\000\000\000\000\000\000\000\000\t\225\000\000\000\000\t\225\000\000\000\000\000\000\000\000\t\225\000\000\000\000\000\000\t\225\000\000\t\225\t\225\000\000\000\000\000\000\000\000\t\225\000\000\000\000\000\000\t\225\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\225\t\225\t\225\000\000\015\222\003\026\000\000\001\022\001.\021\026\t\225\003v\t\225\t\225\000\000\000\000\000\000\t\225\t\225\t\225\t\133\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\021&\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\018r\000\000\000\000\000\000\000\000\000\000\006\002\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\002\"\002*\001\022\001.\001Z\000\000\002\206\000\000\000\000\000\000\0022\002\014\000\000\022\162\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\0312\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\021Z\000\000\000\000\000\000\000\000\000\000\025\206\0016#&\001\146\000\000\000\000\000\000\000\000\000\000\002\210\002*\001\022\001.\001Z\000\000\006~\000\000\000\000\000\000\0022\002\014\000\000\025\250\000\000\001\186\002:\000\000\000\000\000\000\001r\000\018\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\031\234\000\000\001\030\000\000\000\000\000\000\000\234\029\222\000\000\001\202\001\234\000\238\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178 ^\000\000\000\250\000\000\000\000\000\000\026\n\0016\000\000\001\146\000\254\000\000\000\000\000\000\000\000\006\130\002*\001\002\000\000\001Z\007^\000\000\007f\007n\000\000\0022\002\014\007\142\000\000\000\000\001\186\002:\000\000\007\154\000\000\007\166\000\000\000\000\007\174\000\000\007\190\000\000\000\000\000\000\000\000\007\210\000\000\001\006\000\000\001\n\003\178\000\000\000\000\000\000\007\238\003\182\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006M\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006M\000\000\000\000\006M\006M\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006]\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006]\000\000\000\000\006]\006]\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005q\000\000\000\000\005q\005q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006y\000\000\000\000\006y\006y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006q\000\000\000\000\006q\006q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006=\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006=\000\000\000\000\006=\006=\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0065\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0065\000\000\000\000\0065\0065\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0059\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0059\000\000\000\000\0059\0059\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005Q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Q\000\000\000\000\005Q\005Q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0051\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0051\000\000\000\000\0051\0051\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006i\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006i\000\000\000\000\006i\006i\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005I\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005I\000\000\000\000\005I\005I\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006I\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006I\000\000\000\000\006I\006I\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006U\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006U\000\000\000\000\006U\006U\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\209\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\209\000\000\000\000\005\209\005\209\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005A\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005A\000\000\000\000\005A\005A\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005a\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005a\000\000\000\000\005a\005a\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005Y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005Y\000\000\000\000\005Y\005Y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006E\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006E\000\000\000\000\006E\006E\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\129\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\129\000\000\000\000\005\129\005\129\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005)\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005)\000\000\000\000\005)\005)\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005}\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005}\000\000\000\000\005}\005}\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\029\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\029\000\000\000\000\006\029\006\029\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005y\000\000\000\000\005y\005y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005u\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005u\000\000\000\000\005u\005u\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\025\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\025\000\000\000\000\006\025\006\025\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\137\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\137\000\000\000\000\005\137\005\137\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\133\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\133\000\000\000\000\005\133\005\133\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006!\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006!\000\000\000\000\006!\006!\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005U\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005U\000\000\000\000\005U\005U\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\t\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\t\000\000\000\000\006\t\006\t\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005i\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005i\000\000\000\000\005i\005i\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005e\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005e\000\000\000\000\005e\005e\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\017\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\017\000\000\000\000\006\017\006\017\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005]\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005]\000\000\000\000\005]\005]\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\r\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\r\000\000\000\000\006\r\006\r\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005=\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005=\000\000\000\000\005=\005=\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\253\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\253\000\000\000\000\005\253\005\253\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\205\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\205\000\000\000\000\005\205\005\205\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\153\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\153\000\000\000\000\005\153\005\153\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\149\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\149\000\000\000\000\005\149\005\149\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\177\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\177\000\000\000\000\005\177\005\177\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\173\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\173\000\000\000\000\005\173\005\173\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\241\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\241\000\000\000\000\005\241\005\241\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\145\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\145\000\000\000\000\005\145\005\145\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\141\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\141\000\000\000\000\005\141\005\141\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\169\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\169\000\000\000\000\005\169\005\169\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\165\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\165\000\000\000\000\005\165\005\165\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\237\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\237\000\000\000\000\005\237\005\237\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\161\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\161\000\000\000\000\005\161\005\161\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\157\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\157\000\000\000\000\005\157\005\157\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\193\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\193\000\000\000\000\005\193\005\193\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\201\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\201\000\000\000\000\005\201\005\201\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\197\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\197\000\000\000\000\005\197\005\197\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\189\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\189\000\000\000\000\005\189\005\189\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\185\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\185\000\000\000\000\005\185\005\185\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\181\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\181\000\000\000\000\005\181\005\181\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\225\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\225\000\000\000\000\005\225\005\225\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\221\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\221\000\000\000\000\005\221\005\221\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\217\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\217\000\000\000\000\005\217\005\217\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\213\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\213\000\000\000\000\005\213\005\213\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\233\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\233\000\000\000\000\005\233\005\233\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\229\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\229\000\000\000\000\005\229\005\229\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006-\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006-\000\000\000\000\006-\006-\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0061\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0061\000\000\000\000\0061\0061\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005E\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005E\000\000\000\000\005E\005E\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\001\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\001\000\000\000\000\006\001\006\001\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006e\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006e\000\000\000\000\006e\006e\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006Y\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Y\000\000\000\000\006Y\006Y\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005-\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005-\000\000\000\000\005-\005-\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\245\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\245\000\000\000\000\005\245\005\245\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006%\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006%\000\000\000\000\006%\006%\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006)\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006)\000\000\000\000\006)\006)\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005M\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005M\000\000\000\000\005M\005M\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\005\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\005\000\000\000\000\006\005\006\005\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0055\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0055\000\000\000\000\0055\0055\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005\249\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\249\000\000\000\000\005\249\005\249\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\0069\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0069\000\000\000\000\0069\0069\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006A\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006A\000\000\000\000\006A\006A\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006m\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006m\000\000\000\000\006m\006m\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006u\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006u\000\000\000\000\006u\006u\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\005m\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005m\000\000\000\000\005m\005m\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006\021\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\021\000\000\000\000\006\021\006\021\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006a\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006a\000\000\000\000\006a\006a\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\006Q\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006Q\000\000\000\000\006Q\006Q\000\000\000\000\007^\000\000\007f\007n\b\150\b\162\b\170\007\142\000\000\000\000\000\000\000\000\000\000\007\154\b\206\007\166\b\226\t\002\007\174\000\000\007\190\t\022\t\"\000\000\000\000\007\210\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\016\018\b\130\000\000\000\000\000\000\000\000\016\222\000\000\000\000\000\000\017^\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\b\150\b\162\b\170\001\022\001.\031\170\000\000\006*\000\000\000\000\b\206\000\000\b\226\t\002\026.\000\000\000\000\t\022\t\"\017v\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\"\182\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\031\242\000\000\000\000\000\000\000\000\000\000\026>\0016\000\000\001\146\000\000\000\000\006^\000\000\001\022\001.\002*\000\000\006\166\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000 z\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178 \150\000\000\000\000\000\000\000\000\000\000\t\210\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\015.\002*\001\022\001.\001Z\000\000\006\186\000\000\000\000\000\000\0022\002\014\000\000\004\002\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178 \130\000\000\000\000\000\000\000\000\000\000\rB\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\016\026\002*\001\022\001.\001Z\000\000\007z\000\000\000\000\000\000\0022\002\014\000\000\004F\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\004n\004\150\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\n9\000\000\001\186\002:\000\000\000\000\000\000\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\005\006\000\000\000\000\000\000\n9\004\190\005\014\n9\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\005.\004n\004\150\000\000\004\142\000\000\000\000\000\000\000\000\000\000\0056\005\"\n5\000\000\000\000\004\238\005>\000\000\000\000\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\004\222\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\004\246\005\006\000\000\000\000\000\000\n5\004\190\005\014\n5\000\000\000\000\005\022\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\016*\005V\001\022\001.\007\206\004\142\b\186\000\000\000\000\000\000\000\000\0056\005\"\006\n\000\000\000\000\004\238\005>\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\016b\001Z\001\022\001.\007\234\000\000\b\238\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\016\158\001Z\001\022\001.\br\000\000\0122\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\016\234\001Z\001\022\001.\b\146\000\000\014\166\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\0172\001Z\001\022\001.\b\158\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\017\138\001Z\001\022\001.\b\202\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\017\210\001Z\001\022\001.\b\222\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\018\n\001Z\001\022\001.\b\254\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\018\170\001Z\001\022\001.\t\018\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\018\210\001Z\001\022\001.\t\030\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019*\001Z\001\022\001.\tN\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019\134\001Z\001\022\001.\tb\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019\194\001Z\001\022\001.\tv\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\019\254\001Z\001\022\001.\t\166\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\020f\001Z\001\022\001.\t\186\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\020\198\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\t\218\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\021\166\001Z\001\022\001.\t\242\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\031\186\001Z\001\022\001.\n\006\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000 *\001Z\001\022\001.\n.\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000 \210\001Z\001\022\001.\n^\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000!.\001Z\001\022\001.\nr\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000!j\001Z\001\022\001.\n\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000!\166\001Z\001\022\001.\n\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\"\014\001Z\001\022\001.\n\218\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\"n\001Z\001\022\001.\n\242\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\"\226\001Z\001\022\001.\011\006\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011&\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011:\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\138\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\162\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\206\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\226\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\011\242\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\n\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\030\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012B\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012b\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012v\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\138\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\162\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\234\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\012\254\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r\"\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r6\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\rJ\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\rb\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\rv\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r\182\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\r\250\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014>\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014b\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\014\210\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\021.\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\022j\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\022\134\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\023\138\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\024\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\025\146\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\025\214\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\026\018\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\001\022\001.\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\026F\000\000\001\186\002:\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026n\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026\134\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026\170\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\026\194\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\000\000\000\000\001Z\001\022\001.\"\190\000\000\000\000\0022\002\014\000\000\000\000\000\000\001\186\002:\000\000\000\000\000\000\000\000\000\000\000\000\001r\000\000\001\154\000\000\000\000\001z\001\162\000\000\001\130\001\170\001\194\000\000\000\000\000\000\001\030\000\000\000\000\000\000\000\000\000\000\000\000\001\202\001\234\000\000\000\000\000\000\000\000\001\138\001\242\001\250\000\000\000\000\002\002\000\000\001\178\000\000\000\000\000\000\000\000\000\000\000\000\000\000\0016\000\000\001\146\000\000\000\000\000\000\000\000\000\000\000\000\002*\004n\004\150\001Z\000\000\000\000\000\000\000\000\000\000\0022\002\014\000\000\n\189\000\000\001\186\002:\000\000\000\000\n\189\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\000\000\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\189\000\000\000\000\000\000\n\189\004\190\000\000\n\189\000\000\000\000\n\189\000\000\004\230\000\000\000\000\000\000\000\000\000\000\000\000\000\000\004v\000\000\004\198\000\000\000\000\000\000\000\000\000\000\n\189\n\189\004n\004\150\004\142\000\000\000\000\000\000\000\000\000\000\n\189\n\189\000\000\n\181\000\000\004\238\n\189\000\000\000\000\n\181\004\166\000\000\004\206\000\000\000\000\004\174\004\214\000\000\004\182\000\000\000\000\000\000\000\000\000\000\004b\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n\181\000\000\000\000\000\000\n\181\004\190\007^\n\181\007f\007n\n\181\000\000\004\230\007\142\000\000\000\000\000\000\000\000\000\000\007\154\004v\007\166\004\198\000\000\007\174\000\000\007\190\000\000\n\181\n\181\000\000\007\210\004\142\000\000\000\000\000\000\000\000\000\000\n\181\n\181\007\238\000\000\000\000\004\238\n\181\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\016\226\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017\014\000\000\007^\000\000\007f\007n\000\000\000\000\000\000\007\142\000\000\b\150\b\162\b\170\000\000\007\154\000\000\007\166\000\000\000\000\007\174\b\206\007\190\b\226\t\002\000\000\000\000\007\210\t\022\t\"\000\000\000\000\000\000\000\000\000\000\000\000\007\238\000\000\000\000\000\000\000\000\007\242\000\000\000\000\b\006\000\000\000\000\000\000\000\000\bb\000\000\000\000\000\000\bv\000\000\017\130\b\130\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\017\174\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\b\150\b\162\b\170\000\000\000\000\000\"\000\000\000\000\007\170\000\000\b\206\000\000\b\226\t\002\000&\0002\0006\t\022\t\"\t\137\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\002\006\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000.\000\000\000\000\000\000\000&\0002\0006\001\214\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000Z\000\000\000\000\000\000\000&\0002\0006\000n\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\150\000\000\000\000\000\000\000&\0002\0006\002\226\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\001\"\000\000\000\000\000\000\000\000\000\000\002Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002^\002~\002\130\002\146\000\000\005\t\000\000\002\150\000\154\000\158\000\174\000\178\000\186\000\000\002\190\000\202\002\194\000\206\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\b\030\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\003R\003V\003f\003j\003\130\000\"\000\000\003\146\000\000\003\150\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\001\210\001\218\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\000\154\000\158\000\174\000\178\000\186\000\"\000\000\000\202\000\000\000\206\002f\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\000\000\000\000\000\000\000\000\000\000\000\000^\000\000\000b\002\018\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\002\170\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\003>\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\001\"\000\000\000\000\000\000\000\000\000\000\002Z\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002^\002~\002\130\004f\000\000\t]\000\000\002\150\000\154\000\158\000\174\000\178\000\186\000\000\002\190\000\202\002\194\000\206\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\003R\003V\003f\003j\003\130\002Z\000\000\003\146\000\000\003\150\000\000\000\000\000\000\000\000\002^\002~\002\130\b.\000\000\000\000\000\000\002\150\000\000\000\000\000\000\000\000\000\000\000\000\002\190\000\000\002\194\005\026\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\"\003R\003V\003f\003j\003\130\002Z\000\000\003\146\000\000\003\150\000\000\000\000\000\000\000\000\002^\002~\002\130\000\000\000\000\000\000\000\000\002\150\000\000\000\000\000\000\000\000\000\000\000\000\002\190\000\000\002\194\005&\000\000\000\000\000\000\002\198\000\000\000\000\002\222\000\000\000\000\000\000\002\238\002\242\000\000\000\000\000\000\000\000\000\000\003\002\0032\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\007\182\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\003R\003V\003f\003j\003\130\000\000\000^\003\146\000b\003\150\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\r\142\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\014\022\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000F\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\000\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\000\214\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\005\226\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\003\158\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\004\030\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\003\190\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\003\222\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\t*\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\000\000\000\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\t\138\000\000\000\000\000\000\000\000\000\000\000\026\000\000\000\000\000\000\000\000\000\000\000\"\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000&\0002\0006\000\000\000\000\000\000\000\000\012\198\000\154\000\158\000\174\000\178\000\186\000\000\000^\000\202\000b\000\206\000\000\000\000\000\000\000f\000\000\000\000\000j\000\000\000\018\006\190\000r\000v\000\000\000\000\000\000\000\000\000\000\000\134\r\006\000\000\000\000\000\000\000\000\006\214\000\000\000\234\000\000\000\000\000\000\000\000\007\n\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\007&\000\000\000\000\000\154\000\158\000\174\000\178\000\186\000\254\022\218\000\202\000\000\000\206\000\018\006\190\022\018\000\000\000\000\000\000\000\000\000\000\000\000\023\178\000\000\000\000\002%\022&\000\000\006\214\000\000\000\234\000\000\000\000\000\000\000\000\007\n\000\000\022V\022r\000\000\000\000\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\178\007&\000\000\000\000\000\000\022\142\000\018\006\190\000\000\000\254\023\022\000\000\000\000\000\000\000\000\024\186\022\018\000\000\000\000\000\000\000\000\006\214\000\000\000\234\000\000\000\000\002%\022&\007\n\000\000\000\018\006\190\000\000\000\000\000\000\000\000\000\000\000\000\022V\022r\000\000\000\000\007&\000\000\000\000\006\214\001\006\000\234\001\n\003\178\000\254\023B\007\n\000\000\022\142\000\000\000\000\022\018\000\000\000\000\000\000\000\018\006\190\000\000\000\000\000\000\007&\002%\022&\000\000\025\186\000\000\000\000\000\000\000\254\023n\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\023\242\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\024\030\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\024J\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\024v\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\024\242\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\025\030\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\025J\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\025v\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\026\246\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\027\"\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\027Z\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\027\178\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\027\226\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\028\158\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\028\202\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\029\002\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\029:\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\029j\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\029\154\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\029\198\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\018\006\190\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\006\214\000\000\000\234\022V\022r\000\254\029\254\007\n\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\018\006\190\000\000\022\142\000\000\007&\002%\022&\000\000\000\000\000\000\000\000\000\000\000\254\0306\006\214\000\000\000\234\022V\022r\022\018\000\000\007\n\000\000\000\000\000\000\001\006\000\000\001\n\003\178\002%\022&\000\000\000\000\022\142\000\000\007&\000\000\000\000\000\000\000\000\000\000\022V\022r\000\254\030\130\000\000\000\000\000\000\000\000\001\006\022\018\001\n\003\178\000\000\000\000\000\000\000\000\022\142\000\000\015z\002%\022&\000\000\000\000\000\000\000\000\000\000\000\000\015\130\015\138\000\000\000\000\022V\022r\000\000\015\146\000\000\000\000\000\000\000\000\001\006\000\000\001\n\003\178\015\162\015\170\000\000\000\000\022\142\000\000\000\000\000\000\000\000\000\000\015\178\000\000\015\194\000\000\000\000\000\000\000\000\000\000\000\000\000\000\015\202\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\015\210\000\000\015\218"))
  
  and lhs =
    (8, "\001\000!                                                                                        \031\031\031\031\030\030\030\030\030\030\030\030\030\030\030\030\030\029\029\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\028\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\027\026\026\025\025\025\025\025\025\024\024\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\023\022\022\021\021\021\021\020\020\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\019\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\018\017\017\017\016\016\016\015\015\015\014\r\r\r\r\r\r\r\r\012\012\011\011\n\n\t\t\b\b\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\007\006\006\006\006\005\005\005\005\005\005\004\004\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\003\002\002\002\002\002\002\002\002\002\002\002\002\002")
  
  and goto =
    ((16, "\000\026\000#\000\000\000T\000\000\000p\000\000\000\158\000\000\000\000\003,\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\003\208\000\000\000\220\001\n\0018\0046\000\000\000\000\000\000\000\000\000\000\000\000\001\132\000\000\000\000\005\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\194\000\000\000\000\000\000\000\000\002L\000\000\002\168\000\000\000\000\000\000\000\000\003\018\000\000\000\000\000\000\000\000\0038\000\000\000\000\000\000\000\000\003\030\000\000\003X\000\000\000Z\000\000\003\130\000\000\003\146\000\000\000\000\003\236\000\000\000\000\004\026\000\000\000\000\000\000\000\000\003\244\000\000\000\000\000\000\000\000\000\000\004@\000\000\004f\000\000\004\150\000\000\004\170\000\000\004\186\000\000\004\202\000\000\004\250\000\000\005\200\000\000\005\202\000\000\0062\000\000\t\004\000\000\000\000\000\017\001\n\000t\000\000\000x\000\000\000\000\tx\000\000\t\130\000\000\t\136\000\000\t\138\000\000\000\000\t\140\000\000\000\000\t\142\000\000\000\162\000\000\t\144\000\000\t\146\000\000\t\148\000\000\000\166\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\b\000\000\000\000\000\000\000\000\005\014\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\016\000\000\000\000\000\000\000\000\000\000\t\208\t\210\t\154\000\000\000\000\005\018\000\000\000\000\005\020\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\156\000\000\t\158\t\172\t\162\000\000\t\164\t\178\000\000\000\000\t\168\000\000\000\000\000\000\005\024\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\170\000\000\000\000\000\000\000\007\000\000\000\000\000\000\000\000\t\230\000\000\t\174\000\000\000\000\000\000\000\000\t\236\000\000\000\000\t\178\000\000\000\000\000\000\000\000\t\240\000\000\000\000\000\000\000\000\000\000\t\242\000\000\000\000\000\000\000\000\t\184\000\000\000\000\t\246\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\248\000\000\000\000\000\000\000\000\000\000\t\190\000\000\000\000\t\252\000\000\000\000\000\000\000\000\000\000\000|\000\000\000\000\t\252\000\000\000\000\t\240\000\000\000\000\000\000\000\000\n\000\000\000\n\002\000\000\n\004\000\000\n\006\000\000\n\b\000\000\n\n\000\000\n\012\000\000\n\014\000\000\n\016\000\000\n\018\000\000\n\020\000\000\n\022\000\000\n\024\000\000\000\000\000\208\000\000\000\000\n\026\000\000\n\028\000\000\n\030\000\000\000\000\n \000\000\000\000\001\014\000\000\n\"\000\000\n$\000\000\0014\000\000\n&\000\000\001<\000\000\000\000\000\000\000\000\000\000\000\016\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\005\000\000\000\000\000\000\001d\000\000\001l\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\n*\000\000\000\000\000\000\000\000\000\000\t\240\000\000\000\000\n.\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\t\244\n\002\000\000\t\248\000\000\000\000\000\000\000\000\000\000\005\028\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\001\146\000\000\000\000\000\000\000\000\003\136\000\000\000\000\004\016\000\000\000\000\000\000\000\000\001\150\000\000\000\000\000\000\004\134\000\000\000\000\001\154\0038\000\000\000\000\0054\000\000\000\000\000\005\t\250\000\000\t\252\000\000\000\000\000\000\000\022\000\000\005\016\000\000\005\026\000\000\t\254\000\000\n,\000\000\n\002\000\000\005\030\000\000\000\000\0058\000\000\000\000\005:\n\004\005<\000\000\005$\000\000\005@\n2\000\000\n\b\000\000\005B\000\000\000\000\n6\000\000\n\012\000\000\005D\000\000\004\138\000\000\000\000\000\000\000\000\004\170\000\000\000\000\000\000\000\000\001\156\000\000\000\000\000\000\001\236\000\000\000\000\000\000\000\000\n:\000\000\000\000\000\000\000\000\004\186\000\000\000\000\000\000\n<\000\000\n\018\000\000\005F\000\000\000\000\005H\n@\000\000\n\022\000\000\005J\n\024\000\000\005L\000\000\005T\000\000\000\000\n\026\000\000\000\000\000\000\n\028\000\000\005d\nJ\000\000\n \000\000\005f\000\000\n\"\000\000\nP\000\000\n&\000\000\005h\nT\000\000\n*\000\000\005l\n,\000\000\005n\000\000\n.\000\000\000\000\000\000\000\000\nl\n^\000\000\n4\000\000\005p\000\000\000\000\n6\000\000\005r\000\000\000\000\n8\000\000\005t\000\000\000\000\005v\000\000\000\000\000\000\nv\nh\000\000\n>\000\000\005x\000\000\000\000\n@\000\000\005\128\000\000\000\000\005\144\000\000\000\000\nB\000\000\000\000\n\128\nr\000\000\nH\000\000\005\146\000\000\000\000\nJ\000\000\005\148\000\000\000\000\005\152\000\000\000\000\000\000\000\000\nL\000\000\005\154\000\000\000\000\005\156\000\000\000\000\000\b\000\000\nz\000\000\nP\000\000\005\158\000\000\000\000\nR\000\000\005\160\000\000\000\000\005\162\000\000\000\000\nT\000\000\005\164\000\000\000\000\005\172\000\000\000\000\000\000\nV\000\000\005\188\000\000\000\000\005\190\000\000\000\000\000\000\nX\000\000\005\192\000\000\000\000\000\000\nZ\000\000\005\196\000\000\000\000\n\\\000\000\005\198\000\000\000\000\000\000\000\000\000\000\n^\000\000\005\200\000\000\000\000\n`\000\000\005\202\000\000\nd\000\000\000\000\nf\000\000\000\000\004\200\000\000\000\000\000\000\005\224\000\000\000\000\005\226\000\000\000\000\nf\000\000\005\208\000\000\000\000\000\000\nh\000\000\005\216\000\000\000\000\nj\000\000\005\232\000\000\000\000\000\000\nl\000\000\005\234\000\000\000\000\nn\000\000\005\236\000\000\np\000\000\005\240\000\000\000\000\000\000\nr\000\000\005\242\000\000\000\000\nt\000\000\005\244\000\000\000\000\nv\000\000\000\000\000\000\nx\000\000\005\246\000\000\000\n\000\000\000\000\000\000\nz\000\000\005\252\000\000\000\000\n|\000\000\006\004\000\000\000\000\n~\000\000\006\014\000\000\000\000\000\000\n\128\000\000\006\016\000\000\000\000\n\130\000\000\006\020\000\000\000\000\n\132\000\000\000\000\000\000\000\000\n\194\000\000\000\000\n\136\000\000\006\022\000\000\000\000\n\138\000\000\006\024\000\000\000\000\000\000\n\200\000\000\000\000\n\142\000\000\006\028\000\000\000\000\n\144\000\000\006\030\000\000\000\000\n\146\000\000\000\000\n\208\000\000\000\000\n\150\000\000\006 \000\000\000\000\n\152\000\000\006\"\000\000\000\000\000\000\000\000\0066\000\000\0060\000\000\000\000\000\000\006<\000\000\000\000\n\154\000\000\006>\000\000\000\000\006@\000\000\000\000\006B\000\000\000\000\000\000\000\000\006D\000\000\000\000\000\000\n\156\000\000\006H\000\000\000\000\006J\000\000\000\000\006H\000\000\006N\000\000\000\000\000\000\006\\\000\000\000\000\n\158\000\000\006f\000\000\000\000\006h\000\000\000\000\000\000\n\160\000\000\006j\000\000\000\000\006l\000\000\000\000\000\000\000\000\006n\000\000\000\000\000\000\006p\000\000\000\000\n\162\000\000\000\000\006t\000\000\000\000\006v\000\000\000\000\000\000\000\000\n\164\000\000\006x\000\000\000\000\006z\000\000\000\000\000\000\000\000\006\136\000\000\000\000\000\000\000\000\006\146\000\000\000\000\000\000\000\026\000\000\000\000\000\030\n\166\000\000\006\148\n\182\000\"\000\000\000\000\n\170\000\000\n\172\000\000\n\174\000\000\000\000\000&\n\176\000\000\000\000\000\000\n\186\n\230\000\000\n\232\000\000\n\234\000\000\n\236\000\000\000\000\000\000\n\238\000\000\n\240\000\000\n\242\001\186\000\000\000\000\n\244\000\000\n\246\000\000\n\248\000\000\n\250\000\000\n\252\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\006\150\n\204\000\000\006\152\n\222\n\208\000\000\006\154\n\226\000\000\000\000\n\220\006\156\n\222\000*\000\000\n\224\000\000\000\000\n\218\000\000\006\160\n\236\000\000\000D\000\000\006\162\000\000\000H\000\000\000L\000\000\000\000\000\000\n\222\000\000\006\164\n\240\000\000\n\234\000\000\006\166\000\000\n\236\000\000\n\238\000\000\000\000\006\180\000\000\n\240\000\000\006\190\n\234\000\000\006\192\n\252\000\000\n\246\000\000\006\194\000\000\n\248\000\000\n\250\000P\000\000\n\252\000\000\000\000\000\000\n\246\000\000\006\196\011\b\000\000\011\002\000\000\006\198\000\000\011\004\000\000\011\006\000\000\011\b\000T\000\000\011\n\000\000\000\000\011\004\000\000\006\200\011\006\000\000\006\204\011\024\000\000\011\018\000\000\006\206\000\000\011\020\000\000\011\022\000X\000\000\011\024\000\000\000\000\000\000\011\018\000\000\006\208\011$\000\000\011\030\000\000\006\210\000\000\011 \000\000\011\"\000\000\000\000\011\028\000\000\006\224\011.\000\000\011(\000\000\006\234\000\000\011*\000\000\011,\000\000\000\000\000r\000\000\000\000\000v\000\000\000\000\000z\000\000\000~\000\000\011&\000\000\011(\000\000\000\000\000\130\000\000\000\134\000\000\000\000\000\160\000\000\000\164\000\000\000\000\0118\011,\000\000\006\236\011<\000\168\000\000\011>\000\000\000\000\000\000\0112\000\000\006\238\011D\000\000\011D\000\000\006\240\000\000\011F\000\000\011H\000\000\000\172\006\242\000\176\000\180\000\000\000\206\000\000\000\000\000\000\011<\000\000\006\244\011N\000\000\000\210\000\000\006\248\000\000\000\214\000\000\000\218\000\000\000\000\000\222\006\250\000\226\000\252\000\000\001\000\000\000\000\000\000\000\011@\000\000\006\252\011R\000\000\001\004\000\000\006\254\000\000\001\b\000\000\001\012\000\000\000\000\011T\011F\000\000\007\012\011X\000\000\011X\001\016\007\022\001*\001.\000\000\0012\000\000\000\000\000\000\011L\000\000\007\024\011^\000\000\0016\000\000\007\026\000\000\001:\000\000\001>\000\000\000\000\007\028\000\000\011^\001X\007\030\001\\\001`\000\000\001d\000\000\000\000\000\000\011R\000\000\007 \011d\000\000\001h\000\000\007$\000\000\001l\000\000\001\134\000\000\000\000\011d\001\138\007&\001\142\001\146\000\000\001\150\000\000\000\000\000\000\011X\000\000\007(\011j\000\000\001\154\000\000\007*\000\000\001\180\000\000\001\184\000\000\000\000\000\000\0078\000\000\001\188\000\000\000\000\000\000\011\\\000\000\000\000\001\192\000\000\011^\000\000\000\000\001\196\000\000\000\000\000\000\000\000\000\000\000\000\011v\011b\000\000\011z\001\200\000\000\011|\000\000\000\000\000\000\007B\000\000\001\226\000\000\000\000\001\230\000\000\001\234\000\000\000\000\011h\000\000\007D\011z\000\000\000\000\001\238\000\000\007F\000\000\000\000\001\242\000\000\000\000\001\246\000\000\002\016\000\000\000\000\002\020\000\000\000\000\000\000\002\024\000\000\002\028\000\000\000\000\001\250\000\000\007n\000\000\000\000\002\028\000\000\000\000\000\000\000\000\011\142\000\000\011\144\000\000\000\000\000\000\000\000\002 \011\172\000\000\000\000\011r\000\000\000\000\002$\011\176\000\000\000\000\011v\000\000\000\000\002(\011\180\000\000\000\000\011z\000\000\000\000\000\000\002J\000\000\000\000\000\000\002x\000\000\007r\000\000\000\000\002\128\000\000\002\132\002 \000\000\002\166\000\000\000\000\000\000\000\000\007t\000\000\000\000\000\000\000\000\002\174\000\000\002\212\002$\000\000\002\220\000\000\000\000\007v\000\000\000\000\003\002\000\000\003\n\002>\000\000\0030\000\000\000\000\000\000\000\000\000\000\007j\000\000\007l\002B\000\000\007x\000\000\000\000\011|\000\000\000\000\007\130\000\000\000\000\000\000\007\138\000\000\002F\000\000\007\140\000\000\007\142\000\000\000\000\000\000\000\000\000\000\000\000\007\144\000\000\007\146\000\000\000\000\007\148\000\000\007\150\002J\000\000\007\152\000\000\000\000\000\000\000\000\000\000\007\154\000\000\007\160\002N\000\000\007\162\000\000\000\000\007\166\000\000\000\000\007\168\000\000\007\172\002R\000\000\007\174\000\000\000\000\000\000\000\000\000\000\007\176\000\000\007\178\002l\000\000\007\182\000\000\000\000\011~\000\000\000\000\007\186\000\000\000\000\000\000\007\196\000\000\002p\000\000\007\206\000\000\007\208\000\000\000\000\000\000\000\000\007\214\000\000\007\216\000\000\000\000\007\220\000\000\007\230\002t\000\000\007\238\000\000\000\000\000\000\000\000\000\000\007\240\000\000\007\242\002x\000\000\007\244\000\000\000\000\007\248\000\000\000\000\007\250\000\000\007\252\002|\000\000\007\254\000\000\000\000\000\000\000\000\000\000\b\004\000\000\b\006\002\128\000\000\b\012\000\000\000\000\011\128\000\000\000\000\b\016\000\000\000\000\000\000\b\018\000\000\002\154\000\000\b\020\000\000\b\022\000\000\000\000\000\000\011\130\000\000\000\000\000\000\b\026\000\000\000\000\000\000\000\000\011\132\000\000\000\000\000\000\b\028\000\000\011\134\000\000\000\000\000\000\b\030\000\000\000\000\011\136\000\000\000\000\000\000\b(\000\000\011\138\000\000\000\000\000\000\b*\000\000\000\000\000\000\000\000\000\000\011\140\000\000\000\000\b2\000\000\000\000\011\142\000\000\000\000\b4\000\000\000\000\000\000\000\000\000\000\011\144\000\000\000\000\b:\000\000\000\000\011\146\000\000\000\000\b<\000\000\000\000\000\000\011\182\000\000\000\000\000\000\b@\000\000\000\000\bJ\002\158\000\000\bR\000\000\000\000\000\000\000\000\000\000\bT\000\000\bV\002\162\000\000\bX\000\000\000\000\005:\000\000\011\210\000\000\000\000\000\000\b^\000\000\b`\002\166\000\000\bb\000\000\000\000\000\000\000\000\bh\000\000\000\000\000\000\bv\000\000\000\000\000\000\011\212\000\000\000\000\000\000\bj\000\000\bt\002\170\000\000\bx\000\000\000\000\011\214\000\000\000\000\000\000\bz\000\000\b\128\002\174\000\000\b\130\000\000\000\000\000\000\000\000\000\000\000\000\002\200\000\000\b\140\000\000\000\000\000\000\000\000\b\142\000\000\000\000\002\204\000\000\b\150\000\000\000\000\000\000\000\000\002\208\000\000\b\152\000\000\000\000\b\158\000\000\000\000\002\212\000\000\b\154\000\000\000\000\000\000\000\000\002\216\000\000\b\162\000\000\000\000\b\164\002\220\000\000\b\168\000\000\000\000\000\000\000\000\000\000\b\174\000\000\b\182\002\246\000\000\b\184\000\000\000\000\b\186\000\000\011\216\000\000\000\000\000\000\b\188\000\000\b\192\002\250\000\000\b\196\000\000\000\000\000\000\000\000\011\218\000\000\000\000\000\000\b\198\000\000\b\206\002\254\000\000\b\208\000\000\000\000\011\220\000\000\000\000\000\000\b\210\000\000\b\216\003\002\000\000\b\220\000\000\000\000\000\000\b\222\000\000\000\000\b\226\000\000\b\228\003\006\000\000\b\230\000\000\000\000\000\000\000\000\000\000\b\236\000\000\b\244\003\n\000\000\b\250\000\000\000\000\b\254\000\000\011\222\000\000\000\000\000\000\b\252\000\000\t\b\003$\000\000\t\012\000\000\000\000\000\000\000\000\011\224\000\000\000\000\000\000\t\016\000\000\t\018\003(\000\000\t\026\000\000\000\000\000\000\004D\000\000\000\000\000\000\t\028\000\000\011\226\000\000\000\000\000\000\t \000\000\t\"\003,\000\000\t$\000\000\000\000\000\000\000\000\t*\000\000\000\000\t4\000\000\000\000\000\000\t(\000\000\011\228\000\000\000\000\t0\000\000\000\000\000\000\t2\000\000\000\000\t<\000\000\000\000\t6\000\000\011\230\000\000\000\000\t8\000\000\000\000\000\000\000\000\000\210\000\000\003.\011\172\000\000\011\174\000\000\000\000\000\000\0032\000\000\0034\000\000\000\000\003N\000\000\000\000\000\000\000\000\000\000\011\198\000\000\t&\000\000\003R\000\000\000\000\003T\000\000\000\000\003X\000\000\000\000\011\178\000\000\000\000\003Z\011\180\000\000\t(\011\196\003`\000\000\011\198\003l\000\000\000\000\011\186\000\000\011\188\000\000\011\190\000\000\000\000\003z\000\000\003|\011\192\000\000\000\000\000\000\011\202\000\000\003~\000\000\011\196\000\000\t:\011\214\000\000\003\128\000\000\tD\000\000\003\152\000\000\003\154\000\000\000\000\000\000\000\000\003\142\000\000\003\158\000\000\011\200\000\000\011\202\000\000\000\000\003\170\000\000\003\178\000\000\000\000\003\184\000\000\003\188\000\000\tJ\003\190\003\204\000\000\003\208\000\000\000\000\000\000\011\204\000\000\tL\011\222\000\000\003\214\000\000\tN\000\000\003\220\000\000\003\224\000\000\000\000\003\240\tR\003\244\004\000\000\000\003\250\000\000\000\000\000\000\011\208\000\000\tT\011\226\000\000\004\004\000\000\tV\000\000\004\020\000\000\004\024\000\000\000\000\011\228\011\214\000\000\tX\011\232\000\000\011\232\004\030\t\\\004$\0042\000\000\0046\000\000\000\000\000\000\011\220\000\000\t^\011\238\000\000\0048\000\000\tf\000\000\004<\000\000\004B\000\000\000\000\tp\000\000\011\238\004T\tv\004V\004b\000\000\004f\000\000\000\000\000\000\011\226\000\000\tx\011\244\000\000\004h\000\000\tz\000\000\004r\000\000\004\130\000\000\000\000\011\244\004\132\t~\004\134\004\146\000\000\004\150\000\000\000\000\000\000\011\232\000\000\t\128\011\250\000\000\004\162\000\000\t\130\000\000\004\166\000\000\004\178\000\000\000\000\000\000\t\132\000\000\004\182\000\000\000\000\011\236\000\000\000\000\004\194\000\000\000\000\004\198\000\000\000\000\011\238\000\000\t\136\012\000\000\000\000\000\004\210\000\000\t\138\000\000\000\000\004\214\000\000\000\000\004\226\000\000\004\230\000\000\000\000\000\000\000\000\004\242\000\000\004\246\000\000\000\000\000\000"), (16, "\001\027\001\027\001Z\001Z\001\027\000\149\001Z\001\027\001\027\001Z\001Z\001\027\000\003\001Z\001^\001^\005\131\004\022\001^\001_\001l\001^\001^\001\142\000z\001]\002\147\003\020\002V\005z\004\022\005O\004\022\005C\004\022\004\167\004\022\004\145\004\022\004\019\004\022\002V\000\004\002V\005\172\002V\007\199\002V\001\027\002V\001h\002V\004\029\004\022\004!\004\022\004#\004\022\004F\004\022\004Z\004\022\004n\004\022\002V\001\027\002V\001X\002V\007\197\002V\000\147\002V\000y\002V\004\144\004\022\004\147\004\022\004\150\004\022\004\152\004\022\004\159\004\022\004\161\004\022\002V\001\174\002V\000z\002V\000z\002V\000\138\002V\000\146\002V\004\164\004\022\004\166\004\022\004\174\004\022\004\214\004\022\004\199\004\022\004\196\004\022\002V\001\169\002V\000z\002V\000z\002V\001@\002V\007\201\002V\004\198\004\022\004\207\004\022\004\211\004\022\004\213\004\022\004\237\004\022\004\222\004\022\002V\007\202\002V\000z\002V\001\027\002V\001M\002V\001\164\002V\004\219\004\022\004\221\004\022\004\230\004\022\004\234\004\022\004\236\004\022\005\011\004\022\002V\001\027\002V\001S\002V\001\027\002V\001W\002V\000\148\002V\004\252\004\022\004\249\004\022\004\251\004\022\005\004\004\022\005\b\004\022\005\n\004\022\002V\001p\002V\001s\002V\001p\002V\001r\002V\001\159\002V\005%\004\022\005\022\004\022\005\019\004\022\005\021\004\022\005\030\004\022\005\"\004\022\002V\005\172\002V\005\172\002V\005\172\002V\001\027\002V\002\t\002V\005$\004\022\005=\004\022\005.\004\022\005+\004\022\005-\004\022\0056\004\022\002V\001\151\002V\007\166\002V\007`\002V\007&\002V\003\238\002V\005:\004\022\005<\004\022\005B\004\022\005I\004\022\005N\004\022\005Y\004\022\002V\001\027\002V\002\r\002V\000z\002V\005\172\002V\001\138\002V\005a\004\022\005d\004\022\005f\004\022\005o\004\022\005t\004\022\005w\004\022\002V\005\172\002V\005\172\002V\005\172\002V\005\172\002V\006\254\002V\005y\004\022\005|\004\022\005\128\004\022\005\130\004\022\005\184\004\022\005\199\004\022\002V\005\172\002V\006\188\002V\006\180\002V\006\165\002V\006\150\002V\005\210\004\022\005\221\004\022\005\235\004\022\005\254\004\022\006\t\004\022\006\020\004\022\002V\005\172\002V\006s\002V\005\172\002V\005\172\002V\001\137\002V\006\031\004\022\006-\004\022\006>\004\022\006I\004\022\006T\004\022\006_\004\022\002V\005\172\002V\005\176\002V\005\172\002V\005\181\002V\005\187\002V\006m\004\022\006\191\004\022\006\202\004\022\006\216\004\022\006\238\004\022\006\250\004\022\002V\005\172\002V\005\186\002V\005\172\002V\005\196\002V\001\128\002V\007\003\004\022\007\r\004\022\007\020\004\022\007\028\004\022\007#\004\022\007)\004\022\002V\005\172\002V\005\202\002V\005\172\002V\005\201\002V\001u\002V\0074\004\022\007B\004\022\007P\004\022\007\\\004\022\007h\004\022\007s\004\022\002V\005\172\002V\005\207\002V\001n\002V\005\213\002V\001\167\002V\007\129\004\022\007\143\004\022\007\162\004\022\b\b\007\210\004\022\b\b\b\208\000E\002V\b\201\002V\005\212\002V\002V\000\157\002V\002V\007\215\004\022\007\225\004\022\b\b\007\231\004\022\b\b\b\179\007\242\004\022\b\173\002V\001\187\002V\002V\b\b\002V\002V\000G\b@\002V\007\255\004\022\b\b\b\b\b\b\002V\b\023\b\022\b\015\001\191\b\026\004\022\002V\002V\002V\002V\b\b\b\b\000K\b\b\b\019\b\021\002V\b\028\b#\004\022\000M\002V\002V\b\b\002V\b(\004\022\b%\b\b\b\b\002V\001\165\b*\b1\002V\b.\004\022\002V\b\b\002V\002V\b\b\b0\000T\b\b\b9\b\b\002V\b=\002V\b?\000\157\002V\001\187\b\b\002V\b\b\002V\bW\b\b\bH\bE\004\022\bG\b\b\002V\000S\002V\bP\000X\002V\001\190\b\b\002V\b\b\002V\bT\b\b\bV\001\187\b\b\bu\001\157\002V\bf\002V\bc\004\022\002V\b\b\b\b\002V\b\b\be\bn\b\b\br\007\149\002V\bt\002V\002V\000\157\002V\b\b\b\b\002V\000^\b\143\b\128\b}\004\022\005\188\b\b\b\b\002V\002V\b\127\b\136\b\b\002\023\007-\002V\b\140\002V\002V\000`\b\b\b\b\b\b\002V\b\142\b\167\b\152\b\149\004\022\002\004\b\b\002V\002V\002V\b\151\002\006\b\b\002\022\b\b\002V\b\160\002V\b\164\000b\b\b\002\216\b\b\002V\b\166\002V\b\172\002\006\b\b\000d\b\b\002V\b\178\002V\b\181\002\006\b\b\000f\b\b\002V\b\190\002V\b\195\002\218\b\b\000h\b\b\002V\b\198\002V\b\200\b\205\004\022\001\149\b\b\002V\000\155\002V\b\207\000\159\000\172\000\182\000\186\002V\000\209\002V\001\162\003\191\005\188\000j\003\159\006\220\003\186\000\157\003\177\006\228\000\157\006\255\002V\000\157\000\157\000\157\000\157\002V\000\157\002V\000\157\003\176\003\167\003\163\000\157\003\158\003\149\003\132\003{\003s\003b\003a\002V\002V\002V\003`\002V\002V\002V\002V\002V\002V\002V\002\179\002\170\002\145\002V\002\136\002\135\002U\002Z\002_\002b\002k\002V\002V\002V\002p\002V\002V\002V\002V\002V\002V\002V\002s\002~\002\131\002V\002\134\002\141\002\144\002\153\002\158\002\161\002\166\002V\002V\002V\002\169\002V\002V\002V\002V\002V\002V\002V\002\175\002\178\002\184\002V\002\190\002\195\002\203\002\208\002\220\002\223\002\228\002V\002V\002V\002\234\002V\002V\002V\002V\000l\000n\002V\002\239\002\245\002\250\002V\002\254\003\004\003\t\003\018\002\218\002\218\003\026\002V\002V\002V\003\031\002V\002V\002V\002V\003$\003*\002V\003/\003<\003A\002V\003J\003O\003Z\003_\002V\002V\003g\002V\002V\002V\003f\002V\002V\002V\002V\003\137\003j\003o\003r\003u\003z\002V\003\128\003\131\000p\003\136\000\157\002V\002V\002V\002V\002V\003\140\002V\002V\000\157\002V\003\145\003\148\003\154\003\157\003\162\003\166\002V\003\172\003\175\003\182\003\185\002V\002V\002V\002V\002V\002V\003\190\002V\002V\002V\002V\003\195\004\238\004\128\004\b\004\012\004%\002V\004\026\004\031\004)\004.\002V\002V\002V\002V\002V\002V\0045\002V\002V\002V\002V\004J\004<\004A\004N\004S\004r\002V\004d\004i\004v\004{\002V\002V\002V\002V\002V\002V\004\132\002V\002V\002V\002V\004\137\004\178\004\182\004\187\004\200\004\204\002V\004\209\004\223\004\227\004\232\002V\002V\002V\002V\002V\002V\004\242\002V\002V\002V\002V\004\253\005\001\005\006\005\r\005\023\005\027\002V\005 \005/\0053\0058\002V\002V\002V\002V\002V\002V\005@\002V\002V\002V\002V\005g\005k\005q\005\172\005\172\005\188\002V\005\188\005\188\005\188\005\172\002V\002V\002V\006\195\005\172\005\192\005\191\005\214\005\172\005\172\005\172\005\172\005\188\005\172\005\172\005\172\005\172\005\218\005\224\005\172\005\172\006\002\005\188\005\172\005\223\005\172\005\172\005\172\005\172\005\229\005\172\006\024\005\172\005\233\005\240\005\239\005\246\005\172\005\251\006\001\006\000\006\006\005\172\005\172\006\012\006\011\005\172\005\188\006\017\005\172\006\023\006\022\006\028\006\"\005\172\006!\006B\006'\005\172\005\172\005\172\005\172\006+\005\188\005\172\005\172\005\172\0062\0061\005\172\005\172\0066\006X\005\172\006;\005\172\005\172\005\172\005\172\006A\005\172\005\172\005\172\006@\006F\006L\006K\005\172\005\172\006Q\006W\006V\005\172\005\172\006\\\006b\005\172\005\172\006a\005\172\006g\006k\006r\006q\005\172\006y\006\130\006\136\005\172\005\172\005\172\005\172\006\143\006\149\005\172\005\172\005\172\006\158\006\164\006\220\005\172\006\173\006\179\006\223\006\187\005\172\006\220\005\172\005\172\006\194\006\227\005\172\005\172\006\193\006\199\006\205\006\204\005\172\005\188\006\213\006\219\006\218\005\172\005\172\005\172\006\235\005\188\007\016\005\172\005\172\006\241\005\172\006\240\006\247\005\172\007\031\006\253\006\252\005\172\005\172\006\220\005\172\007\005\005\172\007F\005\172\005\172\007\015\007\022\007\030\005\172\005\172\005\172\007%\007,\005\172\007+\005\172\005\188\0071\005\172\005\172\005\172\0077\0076\005\172\007?\007l\007E\005\172\007D\007M\005\172\005\172\006\220\007S\007R\007Y\007\133\005\172\007_\005\172\007^\005\172\005\172\007e\007k\007j\005\172\005\172\007p\005\172\005\172\005\172\007v\005\172\007\169\007u\007~\005\172\005\172\007\169\005\172\005\172\007\132\007\169\007\131\000r\007\140\007\146\007\173\b\182\bX\007\145\007\153\007\172\007\159\007\165\007\164\007\188\007\176\b\012\002V\002V\007\181\007\185\b\017\007\191\007\196\b2\b6\b;\002V\bI\bM\bR\b\\\002V\bg\bk\002V\002V\002V\bp\002V\002V\002V\002V\bw\002V\002V\b\129\b\133\b\138\002V\b\153\b\157\b\162\b\170\002V\b\186\b\192\002V\002V\002V\000|\002V\002V\002V\002V\000~\002V\002V\000\128\000\131\000\134\000\136\000\140\000\142\000\144\001g\001f\000\179\000\194\000\196\000\202\000\198\000\200\000\201\000\204\000\221\001\024\001\015\001\004\000\254\000\245\000\251\001\000\001\003\001\011\001\017\001\020\001\029\001!\001%\001'\001)\001+\001-\001/\0011\0013\0015\0017\0019\001;\001=\001C\001E\001H\001K\001O\001Q\001U\001|\001\130\001\133\001\153\001\154\001\156\001\210\001\212\001\222\003\183\001\226\003\164\003\155\001\243\003\146\001\250\002\018\003\129\002\028\003p\002$\002'\002.\0022\002\176\0027\002;\002\167\002?\002\142\002D\002G\002t\002P\002`\002S\002X\002]\002f\002q\002i\002n\002v\002y\002\132\002|\002\129\002\139\002\159\002\151\002\156\002\164\002\173\002\182\002\188\002\193\002\201\002\206\002\221\002\214\002\226\002\232\002\237\002\243\002\248\002\252\003\002\003\007\003\012\003\016\003\024\003\029\003\"\003(\003-\003P\0037\003:\003?\003E\003H\003M\003R\003U\003X\003]\003m\003~\003\143\003\152\003\169\003\180\003\203\004\215\003\210\003\212\003\214\003\218\004\142\004\004\004\003\004\002\004\001\004\000\003\255\003\254\003\253\003\252\003\251\003\250\003\249\004\006\004\014\004\n\004\r\0043\004$\004\021\004\024\004\027\004'\004*\004,\0040\0042\0047\004:\004=\004?\004C\004I\004H\004L\004O\004Q\004U\004W\004]\004\\\004_\004b\004e\004g\004k\004q\004p\004t\004w\004y\004}\004\127\004\130\004\133\004\135\004\139\004\141\004\154\004\156\004\192\004\170\004\177\004\176\004\180\004\183\004\185\004\189\004\191\004\202\004\205\004\225\004\228\005>\004\240\004\243\004\245\004\255\005\002\005\015\005\025\005\028\005'\0051\0054\005F\005K\005]\005V\005\\\005[\005i\005l\005\146\005\145\005\151\005\154\005\158\005\161\005\165\005\168\005\226\006$\006d\006u\006~\006\132\006\139\006\145\006\155\006\161\006\170\006\176\006\183\006\209\006\231\006\243\007;\007I\007U\007z\007\136\007\155\007\178\007\193\007\204\007\206\007\221\007\234\007\238\bA\007\244\007\248\007\250\007\252\b\002\b\006\b\n\b\r\b\030\b \b4\b7\bK\bN\b\168\bZ\b]\b_\bi\bl\by\b\131\b\134\b\145\b\155\b\158\b\175\b\184\b\187"))
  
  and semantic_action =
    [|
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.decl option list) = Obj.magic x in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x = 
# 224 "asllib/Parser0.mly"
                      ( List.filter_map Fun.id x )
# 808 "asllib/Parser0.ml"
           in
          (
# 196 "<standard.mly>"
    ( x )
# 813 "asllib/Parser0.ml"
           : (AST.t))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 853 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 79 "asllib/Parser0.mly"
       (bool)
# 874 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 390 "asllib/Parser0.mly"
                       AST.L_Bool        
# 886 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 892 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 901 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 77 "asllib/Parser0.mly"
       (Z.t)
# 923 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 391 "asllib/Parser0.mly"
                       AST.L_Int         
# 935 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 941 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 950 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 78 "asllib/Parser0.mly"
       (Q.t)
# 972 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 392 "asllib/Parser0.mly"
                       AST.L_Real        
# 984 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 990 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 999 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 76 "asllib/Parser0.mly"
       (Bitvector.t)
# 1021 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 393 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 1033 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1039 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1048 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1070 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 394 "asllib/Parser0.mly"
                       AST.L_String      
# 1082 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 1088 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1097 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1131 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 1137 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1149 "asllib/Parser0.ml"
              
            in
            
# 357 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1155 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1164 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1186 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 357 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1197 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1206 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 1234 "asllib/Parser0.ml"
             in
            
# 357 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 1239 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1248 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1296 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 1302 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 1312 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 1318 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1323 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1331 "asllib/Parser0.ml"
              
            in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1337 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1346 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1401 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 1407 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 1417 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1425 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 1433 "asllib/Parser0.ml"
              
            in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1439 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1448 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1484 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 1494 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 1500 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1505 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1512 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1521 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 1564 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 1574 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1582 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1589 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1598 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 1640 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 1646 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 1651 "asllib/Parser0.ml"
              
            in
            let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 1657 "asllib/Parser0.ml"
             in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1662 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1671 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 1720 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 1728 "asllib/Parser0.ml"
              
            in
            let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 1734 "asllib/Parser0.ml"
             in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 1739 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1748 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 711 "asllib/Parser0.mly"
            ( AST.BNOT )
# 1783 "asllib/Parser0.ml"
             in
            
# 360 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1788 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1797 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 712 "asllib/Parser0.mly"
            ( AST.NEG )
# 1832 "asllib/Parser0.ml"
             in
            
# 360 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1837 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1846 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 713 "asllib/Parser0.mly"
            ( AST.NOT )
# 1881 "asllib/Parser0.ml"
             in
            
# 360 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 1886 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1895 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 718 "asllib/Parser0.mly"
                 ( AST.AND    )
# 1937 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 1942 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 1951 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 719 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 1993 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 1998 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2007 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 720 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 2049 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2054 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2063 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 721 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 2105 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2110 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2119 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 722 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 2161 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2166 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2175 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 723 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 2217 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2222 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2231 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 724 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 2273 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2278 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2287 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 725 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 2329 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2334 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2343 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 726 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 2385 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2390 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2399 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 727 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 2441 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2446 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2455 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 728 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 2497 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2502 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2511 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 729 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 2553 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2558 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2567 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 730 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 2609 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2614 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2623 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 731 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 2665 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2670 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2679 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 732 "asllib/Parser0.mly"
                 ( AST.OR     )
# 2721 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2726 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2735 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 733 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 2777 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2782 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2791 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 734 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 2833 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2838 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2847 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 735 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 2889 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2894 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2903 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 715 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 2945 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 2950 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 2959 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 743 "asllib/Parser0.mly"
                 ( AST.LT     )
# 3001 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3006 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3015 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 744 "asllib/Parser0.mly"
                 ( AST.GT     )
# 3057 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 3062 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3071 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 292 "asllib/Parser0.mly"
                                           ( h::t )
# 3131 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 3137 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 362 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 3144 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3153 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 382 "asllib/Parser0.mly"
                                                build_expr_conds  
# 3226 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 363 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 3232 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3241 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 3275 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 364 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 3288 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3297 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 3347 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3352 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 3359 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3368 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3426 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 3433 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3442 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 3485 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3490 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 3497 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3506 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3557 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 3564 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3573 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 3609 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 3614 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 367 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 3621 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3630 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 3674 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 367 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 3681 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3690 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 686 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 3751 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 3757 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3766 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3772 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3781 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 3815 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 3830 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3839 "asllib/Parser0.ml"
              
            in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 3845 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3854 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 3888 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 3906 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3915 "asllib/Parser0.ml"
                  
                in
                
# 370 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 3921 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3930 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 370 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 3937 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3946 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 3982 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 3990 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 3997 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4006 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 4042 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4050 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4057 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4066 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 4102 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4110 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4117 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4126 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 4155 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 4168 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4177 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4184 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4193 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 4234 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 4240 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 4255 "asllib/Parser0.ml"
                  
                in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 4261 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4270 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4277 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4286 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 4322 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4330 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4337 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4346 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 4404 "asllib/Parser0.ml"
                 in
                
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 4409 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4418 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4425 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4434 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 4516 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 4522 "asllib/Parser0.ml"
                 in
                
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 4527 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4536 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4543 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4552 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 4611 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 4618 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4627 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4634 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4643 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 4705 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 4726 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 4734 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4743 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4750 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4759 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 4833 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 4839 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 4861 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 4869 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 4877 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4886 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 4893 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 4902 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 4996 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 5004 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5013 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 5020 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5029 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5065 "asllib/Parser0.ml"
               in
              let _1 = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5070 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5077 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5086 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 5120 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5133 "asllib/Parser0.ml"
               in
              let _1 = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 5138 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5145 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5154 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5190 "asllib/Parser0.ml"
               in
              let _1 = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5195 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5202 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5211 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 5245 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5258 "asllib/Parser0.ml"
               in
              let _1 = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 5263 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5270 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5279 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5315 "asllib/Parser0.ml"
               in
              let _1 = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5320 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5327 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5336 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 5370 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5383 "asllib/Parser0.ml"
               in
              let _1 = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 5388 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5395 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5404 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 5433 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5444 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 5451 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5459 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5468 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 5502 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 5508 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5519 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 5526 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5534 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5543 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 5584 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 5590 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5601 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5610 "asllib/Parser0.ml"
                  
                in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 5616 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5624 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5633 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 5679 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 5685 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 5691 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5702 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 5711 "asllib/Parser0.ml"
                  
                in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 5717 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5725 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5734 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5770 "asllib/Parser0.ml"
               in
              let _1 = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 5775 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5782 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5791 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 5825 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 5838 "asllib/Parser0.ml"
               in
              let _1 = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 5843 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5850 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5859 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 5916 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 5922 "asllib/Parser0.ml"
                 in
                
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 5927 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 5935 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 5944 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 5996 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6014 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6021 "asllib/Parser0.ml"
                 in
                
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 6026 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6034 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6043 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6121 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 6130 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6136 "asllib/Parser0.ml"
                 in
                
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 6141 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6149 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6158 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 6228 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6249 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 6259 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 6265 "asllib/Parser0.ml"
                 in
                
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 6270 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6278 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6287 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6344 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 6351 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6358 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6366 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6375 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 6427 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 6445 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 6453 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6460 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6468 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6477 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 6539 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6552 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6566 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6574 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6582 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6591 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 6655 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 6664 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6677 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6691 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6699 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6707 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6716 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 6790 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 6796 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 6809 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6823 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6831 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6839 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6847 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 6856 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 6932 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 6941 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 6947 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 6960 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 6974 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 6982 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 6990 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 6998 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7007 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 7092 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7106 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7114 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7122 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7131 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 7207 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 7227 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 7241 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 7249 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 7257 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7266 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc = 
# 350 "asllib/Parser0.mly"
          ( AST.E_Concat [ e1; e2 ] )
# 7307 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7315 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v : (AST.local_decl_item) = 
# 624 "asllib/Parser0.mly"
            ( AST.LDI_Discard )
# 7341 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 7362 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 625 "asllib/Parser0.mly"
                          ( AST.LDI_Var x )
# 7372 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = 
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 7399 "asllib/Parser0.ml"
           in
          (
# 625 "asllib/Parser0.mly"
                          ( AST.LDI_Var x )
# 7404 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.local_decl_item list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let ldis =
            let x =
              let _1 = _1_inlined1 in
              let t = _1 in
              
# 292 "asllib/Parser0.mly"
                                           ( h::t )
# 7463 "asllib/Parser0.ml"
              
            in
            
# 205 "<standard.mly>"
    ( x )
# 7469 "asllib/Parser0.ml"
            
          in
          (
# 628 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 7475 "asllib/Parser0.ml"
           : (AST.local_decl_item))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 602 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 7502 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7510 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 7544 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 7550 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 7562 "asllib/Parser0.ml"
              
            in
            
# 601 "asllib/Parser0.mly"
                             AST.LE_Var  
# 7568 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7577 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 7599 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 601 "asllib/Parser0.mly"
                             AST.LE_Var  
# 7610 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7619 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 7647 "asllib/Parser0.ml"
             in
            
# 601 "asllib/Parser0.mly"
                             AST.LE_Var  
# 7652 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7661 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 7704 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 7709 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 612 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7716 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7725 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 7776 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 612 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7783 "asllib/Parser0.ml"
             (lexpr, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7792 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 7834 "asllib/Parser0.ml"
             in
            let _3_1 = _3 in
            
# 613 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7840 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7849 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = lexpr;
                MenhirLib.EngineTypes.startp = _startpos_lexpr_;
                MenhirLib.EngineTypes.endp = _endpos_lexpr_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _3 = _1 in
            let _3_1 = _3 in
            
# 613 "asllib/Parser0.mly"
                                                 AST.LE_Slice        
# 7900 "asllib/Parser0.ml"
             (lexpr, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7909 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 7953 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 614 "asllib/Parser0.mly"
                                                 AST.LE_Destructuring  
# 7960 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 7969 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = lexpr;
              MenhirLib.EngineTypes.startp = _startpos_lexpr_;
              MenhirLib.EngineTypes.endp = _endpos_lexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 8003 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let lexpr : (AST.lexpr) = Obj.magic lexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_lexpr_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 615 "asllib/Parser0.mly"
                                                 AST.LE_SetField     
# 8016 "asllib/Parser0.ml"
             (lexpr, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_lexpr_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8025 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = l;
                MenhirLib.EngineTypes.startp = _startpos_l_;
                MenhirLib.EngineTypes.endp = _endpos_l_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 8075 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 8080 "asllib/Parser0.ml"
              
            in
            
# 616 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 8086 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8095 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = l;
                  MenhirLib.EngineTypes.startp = _startpos_l_;
                  MenhirLib.EngineTypes.endp = _endpos_l_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let l : (AST.lexpr) = Obj.magic l in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_l_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let f =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 8153 "asllib/Parser0.ml"
              
            in
            
# 616 "asllib/Parser0.mly"
                                               ( AST.LE_SetFields (l, f, []) )
# 8159 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_l_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8168 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.lexpr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 = 
# 602 "asllib/Parser0.mly"
                    ( AST.LE_Discard )
# 8210 "asllib/Parser0.ml"
             in
            let _1 =
              let _1 =
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 8218 "asllib/Parser0.ml"
                
              in
              ()
            in
            _2
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8231 "asllib/Parser0.ml"
           : (AST.lexpr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (unit list) = 
# 216 "<standard.mly>"
    ( [] )
# 8250 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let x : unit = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (unit list) = 
# 219 "<standard.mly>"
    ( x :: xs )
# 8282 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.case_alt list) = 
# 216 "<standard.mly>"
    ( [] )
# 8300 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 8374 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 8380 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8389 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8398 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8404 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8413 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8419 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 8519 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 8526 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8535 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 8541 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8550 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8558 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 8564 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8573 "asllib/Parser0.ml"
                
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 8579 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8588 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8597 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8603 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8612 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8618 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8737 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 8743 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 8751 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8760 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 8766 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8775 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8783 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 8789 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8798 "asllib/Parser0.ml"
                
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 8804 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8813 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8822 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8828 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8837 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8843 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 8904 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 8910 "asllib/Parser0.ml"
                
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 8916 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 8925 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8934 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 8940 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 8949 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 8955 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 9007 "asllib/Parser0.ml"
                
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 9013 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9022 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9031 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9037 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9046 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9052 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9134 "asllib/Parser0.ml"
                 _3_1
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9140 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9149 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9158 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9164 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9173 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9179 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 9286 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9293 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9302 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9308 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9317 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9325 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9331 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9340 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9346 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9355 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9364 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9370 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9379 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9385 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9511 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 9517 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 9525 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9534 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 9540 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9549 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9557 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 9563 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9572 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9578 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9587 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9596 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9602 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9611 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9617 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 9685 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 9691 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9697 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9706 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9715 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9721 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9730 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9736 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined2 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 9795 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 9801 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9810 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9819 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9825 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9834 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9840 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 9936 "asllib/Parser0.ml"
                 _3_1
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 9946 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 9956 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9965 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 9971 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 9980 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 9986 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10107 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10114 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10123 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10129 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10138 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10146 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10152 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10161 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10171 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10181 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10190 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10196 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10205 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10211 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined4_, _startpos__1_inlined3_, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10351 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 10357 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10365 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10374 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10380 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10389 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10397 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 10403 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10412 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10422 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10432 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10441 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10447 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10456 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10462 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10544 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 10550 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10560 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10570 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10579 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10585 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10594 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10600 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _1 = _1_inlined3 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 10673 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 10683 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10693 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10702 "asllib/Parser0.ml"
                
              in
              
# 660 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10708 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10717 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10723 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 10813 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 10820 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10829 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 10835 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10844 "asllib/Parser0.ml"
                
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 10850 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 10859 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10868 "asllib/Parser0.ml"
                
              in
              
# 662 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 10874 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 10883 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 10889 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 10998 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11004 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11012 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11021 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11027 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11036 "asllib/Parser0.ml"
                
              in
              let where = 
# 668 "asllib/Parser0.mly"
    ( None )
# 11042 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11051 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11060 "asllib/Parser0.ml"
                
              in
              
# 662 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11066 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11075 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11081 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11178 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11185 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11194 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11200 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11209 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 11215 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11224 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11233 "asllib/Parser0.ml"
                
              in
              
# 662 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11239 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11248 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11254 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11370 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11376 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11384 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11393 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11399 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11408 "asllib/Parser0.ml"
                
              in
              let where = 
# 123 "<standard.mly>"
    ( None )
# 11414 "asllib/Parser0.ml"
               in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11423 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11432 "asllib/Parser0.ml"
                
              in
              
# 662 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11438 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11447 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11453 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 11564 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11571 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11580 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11586 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11595 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11605 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11615 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11624 "asllib/Parser0.ml"
                
              in
              
# 662 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11630 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11639 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11645 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11775 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 11781 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 11789 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 11798 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 11804 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11813 "asllib/Parser0.ml"
                
              in
              let where =
                let _1 = _1_inlined2 in
                let _2 = _2_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 11823 "asllib/Parser0.ml"
                
              in
              let pattern =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                let desc =
                  let _1_1 = _1 in
                  
# 675 "asllib/Parser0.mly"
                                                   AST.Pattern_Any  
# 11833 "asllib/Parser0.ml"
                   _1_1
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11842 "asllib/Parser0.ml"
                
              in
              
# 662 "asllib/Parser0.mly"
        ( AST.{ pattern; where; stmt } )
# 11848 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11857 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11863 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = desc;
                    MenhirLib.EngineTypes.startp = _startpos_desc_;
                    MenhirLib.EngineTypes.endp = _endpos_desc_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 11930 "asllib/Parser0.ml"
                 _3_1
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11939 "asllib/Parser0.ml"
                
              in
              
# 664 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 11945 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__4_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 11954 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 11960 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = desc;
                          MenhirLib.EngineTypes.startp = _startpos_desc_;
                          MenhirLib.EngineTypes.endp = _endpos_desc_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 12052 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12059 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12068 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12074 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12083 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12091 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 12097 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12106 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12115 "asllib/Parser0.ml"
                
              in
              
# 664 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12121 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12130 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12136 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = desc;
                              MenhirLib.EngineTypes.startp = _startpos_desc_;
                              MenhirLib.EngineTypes.endp = _endpos_desc_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12247 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 12253 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 12261 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12270 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 12276 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12285 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12293 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 12299 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12308 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12317 "asllib/Parser0.ml"
                
              in
              
# 664 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12323 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__6_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12332 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12338 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = desc;
                MenhirLib.EngineTypes.startp = _startpos_desc_;
                MenhirLib.EngineTypes.endp = _endpos_desc_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt =
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 12391 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 12397 "asllib/Parser0.ml"
                
              in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12406 "asllib/Parser0.ml"
                
              in
              
# 664 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12412 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__2_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12421 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12427 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = desc;
              MenhirLib.EngineTypes.startp = _startpos_desc_;
              MenhirLib.EngineTypes.endp = _endpos_desc_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.case_alt list) = Obj.magic xs in
        let _1 : unit = Obj.magic _1 in
        let desc : unit = Obj.magic desc in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_desc_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let stmt = 
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 12470 "asllib/Parser0.ml"
               in
              let loc =
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12478 "asllib/Parser0.ml"
                
              in
              
# 664 "asllib/Parser0.mly"
        ( AST.{ pattern = ASTUtils.add_pos_from loc Pattern_All; where = None; stmt } )
# 12484 "asllib/Parser0.ml"
              
            in
            let _endpos_desc_ = _endpos__1_ in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12493 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12499 "asllib/Parser0.ml"
           : (AST.case_alt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.decl option list) = 
# 216 "<standard.mly>"
    ( [] )
# 12518 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 12598 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 12604 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 12627 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 401 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 12633 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 12643 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12652 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 12658 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 12664 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12670 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 12739 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 401 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 12759 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 12769 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12778 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 12784 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 12790 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12796 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 340 "asllib/Parser0.mly"
              ( "record" )
# 12882 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 401 "asllib/Parser0.mly"
                ( AST.GDK_Constant  )
# 12888 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 12898 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 12907 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 12913 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 12919 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 12925 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 13006 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 13012 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13035 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 402 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 13041 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13051 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13060 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13066 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13072 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13078 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 13147 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1_inlined1 in
                  let gdk = 
# 402 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 13167 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13177 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13186 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13192 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13198 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13204 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined2 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 340 "asllib/Parser0.mly"
              ( "record" )
# 13290 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 402 "asllib/Parser0.mly"
                ( AST.GDK_Config    )
# 13296 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13306 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13315 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13321 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13327 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13333 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = t;
                          MenhirLib.EngineTypes.startp = _startpos_t_;
                          MenhirLib.EngineTypes.endp = _endpos_t_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 13408 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 13414 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13435 "asllib/Parser0.ml"
                    
                  in
                  let gdk = 
# 403 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 13441 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13451 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13460 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13466 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13472 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13478 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 13541 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  let gdk = 
# 403 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 13560 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13570 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13579 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13585 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13591 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13597 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = t;
                      MenhirLib.EngineTypes.startp = _startpos_t_;
                      MenhirLib.EngineTypes.endp = _endpos_t_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _4 : unit = Obj.magic _4 in
        let _1 : unit = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 13674 "asllib/Parser0.ml"
                   in
                  let gdk = 
# 403 "asllib/Parser0.mly"
                ( AST.GDK_Var       )
# 13679 "asllib/Parser0.ml"
                   in
                  
# 409 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = gdk;
            name = x;
            initial_value = Some e;
            ty = Some t;
          } )
# 13689 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos_t_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13698 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13704 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13710 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13716 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 13777 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 13783 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let x =
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 13804 "asllib/Parser0.ml"
                    
                  in
                  
# 416 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 13815 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13824 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13830 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13836 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13842 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 13891 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = _1 in
                  
# 416 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 13915 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 13924 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 13930 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 13936 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 13942 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = ty;
                  MenhirLib.EngineTypes.startp = _startpos_ty_;
                  MenhirLib.EngineTypes.endp = _endpos_ty_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined1 in
              _2
            in
            let x =
              let x =
                let desc =
                  let x = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 14005 "asllib/Parser0.ml"
                   in
                  
# 416 "asllib/Parser0.mly"
          ( AST.D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some ty;
            initial_value = None;
          })
# 14015 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_ty_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14024 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14030 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14036 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14042 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 14130 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 14136 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14159 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14168 "asllib/Parser0.ml"
                    
                  in
                  
# 423 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14180 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14189 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14195 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14201 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14207 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 14309 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 14315 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let (_2_inlined1, _2) = (_2_inlined2, _2_inlined1) in
              let x =
                let desc =
                  let e =
                    let (_2, _1_inlined1) = (_2_inlined1, _1_inlined3) in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14341 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 14350 "asllib/Parser0.ml"
                    
                  in
                  
# 423 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14362 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14371 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14377 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14383 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14389 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 14465 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14487 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 423 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14500 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14509 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14515 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14521 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14527 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 14617 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14643 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 423 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14656 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14665 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14671 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14677 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14683 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 14777 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 340 "asllib/Parser0.mly"
              ( "record" )
# 14785 "asllib/Parser0.ml"
                    
                  in
                  
# 423 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14797 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14806 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14812 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14818 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14824 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 =
              let _1 = _1_inlined4 in
              _2
            in
            let x =
              let _2 = _2_inlined1 in
              let x =
                let desc =
                  let e =
                    let _1_inlined1 = _1_inlined3 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      _3
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 14936 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 340 "asllib/Parser0.mly"
              ( "record" )
# 14944 "asllib/Parser0.ml"
                    
                  in
                  
# 423 "asllib/Parser0.mly"
          ( AST.(D_GlobalStorage {
            keyword = GDK_Var;
            name = x;
            ty = Some (T_Array (ArrayLength_Expr e, ty)
                       |> ASTUtils.add_dummy_annotation ~version);
            initial_value = None;
          }))
# 14956 "asllib/Parser0.ml"
                  
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 14965 "asllib/Parser0.ml"
                
              in
              
# 225 "asllib/Parser0.mly"
                      Some  
# 14971 "asllib/Parser0.ml"
               x
            in
            
# 196 "<standard.mly>"
    ( x )
# 14977 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 14983 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 15072 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 15078 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15095 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 15102 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15107 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15115 "asllib/Parser0.ml"
                  
                in
                
# 435 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15121 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15130 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 15136 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15142 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 15238 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 15244 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15261 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15270 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15278 "asllib/Parser0.ml"
                  
                in
                
# 435 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15284 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15293 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 15299 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15305 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 15382 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15399 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 15406 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15411 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 435 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15418 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15427 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 15433 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15439 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 15523 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15540 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15549 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 435 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15556 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15565 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 15571 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15577 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15667 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 15674 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15679 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 15685 "asllib/Parser0.ml"
                 in
                
# 435 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15690 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15699 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 15705 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15711 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15808 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 15817 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 15823 "asllib/Parser0.ml"
                 in
                
# 435 "asllib/Parser0.mly"
        ( make_func name args (Some ty) (SB_ASL body) )
# 15828 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 15837 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 15843 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 15849 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 15944 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 15950 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined2, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 15968 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 15975 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 15980 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 15989 "asllib/Parser0.ml"
                  
                in
                
# 439 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 15995 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16004 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 16010 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16016 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 16118 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 16124 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined2, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16142 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16151 "asllib/Parser0.ml"
                  
                in
                let name =
                  let (_1, _2) = (_1_inlined1, _2_inlined1) in
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16160 "asllib/Parser0.ml"
                  
                in
                
# 439 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16166 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16175 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 16181 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16187 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 16270 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16288 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 16295 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16300 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 439 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16307 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16316 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 16322 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16328 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 16418 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16436 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16445 "asllib/Parser0.ml"
                  
                in
                let name = _1_inlined1 in
                
# 439 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16452 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16461 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 16467 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16473 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16570 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 16577 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 16582 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 340 "asllib/Parser0.mly"
              ( "record" )
# 16590 "asllib/Parser0.ml"
                  
                in
                
# 439 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16596 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16605 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 16611 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16617 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 16721 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 16730 "asllib/Parser0.ml"
                  
                in
                let name =
                  let _1 = _1_inlined1 in
                  
# 340 "asllib/Parser0.mly"
              ( "record" )
# 16738 "asllib/Parser0.ml"
                  
                in
                
# 439 "asllib/Parser0.mly"
        ( make_func name args None (SB_ASL body) )
# 16744 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 16753 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 16759 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16765 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 16833 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 16839 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 16851 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 16857 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 16862 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 16870 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 16876 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 16883 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 16889 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 16964 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 16970 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 16984 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 16991 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 16996 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17004 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17010 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17017 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17023 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = x;
                          MenhirLib.EngineTypes.startp = _startpos_x_;
                          MenhirLib.EngineTypes.endp = _endpos_x_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 17098 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 17104 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17116 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17124 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17132 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17138 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17145 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17151 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = x;
                            MenhirLib.EngineTypes.startp = _startpos_x_;
                            MenhirLib.EngineTypes.endp = _endpos_x_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 17233 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 17239 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17253 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17262 "asllib/Parser0.ml"
                
              in
              let _2 =
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 17270 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17276 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17283 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17289 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 17345 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17357 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 17363 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17368 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17375 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17382 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17388 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 17451 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17465 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 17472 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17477 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17484 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17491 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17497 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 17560 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17572 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17580 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17587 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17594 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17600 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 17670 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17684 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 17693 "asllib/Parser0.ml"
                
              in
              let _2 = _1 in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17700 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17707 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17713 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17777 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 17783 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17788 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 17794 "asllib/Parser0.ml"
               in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17799 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17806 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17812 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 17885 "asllib/Parser0.ml"
                
              in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 17892 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 17897 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 17903 "asllib/Parser0.ml"
               in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 17908 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 17915 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 17921 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 17992 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18000 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 18006 "asllib/Parser0.ml"
               in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 18011 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 18018 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18024 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x_inlined1;
              MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 18104 "asllib/Parser0.ml"
                
              in
              let _3 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 18113 "asllib/Parser0.ml"
                
              in
              let _2 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 18119 "asllib/Parser0.ml"
               in
              let _1 = 
# 225 "asllib/Parser0.mly"
                      Some  
# 18124 "asllib/Parser0.ml"
               x in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 18131 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18137 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 18220 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 18226 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18242 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 18249 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18254 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18262 "asllib/Parser0.ml"
                  
                in
                
# 517 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
        )
# 18276 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18285 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 18291 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18297 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 18387 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 18393 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18409 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18418 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 18426 "asllib/Parser0.ml"
                  
                in
                
# 517 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
        )
# 18440 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18449 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 18455 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18461 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 18532 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18548 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 18555 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18560 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 517 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
        )
# 18575 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18584 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 18590 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18596 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 18674 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18690 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18699 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 517 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
        )
# 18714 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18723 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 18729 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18735 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18818 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 18825 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 18830 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 18836 "asllib/Parser0.ml"
                 in
                
# 517 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
        )
# 18849 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18858 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 18864 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 18870 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 18960 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 18969 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 18975 "asllib/Parser0.ml"
                 in
                
# 517 "asllib/Parser0.mly"
        (
          let open AST in
          let return_type = None
          and parameters = []
          and body = SB_ASL body
          and recurse_limit = None
          and subprogram_type = ST_Procedure in
          D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
        )
# 18988 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 18997 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 19003 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19009 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19071 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 19077 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19088 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 19094 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19099 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19108 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19116 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19122 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19191 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 19197 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19208 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 19214 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19219 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19228 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19236 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19242 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19311 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 19317 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19328 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19336 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19345 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19353 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19359 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19435 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 19441 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19452 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19460 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 19469 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19477 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19483 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19533 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19544 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 19550 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19555 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19563 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19569 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19626 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19637 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 19643 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19648 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19656 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19662 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19719 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19730 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19738 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19746 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19752 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 19816 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 19827 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 19835 "asllib/Parser0.ml"
                
              in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19843 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19849 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 19906 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 19912 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 19917 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 19923 "asllib/Parser0.ml"
               in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 19930 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 19936 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20000 "asllib/Parser0.ml"
               in
              let _2 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 20006 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 20011 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 20017 "asllib/Parser0.ml"
               in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 20024 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20030 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 20094 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20102 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 20108 "asllib/Parser0.ml"
               in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 20115 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20121 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let x : unit = Obj.magic x in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 20192 "asllib/Parser0.ml"
               in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 20200 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 20206 "asllib/Parser0.ml"
               in
              _4
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 20213 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20219 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 20294 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 20300 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20317 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20325 "asllib/Parser0.ml"
                  
                in
                
# 448 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 20340 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20349 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 20355 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20361 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 20424 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20441 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 448 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 20457 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20466 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 20472 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20478 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20554 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 20560 "asllib/Parser0.ml"
                 in
                
# 448 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptyGetter
        and recurse_limit = None
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 20574 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20583 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 20589 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20595 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 20684 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 20690 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined2, _2_inlined1, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20707 "asllib/Parser0.ml"
                   _3_1
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20715 "asllib/Parser0.ml"
                  
                in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 20730 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20739 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 20745 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20751 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = ty;
                        MenhirLib.EngineTypes.startp = _startpos_ty_;
                        MenhirLib.EngineTypes.endp = _endpos_ty_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 20819 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 20825 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 20840 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 20848 "asllib/Parser0.ml"
                  
                in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 20863 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 20872 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 20878 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 20884 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 20961 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 20978 "asllib/Parser0.ml"
                   _3_1
                in
                let name = _1 in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 20994 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21003 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21009 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21015 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 21071 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 21086 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21102 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21111 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21117 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21123 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21213 "asllib/Parser0.ml"
                   _3_1
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 21219 "asllib/Parser0.ml"
                 in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21233 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21242 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21248 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21254 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = ty;
                    MenhirLib.EngineTypes.startp = _startpos_ty_;
                    MenhirLib.EngineTypes.endp = _endpos_ty_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let _1 = _1_inlined1 in
                  
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 21321 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 21327 "asllib/Parser0.ml"
                 in
                
# 459 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and args = []
        and body = SB_ASL body
        and recurse_limit = None
        and subprogram_type = ST_EmptyGetter
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21341 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21350 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21356 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21362 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = ty;
                              MenhirLib.EngineTypes.startp = _startpos_ty_;
                              MenhirLib.EngineTypes.endp = _endpos_ty_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 21451 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 21457 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21474 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 21481 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 21486 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21494 "asllib/Parser0.ml"
                  
                in
                
# 470 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21508 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21517 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21523 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21529 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = ty;
                                MenhirLib.EngineTypes.startp = _startpos_ty_;
                                MenhirLib.EngineTypes.endp = _endpos_ty_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 21625 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 21631 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21648 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 21657 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 21665 "asllib/Parser0.ml"
                  
                in
                
# 470 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21679 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21688 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21694 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21700 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 21777 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21794 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 21801 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 21806 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 470 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21821 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21830 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21836 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21842 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 21926 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 21943 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 21952 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 470 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 21967 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 21976 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 21982 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 21988 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = ty;
                          MenhirLib.EngineTypes.startp = _startpos_ty_;
                          MenhirLib.EngineTypes.endp = _endpos_ty_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined3, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22078 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 22085 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 22090 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 22096 "asllib/Parser0.ml"
                 in
                
# 470 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 22109 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22118 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 22124 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22130 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = ty;
                            MenhirLib.EngineTypes.startp = _startpos_ty_;
                            MenhirLib.EngineTypes.endp = _endpos_ty_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_ty_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 22227 "asllib/Parser0.ml"
                   _3_1
                in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 22236 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 22242 "asllib/Parser0.ml"
                 in
                
# 470 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = Some ty
        and subprogram_type = ST_Getter
        and recurse_limit = None
        and body = SB_ASL body
        and parameters = [] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 22255 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_ty_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 22264 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 22270 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22276 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 22344 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 22350 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22362 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 22368 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22373 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22382 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 22390 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22396 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 22471 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 22477 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22489 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 22495 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22500 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22509 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 22517 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22523 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 22598 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 22604 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22616 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 22624 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22633 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 22641 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22647 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 22729 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 22735 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22747 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 22755 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 22764 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 22772 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22778 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 22834 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 22846 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 22852 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22857 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 22866 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22872 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 22935 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 22947 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 22953 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 22958 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 22967 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 22973 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23036 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23048 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23056 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 23065 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23071 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23141 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23153 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23161 "asllib/Parser0.ml"
                
              in
              let _2 = _1_inlined1 in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 23170 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23176 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23240 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 23246 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23251 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 340 "asllib/Parser0.mly"
              ( "record" )
# 23259 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 23267 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23273 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23344 "asllib/Parser0.ml"
               in
              let _3 =
                let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 23350 "asllib/Parser0.ml"
                 in
                
# 205 "<standard.mly>"
    ( x )
# 23355 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 340 "asllib/Parser0.mly"
              ( "record" )
# 23363 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 23371 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23377 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 123 "<standard.mly>"
    ( None )
# 23448 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23456 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 340 "asllib/Parser0.mly"
              ( "record" )
# 23464 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 23472 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23478 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let x : unit = Obj.magic x in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.typed_identifier list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.ty) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _4 = 
# 126 "<standard.mly>"
    ( Some x )
# 23556 "asllib/Parser0.ml"
               in
              let _3 =
                let _1_inlined1 = _1_inlined3 in
                let x = _1_inlined1 in
                
# 205 "<standard.mly>"
    ( x )
# 23564 "asllib/Parser0.ml"
                
              in
              let _2 =
                let _1 = _1_inlined1 in
                
# 340 "asllib/Parser0.mly"
              ( "record" )
# 23572 "asllib/Parser0.ml"
                
              in
              _5
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 23580 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23586 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23673 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23680 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 23686 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined2, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23702 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name =
                  let _2 = _2_inlined1 in
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 23712 "asllib/Parser0.ml"
                  
                in
                
# 488 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 23727 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23736 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 23742 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23748 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23823 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23830 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23846 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = _1 in
                
# 488 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 23863 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 23872 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 23878 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 23884 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 23959 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let ty : (AST.ty) = Obj.magic ty in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined3, _2_inlined1, _1_inlined2) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 23978 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined1 in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 23985 "asllib/Parser0.ml"
                 in
                
# 488 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_EmptySetter
        and recurse_limit = None
        and args = [ (ident, ty) ] in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 23999 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24008 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 24014 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24020 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = q;
                                  MenhirLib.EngineTypes.startp = _startpos_q_;
                                  MenhirLib.EngineTypes.endp = _endpos_q_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24119 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24128 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 24134 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined4, _2_inlined1, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24150 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 24158 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 24163 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24171 "asllib/Parser0.ml"
                  
                in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 24186 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24195 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 24201 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24207 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = q;
                                    MenhirLib.EngineTypes.startp = _startpos_q_;
                                    MenhirLib.EngineTypes.endp = _endpos_q_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24312 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24322 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 24328 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24344 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 24354 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 24362 "asllib/Parser0.ml"
                  
                in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 24377 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24386 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 24392 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24398 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24485 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24494 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24510 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 24518 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 24523 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 24539 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24548 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 24554 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24560 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24653 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24663 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24679 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 24689 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 24705 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24714 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 24720 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24726 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24813 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 24834 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined2 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 24842 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 24847 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 24853 "asllib/Parser0.ml"
                 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 24867 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 24876 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 24882 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 24888 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = ty;
                      MenhirLib.EngineTypes.startp = _startpos_ty_;
                      MenhirLib.EngineTypes.endp = _endpos_ty_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 24981 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let body =
                  let (_1_inlined1, _1) = (_1_inlined5, _1_inlined4) in
                  let _3 = _1_inlined1 in
                  let _3_1 = _3 in
                  
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 25003 "asllib/Parser0.ml"
                   _3_1
                in
                let ident = _1_inlined3 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25013 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 25019 "asllib/Parser0.ml"
                 in
                
# 499 "asllib/Parser0.mly"
      (
        let open AST in
        let return_type = None
        and parameters = []
        and body = SB_ASL body
        and subprogram_type = ST_Setter
        and recurse_limit = None
        and args = (ident, ty) :: args in
        D_Func { name; args; return_type; body; parameters; subprogram_type; recurse_limit }
      )
# 25033 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 25042 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 25048 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25054 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25120 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25127 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 25133 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25144 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 25150 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25158 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25166 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25172 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25245 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25252 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 25258 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 25269 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 25275 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25283 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25291 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25297 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25375 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25384 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 25390 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25401 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 25409 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25414 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 25420 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25429 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25437 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25443 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25528 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25537 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 25543 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 25554 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 25562 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 25567 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 25573 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25582 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25590 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25596 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25680 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25690 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 25696 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25707 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25717 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 25723 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25732 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25740 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25746 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = q;
                                MenhirLib.EngineTypes.startp = _startpos_q_;
                                MenhirLib.EngineTypes.endp = _endpos_q_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25837 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25847 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 25853 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 25864 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 25874 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 25880 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _2 = _2_inlined1 in
                let i = _1 in
                
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 25889 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25897 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25903 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25957 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 25964 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 25975 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 25981 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 25988 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 25994 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26055 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26062 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26073 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26079 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26086 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26092 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26158 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26167 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26178 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 26186 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26191 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26197 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26205 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26211 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26284 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26293 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26304 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 26312 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26317 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26323 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26331 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26337 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26409 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26419 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26430 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26440 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26446 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26454 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26460 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26539 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26549 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26560 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 26570 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26576 "asllib/Parser0.ml"
                
              in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26584 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26590 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26644 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26658 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26664 "asllib/Parser0.ml"
               in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 26669 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26676 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26682 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26743 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26757 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined1 in
              let _2 = 
# 123 "<standard.mly>"
    ( None )
# 26763 "asllib/Parser0.ml"
               in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 26768 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26775 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26781 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26847 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 26863 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 26871 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 26876 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 26882 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 26888 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 26895 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 26901 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 26974 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 26990 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined2 in
              let _2 =
                let x =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 26998 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 27003 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27009 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 27015 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 27022 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27028 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27100 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 123 "<standard.mly>"
    ( None )
# 27117 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27127 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27133 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 27139 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 27146 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27152 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let x : unit = Obj.magic x in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27231 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.typed_identifier list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _1 =
              let _6 = 
# 126 "<standard.mly>"
    ( Some x )
# 27248 "asllib/Parser0.ml"
               in
              let _5 = _1_inlined3 in
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 27258 "asllib/Parser0.ml"
                  
                in
                
# 126 "<standard.mly>"
    ( Some x )
# 27264 "asllib/Parser0.ml"
                
              in
              let _1 = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 27270 "asllib/Parser0.ml"
               in
              _7
            in
            
# 255 "asllib/Parser0.mly"
                                ( None )
# 27277 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27283 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27346 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let x = _1_inlined1 in
                  
# 264 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 27365 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27371 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27380 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 27386 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27392 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = ty;
                MenhirLib.EngineTypes.startp = _startpos_ty_;
                MenhirLib.EngineTypes.endp = _endpos_ty_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let ty : (AST.ty) = Obj.magic ty in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27467 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 27473 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 281 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 27495 "asllib/Parser0.ml"
                    
                  in
                  
# 264 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ty, None)) )
# 27501 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27507 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27516 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 27522 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27528 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27598 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 27620 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27629 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 266 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 27636 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27642 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27651 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 27657 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27663 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (AST.field list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27745 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 27751 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined4 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let fields =
                    let (_startpos__1_, _1_inlined1) = (_startpos__1_inlined2_, _1_inlined3) in
                    let desc =
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 27774 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27783 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 281 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 27792 "asllib/Parser0.ml"
                    
                  in
                  
# 266 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from fields (T_Record fields.desc), None)) )
# 27798 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27804 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27813 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 27819 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27825 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 27895 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 27915 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27923 "asllib/Parser0.ml"
                    
                  in
                  let x = _1_inlined1 in
                  
# 268 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 27930 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 27936 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 27945 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 27951 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 27957 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let x : (string list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 28039 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 28045 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined3 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let li =
                    let _startpos__1_ = _startpos__1_inlined2_ in
                    let desc = 
# 205 "<standard.mly>"
    ( x )
# 28066 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28074 "asllib/Parser0.ml"
                    
                  in
                  let x =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 281 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28083 "asllib/Parser0.ml"
                    
                  in
                  
# 268 "asllib/Parser0.mly"
          ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Enum li.desc), None)) )
# 28089 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28095 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28104 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 28110 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28116 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 28165 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 28187 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28196 "asllib/Parser0.ml"
                    
                  in
                  let t = _1_inlined1 in
                  
# 271 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 28203 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28209 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28218 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 28224 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28230 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 28291 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 28297 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let _2 =
                  let _1 = _1_inlined2 in
                  _2
                in
                let x =
                  let _2 = _2_inlined1 in
                  let ty =
                    let _endpos__0_ = _endpos__1_inlined1_ in
                    let desc =
                      let _1 = () in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 28320 "asllib/Parser0.ml"
                      
                    in
                    let _endpos_desc_ = _endpos__0_ in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _endpos in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28329 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let _1 = _1_inlined1 in
                    let i = _1 in
                    
# 281 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28338 "asllib/Parser0.ml"
                    
                  in
                  
# 271 "asllib/Parser0.mly"
          ( AST.D_TypeDecl (t, ty, None) )
# 28344 "asllib/Parser0.ml"
                  
                in
                
# 196 "<standard.mly>"
    ( x )
# 28350 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28359 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 28365 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28371 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 28441 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 28456 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28464 "asllib/Parser0.ml"
                  
                in
                let x = _1_inlined1 in
                
# 275 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 28471 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28480 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 28486 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28492 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _5;
            MenhirLib.EngineTypes.startp = _startpos__5_;
            MenhirLib.EngineTypes.endp = _endpos__5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.decl option list) = Obj.magic xs in
        let _5 : unit = Obj.magic _5 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.field list) = Obj.magic x in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 28574 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 28580 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let desc =
                let li =
                  let (_endpos__3_, _startpos__1_) = (_endpos__3_inlined1_, _startpos__1_inlined2_) in
                  let desc = 
# 205 "<standard.mly>"
    ( x )
# 28595 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28603 "asllib/Parser0.ml"
                  
                in
                let x =
                  let _1 = _1_inlined1 in
                  let i = _1 in
                  
# 281 "asllib/Parser0.mly"
                               ( q ^ "_" ^ i )
# 28612 "asllib/Parser0.ml"
                  
                in
                
# 275 "asllib/Parser0.mly"
        ( AST.(D_TypeDecl (x, ASTUtils.add_pos_from li (T_Record li.desc), None)) )
# 28618 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__5_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28627 "asllib/Parser0.ml"
              
            in
            
# 225 "asllib/Parser0.mly"
                      Some  
# 28633 "asllib/Parser0.ml"
             x
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28639 "asllib/Parser0.ml"
           : (AST.decl option list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.expr) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 28658 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = c;
                MenhirLib.EngineTypes.startp = _startpos_c_;
                MenhirLib.EngineTypes.endp = _endpos_c_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic xs in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = (c, e) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28717 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28723 "asllib/Parser0.ml"
           : ((AST.expr * AST.expr) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 28742 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 28823 "asllib/Parser0.ml"
                 _3_1
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28834 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 28840 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 28947 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 28954 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28963 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 28969 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 28978 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 28986 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 28992 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29001 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29012 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29018 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29144 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 29150 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29158 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29167 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29173 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29182 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29190 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29196 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29205 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29216 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29222 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29290 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 29296 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29307 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29313 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 29372 "asllib/Parser0.ml"
                
              in
              (expr, possibly_empty_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29383 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29389 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : ((AST.expr * AST.stmt) AST.annotated list) = 
# 216 "<standard.mly>"
    ( [] )
# 29408 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic xs in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29467 "asllib/Parser0.ml"
                 _1_1
              in
              (expr, simple_stmt_list)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29478 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29484 "asllib/Parser0.ml"
           : ((AST.expr * AST.stmt) AST.annotated list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.stmt list) = 
# 216 "<standard.mly>"
    ( [] )
# 29503 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29585 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29592 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29601 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29607 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29616 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29624 "asllib/Parser0.ml"
                 _1_1
              in
              
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29630 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29639 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29645 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29747 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 29753 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 29761 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29770 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 29776 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29785 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29793 "asllib/Parser0.ml"
                 _1_1
              in
              
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 29799 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29808 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29814 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 29858 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 29864 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29870 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 29957 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 29964 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 29974 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 29980 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 29989 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 29995 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30123 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30129 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30137 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30147 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30153 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30162 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30168 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 30321 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30328 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30337 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30343 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30352 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30360 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30366 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30375 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30381 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30389 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30399 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30405 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30414 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30420 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30592 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 30598 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 30606 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30615 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 30621 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30630 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30638 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 30644 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30653 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30659 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30667 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30677 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30683 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30692 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30698 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 30812 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 30818 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30824 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30832 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30842 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30848 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 30857 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 30863 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 30968 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 30974 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 30982 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 30992 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 30998 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31007 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31013 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31121 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31128 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31142 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31149 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31158 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31164 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31173 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31181 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31187 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31196 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31202 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31211 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31217 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 31366 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31372 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31380 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31394 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31401 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31410 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31416 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31425 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31433 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31439 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31448 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31454 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31463 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31469 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31643 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31650 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31659 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31665 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31674 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31682 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31688 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31697 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 31703 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 31711 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 31725 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 31732 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31741 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 31747 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31756 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31764 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 31770 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31779 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 31785 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 31794 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 31800 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 31993 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 31999 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32007 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32016 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32022 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32031 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32039 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32045 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32054 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32060 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32068 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32082 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32089 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32098 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32104 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32113 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32121 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32127 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32136 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32142 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32151 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32157 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32292 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 32298 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32304 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32312 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32326 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32333 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32342 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32348 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32357 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32365 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32371 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32380 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32386 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32395 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32401 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 32527 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 32533 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32541 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32555 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32562 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32571 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32577 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32586 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32594 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32600 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32609 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32615 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32624 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32630 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 32752 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 32759 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32778 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 32784 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 32792 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32801 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 32807 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32816 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 32824 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 32830 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32839 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 32845 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 32854 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 32860 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 33023 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33029 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33037 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33056 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 33062 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33070 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33079 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33085 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33094 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33102 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33108 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33117 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33123 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33132 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33138 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 33326 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33333 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33342 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33348 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33357 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33365 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33371 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33380 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33386 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33394 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33413 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 33419 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33427 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33436 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33442 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33451 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33459 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33465 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33474 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33480 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33489 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33495 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33702 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 33708 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33716 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33725 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33731 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33740 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33748 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33754 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33763 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 33769 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 33777 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33796 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 33802 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 33810 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33819 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 33825 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33834 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 33842 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 33848 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33857 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 33863 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 33872 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 33878 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34027 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 34033 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34039 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34047 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34066 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34072 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34080 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34089 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34095 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34104 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34112 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34118 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34127 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34133 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34142 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34148 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 34288 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34294 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34302 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34321 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 34327 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34335 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34344 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34350 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34359 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34367 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34373 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34382 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34388 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34397 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34403 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34476 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34483 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34493 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 34499 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34505 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34514 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34520 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 34634 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34640 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34648 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34658 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 34664 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34670 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34679 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34685 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 34824 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 34831 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34840 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 34846 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34855 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34863 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 34869 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34878 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 34884 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 34892 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 34902 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 34908 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 34914 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 34923 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 34929 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35087 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 35093 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35101 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35110 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35116 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35125 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35133 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35139 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35148 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35154 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35162 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35172 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35178 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35184 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35193 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35199 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35299 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 35305 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35311 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35319 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35329 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35335 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35341 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35350 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35356 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35447 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35453 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35461 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35471 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 35477 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35483 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35492 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35498 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35564 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35571 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35579 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35585 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35594 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35600 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 35707 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35713 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35721 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35729 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35735 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35744 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35750 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 35882 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 35889 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35898 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 35904 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35913 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 35921 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 35927 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35936 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 35942 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 35950 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 35958 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 35964 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 35973 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 35979 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36130 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 36136 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36144 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36153 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 36159 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36168 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36176 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 36182 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36191 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36197 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36205 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36213 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36219 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36228 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36234 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36327 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 36333 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36339 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36347 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36355 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36361 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36370 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36376 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36460 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 36466 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 36474 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 36482 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36488 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36497 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36503 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36595 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 225 "asllib/Parser0.mly"
                      Some  
# 36601 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 36609 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 36618 "asllib/Parser0.ml"
                 _1_1
              in
              
# 651 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 36624 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36633 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36639 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 652 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 36718 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36727 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36733 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 36824 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 36840 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 36846 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                       ( AST.Up )
# 36853 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 36860 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 36869 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 36875 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 36980 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 36996 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37005 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                       ( AST.Up )
# 37013 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37020 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37029 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37035 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 37126 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37142 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 37148 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                                            ( AST.Down )
# 37155 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37162 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37171 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37177 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 37282 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37298 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37307 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                                            ( AST.Down )
# 37315 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 37322 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37331 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37337 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37419 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 37425 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 699 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 37431 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37440 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37446 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37542 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37551 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 699 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 37558 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37567 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37573 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 37665 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37674 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 701 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 37681 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37690 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37696 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 37805 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37815 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 701 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 37822 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37831 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37837 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 37930 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 37949 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 37960 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 37970 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 37979 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 37985 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 38113 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38139 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38148 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 38154 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38166 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38176 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38185 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38191 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 38340 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 38370 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 38377 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38386 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 38392 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38401 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38409 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 38415 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38424 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38433 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 38439 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38451 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38461 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38470 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38476 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 38639 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38674 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 38680 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 38688 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38697 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 38703 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38712 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38720 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 38726 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38735 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38744 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 38750 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38762 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38772 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38781 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38787 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 38901 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 38927 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 38933 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38942 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 38948 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 38960 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 38970 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 38979 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 38985 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 39092 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 39116 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39125 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 39131 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39143 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 39153 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39162 "asllib/Parser0.ml"
            
          in
          (
# 219 "<standard.mly>"
    ( x :: xs )
# 39168 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let _menhir_s = _menhir_env.MenhirLib.EngineTypes.current in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _endpos = _startpos in
        let _v : (AST.bitfield list) = 
# 145 "<standard.mly>"
    ( [] )
# 39187 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.bitfield list) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.bitfield list) = 
# 148 "<standard.mly>"
    ( x )
# 39212 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39278 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39286 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 39330 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39338 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let (_1_inlined1, _2, _1) = (_1_inlined2, _2_inlined1, _1_inlined1) in
              let _3 = _1_inlined1 in
              let _3_1 = _3 in
              
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 39412 "asllib/Parser0.ml"
               _3_1
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 39420 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (unit list) = Obj.magic xs in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _3 =
              let _1 = _1_inlined1 in
              
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 39471 "asllib/Parser0.ml"
              
            in
            ()
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 39479 "asllib/Parser0.ml"
           : (unit list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 39514 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 284 "asllib/Parser0.mly"
                               ( (x, t) )
# 39527 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 39533 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39539 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.field list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 39581 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let x = _1 in
              
# 284 "asllib/Parser0.mly"
                               ( (x, t) )
# 39594 "asllib/Parser0.ml"
              
            in
            
# 196 "<standard.mly>"
    ( x )
# 39600 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 39606 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = le;
                MenhirLib.EngineTypes.startp = _startpos_le_;
                MenhirLib.EngineTypes.endp = _endpos_le_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 589 "asllib/Parser0.mly"
                                AST.S_Assign  
# 39658 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 39664 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39673 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39679 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 39728 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 39745 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39753 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39759 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39765 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39771 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39780 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39786 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 39848 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 39855 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39863 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39869 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39875 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39881 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39890 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 39896 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 39945 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 39962 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39970 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 39976 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 39982 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 39988 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 39997 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40003 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 40065 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 40072 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40080 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40086 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40092 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40098 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40107 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40113 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40162 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 40179 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40187 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40193 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40199 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40205 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40214 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40220 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 40282 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 40289 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40297 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40303 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40309 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40315 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40324 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40330 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40379 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40384 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 40402 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40411 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40417 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40423 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40429 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40438 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40444 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40494 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 40510 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 40519 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40528 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40534 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40540 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40546 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40555 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40561 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40622 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40627 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 40633 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 40653 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 40659 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40668 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40674 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40680 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40686 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40695 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40701 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40763 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 40769 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 40786 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 40796 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 40802 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40811 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40817 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40823 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40829 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40838 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40844 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 40893 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 40910 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40918 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 40924 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 40930 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 40936 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 40945 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 40951 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 41013 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 41020 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41028 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41034 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41040 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41046 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41055 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41061 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 41128 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41150 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 41155 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41164 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41170 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41176 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41182 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41191 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41197 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 41280 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41289 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 41294 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41303 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41309 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41315 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41321 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41330 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41336 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 41421 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 41449 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41455 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 41460 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41469 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41475 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41481 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41487 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41496 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41502 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined4 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 41606 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 41618 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 41624 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 41629 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41638 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41644 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41650 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41656 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41665 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41671 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 41738 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 41761 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 41768 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41777 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41783 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41789 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41795 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41804 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41810 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 41893 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 41903 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 41910 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41919 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 41925 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 41931 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 41937 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 41946 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 41952 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42031 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42039 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42065 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42073 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42082 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42088 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42094 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42100 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42109 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42115 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42198 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 42216 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42231 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42239 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42248 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42254 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42260 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42266 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42275 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42281 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42372 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42380 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 42386 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42413 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42421 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42429 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42438 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42444 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42450 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42456 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42465 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42471 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42566 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 42572 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 42591 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 42606 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42614 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42622 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42631 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42637 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42643 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42649 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42658 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42664 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 42755 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42788 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42796 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42805 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42811 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42817 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 42823 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42832 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 42838 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 42950 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 42965 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 42973 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 42982 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 42988 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 42994 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43000 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43009 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43015 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 43070 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 43088 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43096 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43102 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43108 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43114 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43123 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43129 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 43198 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 43205 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43213 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43219 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43225 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43231 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43240 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43246 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 43301 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 43319 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43327 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43333 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43339 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43345 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43354 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43360 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 43429 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 43436 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43444 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43450 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43456 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43462 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43471 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43477 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 43532 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 43550 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43558 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43564 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43570 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43576 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43585 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43591 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 43660 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 43667 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43675 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43681 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43687 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43693 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43702 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43708 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 43763 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 43768 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 43787 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43796 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43802 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43808 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43814 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43823 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43829 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 43885 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 43902 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 43911 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43920 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 43926 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 43932 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 43938 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 43947 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 43953 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 44020 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 44025 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 44031 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 44052 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 44058 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44067 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44073 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44079 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44085 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44094 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44100 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 44168 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 44174 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 44192 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 44202 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 44208 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44217 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44223 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44229 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44235 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44244 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44250 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 44305 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 44323 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44331 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44337 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44343 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44349 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44358 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44364 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 44433 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 44440 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44448 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44454 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44460 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44466 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44475 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44481 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 44554 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 44577 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 44582 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44591 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44597 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44603 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44609 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44618 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44624 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 44714 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 44723 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 44728 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44737 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44743 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44749 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44755 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44764 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44770 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : (
# 74 "asllib/Parser0.mly"
       (string)
# 44861 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 44890 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 44896 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 44901 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44910 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 44916 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 44922 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 44928 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 44937 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 44943 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = x_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined4 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 45054 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 45066 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 45072 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 45077 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45086 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45092 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45098 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45104 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45113 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45119 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 45192 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 45216 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45223 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45232 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45238 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45244 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45250 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45259 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45265 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 45355 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 45365 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45372 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45381 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45387 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45393 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45399 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45408 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45414 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 45499 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 45507 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 45534 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45542 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45551 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45557 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45563 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45569 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45578 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45584 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 45673 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 45692 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 45707 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45715 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45724 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45730 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45736 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45742 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45751 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45757 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 45854 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 45862 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 45868 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 45896 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 45904 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 45912 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45921 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 45927 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 45933 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 45939 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 45948 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 45954 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = q;
                            MenhirLib.EngineTypes.startp = _startpos_q_;
                            MenhirLib.EngineTypes.endp = _endpos_q_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 46055 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 46061 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 46081 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 46096 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46104 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46112 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46121 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46127 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46133 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46139 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46148 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46154 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 46251 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46285 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46293 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46302 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46308 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46314 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46320 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46329 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46335 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 46454 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 46469 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 46477 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46486 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 46492 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 46498 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46504 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46513 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46519 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 46568 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 595 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some expr)) )
# 46582 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46588 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46597 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46603 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = h;
                      MenhirLib.EngineTypes.startp = _startpos_h_;
                      MenhirLib.EngineTypes.endp = _endpos_h_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.local_decl_item list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let _1_inlined1 = _1_inlined2 in
                  let ldis =
                    let x =
                      let _1 = _1_inlined1 in
                      let t = _1 in
                      
# 292 "asllib/Parser0.mly"
                                           ( h::t )
# 46696 "asllib/Parser0.ml"
                      
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 46702 "asllib/Parser0.ml"
                    
                  in
                  
# 628 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 46708 "asllib/Parser0.ml"
                  
                in
                
# 597 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, ldi, Some e) )
# 46714 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 46720 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46729 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46735 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 46781 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46789 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 46795 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 46801 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46810 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46816 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 46862 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46870 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 46876 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 46882 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46891 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46897 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 46943 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46951 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 46957 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 46963 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 46972 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 46978 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 47014 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 47030 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47039 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47045 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47051 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47060 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47066 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 47114 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 47120 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 47138 "asllib/Parser0.ml"
                      
                    in
                    
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 47144 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47153 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47159 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47165 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47174 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47180 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 47226 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47234 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47240 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47246 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47255 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47261 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 47329 "asllib/Parser0.ml"
                     in
                    
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 47334 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47343 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47349 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47355 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47364 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47370 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 47462 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 47468 "asllib/Parser0.ml"
                     in
                    
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 47473 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47482 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47488 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47494 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47503 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47509 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 47578 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47585 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47594 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47600 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47606 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47615 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47621 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 47690 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47714 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47722 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47731 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47737 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47743 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47752 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47758 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 47839 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 47845 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 47870 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 47878 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 47886 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47895 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 47901 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 47907 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 47916 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 47922 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 48026 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 48034 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48043 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 48049 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 48055 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48064 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48070 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 48125 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 48131 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 48144 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 48150 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 48155 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 48163 "asllib/Parser0.ml"
                  
                in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48169 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48175 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48184 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48190 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 48252 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 48258 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 48271 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 48279 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 48287 "asllib/Parser0.ml"
                  
                in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48293 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48299 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48308 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48314 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 48357 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 48369 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 48375 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 48380 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48387 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48393 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48402 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48408 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 48458 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 48470 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 48478 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48485 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48491 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48500 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48506 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 48557 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 48563 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 48568 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 48574 "asllib/Parser0.ml"
                 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48579 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48585 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48594 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48600 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 48658 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 48666 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 48672 "asllib/Parser0.ml"
                 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 48677 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 48683 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48692 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48698 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 48735 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 569 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 48741 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 48747 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48756 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48762 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 48806 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 569 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 48812 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 48818 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48827 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48833 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = expr;
            MenhirLib.EngineTypes.startp = _startpos_expr_;
            MenhirLib.EngineTypes.endp = _endpos_expr_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 570 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 48876 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 48881 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48890 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48896 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = e;
            MenhirLib.EngineTypes.startp = _startpos_e_;
            MenhirLib.EngineTypes.endp = _endpos_e_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x = 
# 571 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; debug = true } )
# 48939 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 48944 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 48953 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 48959 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 48997 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49004 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49010 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49019 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49025 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 49080 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 49086 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49094 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49100 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49109 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49115 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49153 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49159 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49168 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49174 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 49222 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 49240 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49248 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49254 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49263 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49269 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 49307 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49314 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49320 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49329 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49335 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 49390 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 49396 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49404 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49410 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49419 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49425 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 49463 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49470 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49476 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49485 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49491 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 49526 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 49540 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49547 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49553 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49562 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49568 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 49627 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49634 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49640 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49649 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49655 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 49690 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49705 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49711 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49720 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49726 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 49761 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49778 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49784 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49793 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49799 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 49834 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 49851 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 49857 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49866 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 49872 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = le;
                  MenhirLib.EngineTypes.startp = _startpos_le_;
                  MenhirLib.EngineTypes.endp = _endpos_le_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let le : (AST.lexpr) = Obj.magic le in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_le_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                
# 589 "asllib/Parser0.mly"
                                AST.S_Assign  
# 49931 "asllib/Parser0.ml"
                 (le, e)
              in
              
# 196 "<standard.mly>"
    ( x )
# 49937 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_le_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 49946 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 49952 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50008 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 50025 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50033 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50039 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50045 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50051 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50060 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50066 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 50135 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 50142 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50150 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50156 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50162 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50168 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50177 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50183 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50239 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 50256 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50264 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50270 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50276 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50282 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50291 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50297 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 50366 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 50373 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50381 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50387 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50393 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50399 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50408 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50414 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50470 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 50487 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50495 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50501 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50507 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50513 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50522 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50528 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 50597 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 50604 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50612 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50618 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50624 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50630 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50639 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50645 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50701 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50706 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 50724 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50733 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50739 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50745 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50751 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50760 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50766 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50823 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 50839 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 50848 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50857 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 50863 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 50869 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 50875 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 50884 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 50890 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50958 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 50963 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 50969 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 50989 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 50995 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51004 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51010 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51016 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51022 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51031 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51037 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 51106 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 51112 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 51129 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 51139 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 51145 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51154 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51160 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51166 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51172 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51181 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51187 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 51243 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 51260 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51268 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51274 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51280 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51286 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51295 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51301 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 51370 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 51377 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51385 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51391 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51397 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51403 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51412 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51418 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 51492 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 51514 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 51519 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51528 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51534 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51540 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51546 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51555 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51561 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 51651 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 51660 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 51665 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51674 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51680 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51686 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51692 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51701 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51707 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 51799 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 51827 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 51833 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 51838 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51847 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 51853 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 51859 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 51865 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 51874 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 51880 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined4 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 51991 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 52003 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 52009 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 52014 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52023 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52029 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52035 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52041 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52050 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52056 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52130 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 52153 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52160 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52169 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52175 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52181 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52187 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52196 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52202 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 52292 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 52302 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52309 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52318 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52324 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52330 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52336 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52345 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52351 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52437 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52445 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 52471 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52479 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52488 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52494 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52500 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52506 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52515 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52521 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52611 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 52629 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 52644 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52652 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52661 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52667 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52673 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52679 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52688 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52694 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52792 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52800 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 52806 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 52833 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 52841 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 52849 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52858 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 52864 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 52870 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 52876 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 52885 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 52891 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 52993 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 52999 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 53018 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 53033 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53041 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53049 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53058 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53064 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53070 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53076 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53085 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53091 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 53189 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53222 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53230 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53239 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53245 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53251 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53257 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53266 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53272 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _2_inlined2 : unit = Obj.magic _2_inlined2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined2 in
                let ldi =
                  let _2 = _2_inlined1 in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 53391 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 53406 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 53414 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53423 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53429 "asllib/Parser0.ml"
                  
                in
                
# 591 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Var, ldi, Some expr)) )
# 53435 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53441 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53450 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53456 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 53518 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 53536 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53544 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53550 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53556 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53562 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53571 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53577 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 53653 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 53660 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53668 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53674 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53680 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53686 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53695 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53701 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 53763 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 53781 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53789 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53795 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53801 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53807 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53816 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53822 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 53898 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 53905 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53913 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 53919 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 53925 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 53931 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 53940 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 53946 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54008 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 54026 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54034 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54040 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54046 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54052 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54061 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54067 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 54143 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 54150 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54158 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54164 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54170 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54176 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54185 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54191 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54253 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54258 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 54277 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54286 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54292 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54298 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54304 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54313 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54319 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54382 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 54399 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident = _1 in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 54408 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54417 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54423 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54429 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54435 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54444 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54450 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54524 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54529 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 54535 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54556 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 54562 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54571 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54577 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54583 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54589 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54598 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54604 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54679 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 54685 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_endpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 54703 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let tident =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 54713 "asllib/Parser0.ml"
                        
                      in
                      
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 54719 "asllib/Parser0.ml"
                       tident
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54728 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54734 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54740 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54746 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54755 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54761 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 54823 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x = _1_inlined1 in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 54841 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54849 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54855 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54861 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54867 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54876 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 54882 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 54958 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 54965 "asllib/Parser0.ml"
                     in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 54973 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 54979 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 54985 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 54991 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55000 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55006 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 55086 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55109 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 55114 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55123 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55129 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55135 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55141 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55150 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55156 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 55253 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55262 "asllib/Parser0.ml"
                       in
                      
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 55267 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55276 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55282 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55288 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55294 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55303 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55309 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : (
# 74 "asllib/Parser0.mly"
       (string)
# 55407 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x = _1_inlined4 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 55436 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55442 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 55447 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55456 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55462 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55468 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55474 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55483 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55489 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = x_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined4 : (AST.bitfield list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_inlined1_, _startpos__1_, _1_inlined4, _1_inlined3, _1) = (_endpos__3_inlined2_, _startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined4 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 55607 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let b =
                        let _1_inlined1 = _1_inlined3 in
                        let x = _1_inlined1 in
                        
# 205 "<standard.mly>"
    ( x )
# 55619 "asllib/Parser0.ml"
                        
                      in
                      let e = 
# 205 "<standard.mly>"
    ( x )
# 55625 "asllib/Parser0.ml"
                       in
                      
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 55630 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55639 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55645 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55651 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55657 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55666 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55672 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 55752 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined2 in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 55776 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55783 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55792 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55798 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55804 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55810 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55819 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55825 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x_inlined1 : (AST.expr) = Obj.magic x_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_endpos__3_, _startpos__1_, _1_inlined2, _1) = (_endpos__3_inlined1_, _startpos__1_inlined1_, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined2 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 55922 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let x = x_inlined1 in
                    let desc =
                      let _1 =
                        let _2 = 
# 205 "<standard.mly>"
    ( x )
# 55932 "asllib/Parser0.ml"
                         in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 55939 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55948 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 55954 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 55960 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 55966 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 55975 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 55981 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56073 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56081 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56108 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56116 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56125 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56131 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56137 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56143 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56152 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56158 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56254 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 56273 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56288 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56296 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56305 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56311 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56317 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56323 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56332 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56338 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56442 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56450 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 56456 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56484 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56492 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56500 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56509 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56515 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56521 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56527 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56536 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56542 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = q;
                              MenhirLib.EngineTypes.startp = _startpos_q_;
                              MenhirLib.EngineTypes.endp = _endpos_q_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56650 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 56656 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined2, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 56676 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1 =
                              let i = _1 in
                              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 56691 "asllib/Parser0.ml"
                              
                            in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56699 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56707 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56716 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56722 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56728 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56734 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56743 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56749 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : (
# 74 "asllib/Parser0.mly"
       (string)
# 56853 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x = _1_inlined3 in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 56887 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 56895 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56904 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 56910 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 56916 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 56922 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 56931 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 56937 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined3 : (AST.expr) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let (_startpos__1_, _1_inlined3, _3, _1_inlined2, _1) = (_startpos__1_inlined1_, _1_inlined4, _3_inlined3, _1_inlined3, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined3 in
                    
# 335 "asllib/Parser0.mly"
                                         ( "record" )
# 57063 "asllib/Parser0.ml"
                    
                  in
                  let t =
                    let desc =
                      let _1 =
                        let _2 =
                          let _1_inlined1 = _1_inlined2 in
                          let x =
                            let (_3, _1) = (_3_inlined1, _1_inlined1) in
                            ()
                          in
                          
# 205 "<standard.mly>"
    ( x )
# 57078 "asllib/Parser0.ml"
                          
                        in
                        ()
                      in
                      
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 57086 "asllib/Parser0.ml"
                      
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57095 "asllib/Parser0.ml"
                    
                  in
                  
# 606 "asllib/Parser0.mly"
                                                  ( AST.(LDI_Typed (LDI_Var x, t)) )
# 57101 "asllib/Parser0.ml"
                  
                in
                
# 593 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, ldi, Some expr)) )
# 57107 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57113 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57122 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57128 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 57184 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let x = _1_inlined1 in
                
# 595 "asllib/Parser0.mly"
        ( AST.(S_Decl (LDK_Let, LDI_Var x, Some expr)) )
# 57198 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57204 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57213 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57219 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = h;
                        MenhirLib.EngineTypes.startp = _startpos_h_;
                        MenhirLib.EngineTypes.endp = _endpos_h_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (AST.local_decl_item list) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let h : (AST.local_decl_item) = Obj.magic h in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let ldi =
                  let _1_inlined1 = _1_inlined2 in
                  let ldis =
                    let x =
                      let _1 = _1_inlined1 in
                      let t = _1 in
                      
# 292 "asllib/Parser0.mly"
                                           ( h::t )
# 57319 "asllib/Parser0.ml"
                      
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 57325 "asllib/Parser0.ml"
                    
                  in
                  
# 628 "asllib/Parser0.mly"
                                           ( AST.LDI_Tuple ldis )
# 57331 "asllib/Parser0.ml"
                  
                in
                
# 597 "asllib/Parser0.mly"
        ( AST.S_Decl (LDK_Let, ldi, Some e) )
# 57337 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 57343 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57352 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57358 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 57411 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57419 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57425 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57431 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57440 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57446 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 57499 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57507 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57513 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57519 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57528 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57534 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 57587 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57595 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57601 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57607 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57616 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57622 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 57665 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident = _1 in
                    
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 57681 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57690 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57696 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57702 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57711 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57717 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 57772 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 57778 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined1 in
                let t =
                  let desc =
                    let tident =
                      let i = _1 in
                      
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 57796 "asllib/Parser0.ml"
                      
                    in
                    
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 57802 "asllib/Parser0.ml"
                     tident
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57811 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57817 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57823 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57832 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57838 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined1 in
                let t =
                  let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 57891 "asllib/Parser0.ml"
                   in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57899 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 57905 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 57911 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 57920 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 57926 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 58001 "asllib/Parser0.ml"
                     in
                    
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 58006 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58015 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58021 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58027 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58036 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58042 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = x;
                        MenhirLib.EngineTypes.startp = _startpos_x_;
                        MenhirLib.EngineTypes.endp = _endpos_x_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (string list) = Obj.magic _1_inlined4 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined4 in
                let t =
                  let desc =
                    let b =
                      let _1_inlined1 = _1_inlined3 in
                      let x = _1_inlined1 in
                      
# 205 "<standard.mly>"
    ( x )
# 58141 "asllib/Parser0.ml"
                      
                    in
                    let e = 
# 205 "<standard.mly>"
    ( x )
# 58147 "asllib/Parser0.ml"
                     in
                    
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 58152 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58161 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58167 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58173 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58182 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58188 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (string list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined2 in
                let t =
                  let desc =
                    let _1 =
                      let _2 = 
# 205 "<standard.mly>"
    ( x )
# 58264 "asllib/Parser0.ml"
                       in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58271 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58280 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58286 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58292 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58301 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58307 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 58383 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58407 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58415 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58424 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58430 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58436 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58445 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58451 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = q;
                          MenhirLib.EngineTypes.startp = _startpos_q_;
                          MenhirLib.EngineTypes.endp = _endpos_q_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 58539 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 58545 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let _1 = _1_inlined1 in
                          let _1 =
                            let i = _1 in
                            
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 58570 "asllib/Parser0.ml"
                            
                          in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58578 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58586 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58595 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58601 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58607 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58616 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58622 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : (string list) = Obj.magic _1_inlined3 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let li = _1_inlined3 in
                let t =
                  let desc =
                    let _1 =
                      let _2 =
                        let _1_inlined1 = _1_inlined2 in
                        let x =
                          let (_3, _1) = (_3_inlined1, _1_inlined1) in
                          ()
                        in
                        
# 205 "<standard.mly>"
    ( x )
# 58733 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 58741 "asllib/Parser0.ml"
                    
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58750 "asllib/Parser0.ml"
                  
                in
                
# 598 "asllib/Parser0.mly"
                                                       make_ldi_vars  
# 58756 "asllib/Parser0.ml"
                 (t, li)
              in
              
# 196 "<standard.mly>"
    ( x )
# 58762 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58771 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58777 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 58839 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 58845 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 58858 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 58864 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 58869 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 58877 "asllib/Parser0.ml"
                  
                in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 58883 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 58889 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 58898 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 58904 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 58973 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 58979 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 58992 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 59000 "asllib/Parser0.ml"
                  
                in
                let name =
                  let i = _1 in
                  
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 59008 "asllib/Parser0.ml"
                  
                in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59014 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59020 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59029 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59035 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 59085 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 59097 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 59103 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 59108 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59115 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59121 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59130 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59136 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 59193 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 59205 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 59213 "asllib/Parser0.ml"
                  
                in
                let name = _1 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59220 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59226 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59235 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59241 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 59299 "asllib/Parser0.ml"
                 in
                let args =
                  let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 59305 "asllib/Parser0.ml"
                   in
                  
# 205 "<standard.mly>"
    ( x )
# 59310 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 59316 "asllib/Parser0.ml"
                 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59321 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59327 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59336 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59342 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 59407 "asllib/Parser0.ml"
                 in
                let args =
                  let _1_inlined1 = _1_inlined2 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 59415 "asllib/Parser0.ml"
                  
                in
                let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 59421 "asllib/Parser0.ml"
                 in
                
# 568 "asllib/Parser0.mly"
      ( AST.S_Call { name; args; params ; call_type = ST_Procedure } )
# 59426 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59432 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59441 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59447 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59491 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 569 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 59497 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 59503 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59512 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59518 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 59569 "asllib/Parser0.ml"
                 in
                let _2_1 = _2 in
                
# 569 "asllib/Parser0.mly"
                                                    AST.S_Return  
# 59575 "asllib/Parser0.ml"
                 _2_1
              in
              
# 196 "<standard.mly>"
    ( x )
# 59581 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59590 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59596 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 570 "asllib/Parser0.mly"
                                                    AST.S_Assert  
# 59646 "asllib/Parser0.ml"
               expr in
              
# 196 "<standard.mly>"
    ( x )
# 59651 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59660 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59666 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x = 
# 571 "asllib/Parser0.mly"
                                                  ( AST.S_Print { args = [ e ]; debug = true } )
# 59716 "asllib/Parser0.ml"
               in
              
# 196 "<standard.mly>"
    ( x )
# 59721 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59730 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59736 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 59781 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 59788 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59794 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59803 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59809 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 59871 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 59877 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 59885 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59891 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59900 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59906 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = () in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 59951 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 59957 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 59966 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 59972 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 60027 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x = _1_inlined1 in
                    
# 205 "<standard.mly>"
    ( x )
# 60045 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60053 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60059 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60068 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60074 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60119 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60126 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60132 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60141 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60147 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 =
                    let x =
                      let x = () in
                      
# 205 "<standard.mly>"
    ( x )
# 60209 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 60215 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60223 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60229 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60238 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60244 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60289 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60296 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60302 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60311 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60317 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 60359 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 60373 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60380 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60386 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60395 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60401 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 60467 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60474 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60480 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60489 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60495 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _2_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 60537 "asllib/Parser0.ml"
        ) = Obj.magic _2_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _2 = _2_inlined1 in
                let _1 = () in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60552 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60558 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60567 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60573 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 60615 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60632 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60638 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60647 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60653 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 60695 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 =
                  let _2 = _1_inlined1 in
                  ()
                in
                
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 60712 "asllib/Parser0.ml"
                
              in
              
# 196 "<standard.mly>"
    ( x )
# 60718 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60727 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 60733 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 60809 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60816 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60825 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60831 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60840 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60848 "asllib/Parser0.ml"
                 _1_1
              in
              
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 60854 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 60863 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 60869 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60964 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 60970 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 60978 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 60987 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 60993 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61002 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61010 "asllib/Parser0.ml"
                 _1_1
              in
              
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61016 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61025 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61031 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61068 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 61074 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61080 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined3;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined3_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 61160 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61167 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61177 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61183 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61192 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61198 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61319 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61325 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61333 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61343 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61349 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61358 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61364 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4;
                            MenhirLib.EngineTypes.startp = _startpos__4_;
                            MenhirLib.EngineTypes.endp = _endpos__4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 61510 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61517 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61526 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61532 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61541 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61549 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61555 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61564 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61570 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61578 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61588 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61594 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61603 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61609 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4;
                                MenhirLib.EngineTypes.startp = _startpos__4_;
                                MenhirLib.EngineTypes.endp = _endpos__4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61774 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 61780 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 61788 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61797 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 61803 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61812 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61820 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 61826 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61835 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61841 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 61849 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 61859 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 61865 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 61874 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 61880 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 61987 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 61993 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 61999 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62007 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62017 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62023 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62032 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62038 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 62136 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62142 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62150 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62160 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62166 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62175 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62181 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined5;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined5_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62282 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62289 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62303 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62310 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62319 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62325 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62334 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62342 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62348 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62357 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62363 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62372 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62378 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 62520 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62526 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62534 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62548 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62555 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62564 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62570 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62579 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62587 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62593 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62602 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62608 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62617 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62623 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62790 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62797 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62806 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62812 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62821 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62829 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62835 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62844 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 62850 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 62858 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 62872 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 62879 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62888 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 62894 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62903 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 62911 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 62917 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62926 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 62932 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 62941 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 62947 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63133 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 63139 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63147 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63156 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63162 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63171 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63179 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63185 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63194 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63200 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63208 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63222 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63229 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63238 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63244 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63253 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63261 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63267 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63276 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63282 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63291 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63297 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63425 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 63431 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63437 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63445 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63459 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63466 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63475 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63481 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63490 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63498 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63504 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63513 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63519 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63528 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63534 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 63653 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 63659 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63667 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63681 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63688 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63697 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63703 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63712 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63720 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63726 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63735 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63741 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63750 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63756 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined7;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined7_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 63871 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 63878 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63897 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 63903 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 63911 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63920 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 63926 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63935 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 63943 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 63949 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63958 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 63964 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 63973 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 63979 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined10;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _menhir_s;
                                            MenhirLib.EngineTypes.semv = _1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_;
                                            MenhirLib.EngineTypes.next = _menhir_stack;
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 64135 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64141 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64149 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64168 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 64174 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64182 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64191 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64197 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64206 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64214 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64220 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64229 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64235 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64244 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64250 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined12;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined10;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined9;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined8;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _6;
                            MenhirLib.EngineTypes.startp = _startpos__6_;
                            MenhirLib.EngineTypes.endp = _endpos__6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _3;
                                              MenhirLib.EngineTypes.startp = _startpos__3_;
                                              MenhirLib.EngineTypes.endp = _endpos__3_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = expr;
                                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 64431 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64438 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64447 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64453 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64462 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64470 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64476 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64485 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64491 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64499 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64518 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 64524 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64532 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64541 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64547 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64556 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64564 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64570 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64579 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64585 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64594 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64600 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined14;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined13;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined12;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined11;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined10;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined9;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined8;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined7;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined6;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined5;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined4;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _3;
                                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = expr;
                                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _menhir_s;
                                                      MenhirLib.EngineTypes.semv = _1;
                                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64800 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 64806 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64814 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64823 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64829 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64838 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64846 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64852 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64861 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 64867 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 64875 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64894 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 64900 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 64908 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64917 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 64923 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64932 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 64940 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 64946 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64955 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 64961 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 64970 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 64976 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65118 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 65124 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65130 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65138 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65157 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 65163 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65171 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65180 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65186 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65195 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65203 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65209 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65218 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65224 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65233 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65239 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined9;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined8;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined9_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 65372 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65378 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65386 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65405 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 65411 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65419 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65428 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65434 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65443 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65451 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65457 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65466 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65472 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65481 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65487 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65553 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65560 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65570 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 65576 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65582 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65591 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65597 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 65704 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65710 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65718 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65728 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 65734 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65740 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65749 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65755 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 65887 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 65894 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65903 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 65909 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65918 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65926 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 65932 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65941 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 65947 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 65955 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 65965 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 65971 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 65977 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 65986 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 65992 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66143 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 66149 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66157 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66166 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66172 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66181 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66189 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66195 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66204 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66210 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66218 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66228 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66234 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66240 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66249 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66255 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_inlined1_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66348 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 66354 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66360 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66368 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66378 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66384 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66390 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66399 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66405 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66489 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66495 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66503 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66513 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 66519 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66525 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66534 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66540 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined2;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66599 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66606 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66614 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66620 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66629 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66635 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 66735 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66741 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66749 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66757 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66763 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66772 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 66778 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr;
                                MenhirLib.EngineTypes.startp = _startpos_expr_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 66903 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 66910 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66919 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 66925 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66934 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 66942 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 66948 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66957 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 66963 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 66971 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 66979 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 66985 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 66994 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67000 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67144 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 67150 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67158 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67167 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 67173 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67182 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67190 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 67196 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67205 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67211 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67219 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67227 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67233 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67242 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67248 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67334 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 67340 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67346 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67354 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67362 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67368 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67377 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67383 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined4;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined4_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67460 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 67466 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 67474 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 67482 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67488 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67497 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67503 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _6;
          MenhirLib.EngineTypes.startp = _startpos__6_;
          MenhirLib.EngineTypes.endp = _endpos__6_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__6_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67588 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 225 "asllib/Parser0.mly"
                      Some  
# 67594 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 67602 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 67611 "asllib/Parser0.ml"
                 _1_1
              in
              
# 651 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 67617 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67626 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67632 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _5;
              MenhirLib.EngineTypes.startp = _startpos__5_;
              MenhirLib.EngineTypes.endp = _endpos__5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _4;
                MenhirLib.EngineTypes.startp = _startpos__4_;
                MenhirLib.EngineTypes.endp = _endpos__4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 652 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 67704 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67713 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67719 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 67803 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67819 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 67825 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                       ( AST.Up )
# 67832 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 67839 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 67848 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 67854 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 67952 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 67968 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 67977 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                       ( AST.Up )
# 67985 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 67992 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68001 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68007 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = end_e;
                  MenhirLib.EngineTypes.startp = _startpos_end_e_;
                  MenhirLib.EngineTypes.endp = _endpos_end_e_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = start_e;
                      MenhirLib.EngineTypes.startp = _startpos_start_e_;
                      MenhirLib.EngineTypes.endp = _endpos_start_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 68091 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68107 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 68113 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                                            ( AST.Down )
# 68120 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 68127 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68136 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68142 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = end_e;
                      MenhirLib.EngineTypes.startp = _startpos_end_e_;
                      MenhirLib.EngineTypes.endp = _endpos_end_e_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = start_e;
                          MenhirLib.EngineTypes.startp = _startpos_start_e_;
                          MenhirLib.EngineTypes.endp = _endpos_start_e_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 68240 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68256 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 68265 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                                            ( AST.Down )
# 68273 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 68280 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68289 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68295 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68370 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 68376 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 699 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 68382 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68391 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68397 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_inlined1_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68486 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 68495 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 699 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 68502 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68511 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68517 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 68602 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68611 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 701 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 68618 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68627 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68633 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _7;
          MenhirLib.EngineTypes.startp = _startpos__7_;
          MenhirLib.EngineTypes.endp = _endpos__7_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4;
                      MenhirLib.EngineTypes.startp = _startpos__4_;
                      MenhirLib.EngineTypes.endp = _endpos__4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__7_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 68735 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68745 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 701 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 68752 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68761 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68767 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _4_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _2;
                          MenhirLib.EngineTypes.startp = _startpos__2_;
                          MenhirLib.EngineTypes.endp = _endpos__2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 68853 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 68872 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 68883 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 68893 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 68902 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 68908 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined6;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined5;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _5;
                          MenhirLib.EngineTypes.startp = _startpos__5_;
                          MenhirLib.EngineTypes.endp = _endpos__5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _4_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _2;
                                    MenhirLib.EngineTypes.startp = _startpos__2_;
                                    MenhirLib.EngineTypes.endp = _endpos__2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 69029 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69055 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69064 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69070 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69082 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69092 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69101 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69107 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined6;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _5;
                                MenhirLib.EngineTypes.startp = _startpos__5_;
                                MenhirLib.EngineTypes.endp = _endpos__5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _4_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _2;
                                          MenhirLib.EngineTypes.startp = _startpos__2_;
                                          MenhirLib.EngineTypes.endp = _endpos__2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 69249 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 69279 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69286 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69295 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69301 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69310 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69318 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69324 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69333 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69342 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69348 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69360 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69370 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69379 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69385 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined11;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined10;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined7;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined6;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined5;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _5;
                                    MenhirLib.EngineTypes.startp = _startpos__5_;
                                    MenhirLib.EngineTypes.endp = _endpos__5_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3;
                                        MenhirLib.EngineTypes.startp = _startpos__3_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _4_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _2;
                                              MenhirLib.EngineTypes.startp = _startpos__2_;
                                              MenhirLib.EngineTypes.endp = _endpos__2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _menhir_s;
                                                  MenhirLib.EngineTypes.semv = _1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 69541 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69576 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 69582 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 69590 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69599 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 69605 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69614 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69622 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 69628 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69637 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69646 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69652 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69664 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69674 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69683 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69689 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 69796 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 69822 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 69828 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69837 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 69843 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 69855 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 69865 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 69874 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 69880 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _9;
          MenhirLib.EngineTypes.startp = _startpos__9_;
          MenhirLib.EngineTypes.endp = _endpos__9_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined6;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _5;
                    MenhirLib.EngineTypes.startp = _startpos__5_;
                    MenhirLib.EngineTypes.endp = _endpos__5_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _4_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 69980 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__9_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 70004 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70013 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 70019 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70031 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 70041 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70050 "asllib/Parser0.ml"
            
          in
          (
# 228 "<standard.mly>"
    ( [ x ] )
# 70056 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let _1 = _1_inlined2 in
                    let _2 = 
# 123 "<standard.mly>"
    ( None )
# 70139 "asllib/Parser0.ml"
                     in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70146 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70155 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70161 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70170 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70178 "asllib/Parser0.ml"
                 _1_1
              in
              
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70184 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70193 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70199 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_if_stmt =
                let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_else_opt =
                    let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                    let _2 =
                      let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                      let x =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70301 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 126 "<standard.mly>"
    ( Some x )
# 70307 "asllib/Parser0.ml"
                      
                    in
                    let _1_1 = _1 in
                    let _2_1 = _2 in
                    
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70315 "asllib/Parser0.ml"
                     (_1_1, _2_1)
                  in
                  let simple_stmt_list =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70324 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70330 "asllib/Parser0.ml"
                   (expr, simple_stmt_list, simple_else_opt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70339 "asllib/Parser0.ml"
                
              in
              let simple_stmt_list =
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70347 "asllib/Parser0.ml"
                 _1_1
              in
              
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70353 "asllib/Parser0.ml"
               (simple_stmt_list, simple_if_stmt)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70362 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70368 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (AST.stmt list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x =
              let _1_1 = _1 in
              
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70412 "asllib/Parser0.ml"
               _1_1
            in
            
# 196 "<standard.mly>"
    ( x )
# 70418 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70424 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined3 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 70511 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70518 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70528 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70534 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70543 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70549 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_4, _1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_4_inlined1, _1_inlined6, _2_inlined1, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70677 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70683 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70691 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70701 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70707 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70716 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70722 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4;
                              MenhirLib.EngineTypes.startp = _startpos__4_;
                              MenhirLib.EngineTypes.endp = _endpos__4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 70875 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 70882 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70891 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 70897 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70906 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 70914 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 70920 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70929 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 70935 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 70943 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 70953 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 70959 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 70968 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 70974 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined7;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4;
                                  MenhirLib.EngineTypes.startp = _startpos__4_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7, _3_inlined1, expr_inlined1, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71146 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 71152 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71160 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71169 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71175 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71184 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71192 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71198 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71207 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71213 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71221 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71231 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71237 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71246 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71252 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71366 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 71372 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71378 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71386 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71396 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71402 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71411 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71417 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 71522 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71528 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71536 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71546 "asllib/Parser0.ml"
                 _3_1
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71552 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71561 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71567 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined5;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined4;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined5 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71675 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71682 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71696 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71703 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71712 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71718 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71727 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71735 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71741 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71750 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 71756 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined5_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71765 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 71771 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 71920 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 71926 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 71934 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 71948 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 71955 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71964 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 71970 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 71979 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 71987 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 71993 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72002 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72008 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72017 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72023 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined4;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined3;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr_inlined1;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined2;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3;
                                            MenhirLib.EngineTypes.startp = _startpos__3_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72197 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72204 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72213 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72219 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72228 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72236 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72242 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72251 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72257 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72265 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72279 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72286 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72295 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72301 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72310 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72318 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72324 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72333 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72339 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72348 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72354 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : (AST.stmt list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : unit = Obj.magic _1_inlined11 in
        let _1_inlined10 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined8_, _startpos__1_inlined7_, _6_inlined1, _1_inlined12, _1_inlined11, _1_inlined10, _1_inlined9, _3_inlined2, expr_inlined2, _1_inlined8, _1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72547 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 72553 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72561 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72570 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72576 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72585 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72593 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72599 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72608 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72614 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72622 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72636 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72643 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72652 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72658 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72667 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72675 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72681 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72690 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72696 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72705 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72711 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined4;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72846 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 72852 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 72858 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 72866 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 72880 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 72887 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72896 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 72902 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72911 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 72919 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 72925 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72934 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 72940 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 72949 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 72955 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined5 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined7, _1_inlined6, _1_inlined5) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 73081 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73087 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73095 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let _1 = _1_inlined2 in
                        let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73109 "asllib/Parser0.ml"
                         in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73116 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73125 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73131 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73140 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73148 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73154 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73163 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73169 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73178 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73184 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined7;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined7 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73306 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73313 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73332 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 73338 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73346 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73355 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73361 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73370 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73378 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73384 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73393 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73399 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73408 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73414 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined10;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined9;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined8;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined7;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _6;
                        MenhirLib.EngineTypes.startp = _startpos__6_;
                        MenhirLib.EngineTypes.endp = _endpos__6_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined3;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined2;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = expr;
                                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _menhir_s;
                                              MenhirLib.EngineTypes.semv = _1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_;
                                              MenhirLib.EngineTypes.next = _menhir_stack;
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined10 : (AST.stmt list) = Obj.magic _1_inlined10 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 73577 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73583 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73591 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73610 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 73616 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73624 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73633 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73639 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73648 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73656 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73662 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73671 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 73677 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73686 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 73692 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined12;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined10;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined9;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined8;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _6;
                              MenhirLib.EngineTypes.startp = _startpos__6_;
                              MenhirLib.EngineTypes.endp = _endpos__6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined6;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined5;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined4;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined3;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _3_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = expr_inlined1;
                                          MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _1_inlined2;
                                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _3;
                                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = expr;
                                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 73880 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73887 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73896 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73902 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73911 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73919 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 73925 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 73934 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 73940 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 73948 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73967 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 73973 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 73981 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 73990 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 73996 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74005 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74013 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74019 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74028 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74034 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74043 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74049 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined14;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined14_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined14_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined13;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined13_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined13_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined12;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined12_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined12_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined11;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined10;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined9;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined8;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined7;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _6;
                                  MenhirLib.EngineTypes.startp = _startpos__6_;
                                  MenhirLib.EngineTypes.endp = _endpos__6_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined6;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _1_inlined5;
                                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined4;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined3;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _3_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = expr_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _;
                                                    MenhirLib.EngineTypes.semv = _3;
                                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                                    MenhirLib.EngineTypes.next = {
                                                      MenhirLib.EngineTypes.state = _;
                                                      MenhirLib.EngineTypes.semv = expr;
                                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                                      MenhirLib.EngineTypes.next = {
                                                        MenhirLib.EngineTypes.state = _menhir_s;
                                                        MenhirLib.EngineTypes.semv = _1;
                                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                                      };
                                                    };
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined14 : (AST.stmt list) = Obj.magic _1_inlined14 in
        let _1_inlined13 : unit = Obj.magic _1_inlined13 in
        let _1_inlined12 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined12 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let expr_inlined2 : (AST.expr) = Obj.magic expr_inlined2 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_endpos__6_, _startpos__1_inlined3_, _startpos__1_inlined2_, _6, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined10_, _startpos__1_inlined9_, _6_inlined1, _1_inlined14, _1_inlined13, _1_inlined12, _1_inlined11, _3_inlined2, expr_inlined2, _1_inlined10, _1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74256 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 74262 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74270 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74279 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74285 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74294 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74302 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74308 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74317 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74323 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74331 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74350 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 74356 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74364 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74373 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74379 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74388 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74396 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74402 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74411 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74417 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74426 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74432 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined6;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined5;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined4;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined3;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = expr_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined2;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74581 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 74587 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74593 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74601 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74620 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 74626 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74634 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74643 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74649 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74658 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74666 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74672 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74681 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74687 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74696 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74702 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined9;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined8;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _6;
                  MenhirLib.EngineTypes.startp = _startpos__6_;
                  MenhirLib.EngineTypes.endp = _endpos__6_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined9 : unit = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined9, _1_inlined8, _1_inlined7) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 74842 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 74848 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 74856 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _3, expr, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3_inlined1, expr_inlined1, _1_inlined2, _1_inlined1) in
                let desc =
                  let simple_if_stmt =
                    let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_else_opt =
                        let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                        let _2 =
                          let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                          let x =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74875 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 126 "<standard.mly>"
    ( Some x )
# 74881 "asllib/Parser0.ml"
                          
                        in
                        let _1_1 = _1 in
                        let _2_1 = _2 in
                        
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 74889 "asllib/Parser0.ml"
                         (_1_1, _2_1)
                      in
                      let simple_stmt_list =
                        let _1 = _1_inlined1 in
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74898 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 74904 "asllib/Parser0.ml"
                       (expr, simple_stmt_list, simple_else_opt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74913 "asllib/Parser0.ml"
                    
                  in
                  let simple_stmt_list =
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 74921 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 74927 "asllib/Parser0.ml"
                   (simple_stmt_list, simple_if_stmt)
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74936 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 74942 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 74951 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 74957 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75030 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75037 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75047 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75053 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75059 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75068 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75074 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = expr;
                              MenhirLib.EngineTypes.startp = _startpos_expr_;
                              MenhirLib.EngineTypes.endp = _endpos_expr_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _2, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _2_inlined1, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 75188 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75194 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75202 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75212 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75218 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75224 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75233 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75239 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _2;
                              MenhirLib.EngineTypes.startp = _startpos__2_;
                              MenhirLib.EngineTypes.endp = _endpos__2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _3;
                                  MenhirLib.EngineTypes.startp = _startpos__3_;
                                  MenhirLib.EngineTypes.endp = _endpos__3_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = expr;
                                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 75378 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75385 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75394 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75400 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75409 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75417 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75423 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75432 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75438 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75446 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75456 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75462 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75468 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75477 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75483 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = expr;
                                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75641 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 75647 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 75655 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75664 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 75670 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75679 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75687 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 75693 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75702 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75708 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75716 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75726 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75732 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75738 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75747 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75753 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3;
                        MenhirLib.EngineTypes.startp = _startpos__3_;
                        MenhirLib.EngineTypes.endp = _endpos__3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75853 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 75859 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 75865 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 75873 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 75883 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 75889 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 75895 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 75904 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 75910 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76001 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76007 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76015 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                let x =
                  let _1_1 = _1 in
                  
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76025 "asllib/Parser0.ml"
                   _1_1
                in
                
# 196 "<standard.mly>"
    ( x )
# 76031 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76037 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76046 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76052 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = expr;
                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let _1 = _1_inlined2 in
                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76118 "asllib/Parser0.ml"
                 in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76125 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76133 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76139 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76148 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76154 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = expr;
                            MenhirLib.EngineTypes.startp = _startpos_expr_;
                            MenhirLib.EngineTypes.endp = _endpos_expr_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined3, _1_inlined2, _1_inlined1, _1) = (_1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined2, _1_inlined1, _1) = (_1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 76261 "asllib/Parser0.ml"
                     _3_1
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76267 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76275 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76283 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76289 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76298 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76304 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined7;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined2;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = expr;
                                  MenhirLib.EngineTypes.startp = _startpos_expr_;
                                  MenhirLib.EngineTypes.endp = _endpos_expr_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let _1 = _1_inlined2 in
                            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 76436 "asllib/Parser0.ml"
                             in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76443 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76452 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76458 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76467 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76475 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76481 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76490 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76496 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76504 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76512 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76518 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76527 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76533 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined9;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined8;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined7;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos_expr_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined5;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined4;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _3;
                                    MenhirLib.EngineTypes.startp = _startpos__3_;
                                    MenhirLib.EngineTypes.endp = _endpos__3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = expr;
                                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _menhir_s;
                                        MenhirLib.EngineTypes.semv = _1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_;
                                        MenhirLib.EngineTypes.next = _menhir_stack;
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined9 : (AST.stmt list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : unit = Obj.magic _1_inlined8 in
        let _1_inlined7 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr_inlined1 : (AST.expr) = Obj.magic expr_inlined1 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _3, expr, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined5_, _startpos__1_inlined4_, _1_inlined9, _1_inlined8, _1_inlined7, _1_inlined6, _3_inlined1, expr_inlined1, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined3_, _startpos__1_inlined2_, _1_inlined7, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                  let x =
                    let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                    let desc =
                      let simple_if_stmt =
                        let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_else_opt =
                            let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                            let _2 =
                              let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                              let x =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76684 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 126 "<standard.mly>"
    ( Some x )
# 76690 "asllib/Parser0.ml"
                              
                            in
                            let _1_1 = _1 in
                            let _2_1 = _2 in
                            
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 76698 "asllib/Parser0.ml"
                             (_1_1, _2_1)
                          in
                          let simple_stmt_list =
                            let _1 = _1_inlined1 in
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76707 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 76713 "asllib/Parser0.ml"
                           (expr, simple_stmt_list, simple_else_opt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76722 "asllib/Parser0.ml"
                        
                      in
                      let simple_stmt_list =
                        let _1_1 = _1 in
                        
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76730 "asllib/Parser0.ml"
                         _1_1
                      in
                      
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 76736 "asllib/Parser0.ml"
                       (simple_stmt_list, simple_if_stmt)
                    in
                    let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                    let _endpos = _endpos_desc_ in
                    let _symbolstartpos = _startpos_desc_ in
                    
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76745 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76751 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76759 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76767 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76773 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76782 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76788 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let x =
                      let _1_1 = _1 in
                      
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 76881 "asllib/Parser0.ml"
                       _1_1
                    in
                    
# 196 "<standard.mly>"
    ( x )
# 76887 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 76893 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 76901 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 76909 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 76915 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 76924 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 76930 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined4;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let s_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77014 "asllib/Parser0.ml"
                    
                  in
                  
# 126 "<standard.mly>"
    ( Some x )
# 77020 "asllib/Parser0.ml"
                  
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 655 "asllib/Parser0.mly"
                                                                        build_stmt_conds  
# 77028 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let possibly_empty_block =
                let _1 = _1_inlined1 in
                
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 77036 "asllib/Parser0.ml"
                
              in
              
# 650 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77042 "asllib/Parser0.ml"
               (expr, possibly_empty_block, s_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77051 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77057 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _6;
            MenhirLib.EngineTypes.startp = _startpos__6_;
            MenhirLib.EngineTypes.endp = _endpos__6_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = expr;
                        MenhirLib.EngineTypes.startp = _startpos_expr_;
                        MenhirLib.EngineTypes.endp = _endpos_expr_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _6 : unit = Obj.magic _6 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let _1_inlined2 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : (AST.stmt list) = Obj.magic _1_inlined1 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let simple_else =
                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                let _2 =
                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                  let x =
                    let _1 = _1_inlined1 in
                    let _1_1 = _1 in
                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77149 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 225 "asllib/Parser0.mly"
                      Some  
# 77155 "asllib/Parser0.ml"
                   x
                in
                let _1_1 = _1 in
                let _2_1 = _2 in
                
# 636 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 77163 "asllib/Parser0.ml"
                 (_1_1, _2_1)
              in
              let simple_stmt_list =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 77172 "asllib/Parser0.ml"
                 _1_1
              in
              
# 651 "asllib/Parser0.mly"
                                                                AST.S_Cond  
# 77178 "asllib/Parser0.ml"
               (expr, simple_stmt_list, simple_else)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77187 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77193 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _5;
                MenhirLib.EngineTypes.startp = _startpos__5_;
                MenhirLib.EngineTypes.endp = _endpos__5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _4;
                  MenhirLib.EngineTypes.startp = _startpos__4_;
                  MenhirLib.EngineTypes.endp = _endpos__4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3;
                    MenhirLib.EngineTypes.startp = _startpos__3_;
                    MenhirLib.EngineTypes.endp = _endpos__3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : (AST.case_alt list) = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _4 : unit = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _6_1 = _6 in
              
# 652 "asllib/Parser0.mly"
                                                            AST.S_Case  
# 77272 "asllib/Parser0.ml"
               (expr, _6_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77281 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77287 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 77378 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77394 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 77400 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                       ( AST.Up )
# 77407 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77414 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77423 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77429 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 77534 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77550 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 77559 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                       ( AST.Up )
# 77567 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77574 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77583 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77589 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = end_e;
                    MenhirLib.EngineTypes.startp = _startpos_end_e_;
                    MenhirLib.EngineTypes.endp = _endpos_end_e_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = start_e;
                        MenhirLib.EngineTypes.startp = _startpos_start_e_;
                        MenhirLib.EngineTypes.endp = _endpos_start_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _menhir_s;
                              MenhirLib.EngineTypes.semv = _1;
                              MenhirLib.EngineTypes.startp = _startpos__1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_;
                              MenhirLib.EngineTypes.next = _menhir_stack;
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined4 : (AST.stmt list) = Obj.magic _1_inlined4 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 77680 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _1) = (_1_inlined4, _1_inlined3) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77696 "asllib/Parser0.ml"
                 _3_1
              in
              let limit = 
# 123 "<standard.mly>"
    ( None )
# 77702 "asllib/Parser0.ml"
               in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                                            ( AST.Down )
# 77709 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77716 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77725 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77731 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined5;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2;
                    MenhirLib.EngineTypes.startp = _startpos__2_;
                    MenhirLib.EngineTypes.endp = _endpos__2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined3;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = end_e;
                        MenhirLib.EngineTypes.startp = _startpos_end_e_;
                        MenhirLib.EngineTypes.endp = _endpos_end_e_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = start_e;
                            MenhirLib.EngineTypes.startp = _startpos_start_e_;
                            MenhirLib.EngineTypes.endp = _endpos_start_e_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _3;
                              MenhirLib.EngineTypes.startp = _startpos__3_;
                              MenhirLib.EngineTypes.endp = _endpos__3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined1;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _menhir_s;
                                  MenhirLib.EngineTypes.semv = _1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_;
                                  MenhirLib.EngineTypes.next = _menhir_stack;
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined5 : (AST.stmt list) = Obj.magic _1_inlined5 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined4 : unit = Obj.magic _1_inlined4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let end_e : (AST.expr) = Obj.magic end_e in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let start_e : (AST.expr) = Obj.magic start_e in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 77836 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let body =
                let (_1_inlined1, _2, _1) = (_1_inlined5, _2_inlined1, _1_inlined4) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77852 "asllib/Parser0.ml"
                 _3_1
              in
              let limit =
                let _1 = _1_inlined3 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 77861 "asllib/Parser0.ml"
                
              in
              let dir =
                let _1 = _1_inlined2 in
                
# 703 "asllib/Parser0.mly"
                                            ( AST.Down )
# 77869 "asllib/Parser0.ml"
                
              in
              let index_name = _1_inlined1 in
              
# 698 "asllib/Parser0.mly"
      ( AST.S_For { index_name; start_e; dir; end_e; body; limit } )
# 77876 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77885 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 77891 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _4 : unit = Obj.magic _4 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 77973 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 77979 "asllib/Parser0.ml"
               in
              let _3_1 = _3 in
              
# 699 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 77985 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 77994 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78000 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2;
                      MenhirLib.EngineTypes.startp = _startpos__2_;
                      MenhirLib.EngineTypes.endp = _endpos__2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined3 : (AST.stmt list) = Obj.magic _1_inlined3 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _4 : unit = Obj.magic _4 in
        let _2 : (AST.expr) = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let indented_block =
                let (_4, _1_inlined1, _2, _1) = (_4_inlined1, _1_inlined3, _2_inlined1, _1_inlined2) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78096 "asllib/Parser0.ml"
                 _3_1
              in
              let _3 =
                let _1 = _1_inlined1 in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 78105 "asllib/Parser0.ml"
                
              in
              let _3_1 = _3 in
              
# 699 "asllib/Parser0.mly"
                                                                  AST.S_While 
# 78112 "asllib/Parser0.ml"
               (expr, _3_1, indented_block)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__4_inlined1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78121 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78127 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = expr;
                MenhirLib.EngineTypes.startp = _startpos_expr_;
                MenhirLib.EngineTypes.endp = _endpos_expr_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _4;
                    MenhirLib.EngineTypes.startp = _startpos__4_;
                    MenhirLib.EngineTypes.endp = _endpos__4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _2;
                        MenhirLib.EngineTypes.startp = _startpos__2_;
                        MenhirLib.EngineTypes.endp = _endpos__2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 = 
# 123 "<standard.mly>"
    ( None )
# 78219 "asllib/Parser0.ml"
               in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78228 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 701 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 78235 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78244 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78250 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _7;
            MenhirLib.EngineTypes.startp = _startpos__7_;
            MenhirLib.EngineTypes.endp = _endpos__7_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6;
              MenhirLib.EngineTypes.startp = _startpos__6_;
              MenhirLib.EngineTypes.endp = _endpos__6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined3;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = expr;
                    MenhirLib.EngineTypes.startp = _startpos_expr_;
                    MenhirLib.EngineTypes.endp = _endpos_expr_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4;
                        MenhirLib.EngineTypes.startp = _startpos__4_;
                        MenhirLib.EngineTypes.endp = _endpos__4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _7 : unit = Obj.magic _7 in
        let _6 : unit = Obj.magic _6 in
        let _2_inlined1 : (AST.expr) = Obj.magic _2_inlined1 in
        let _1_inlined3 : unit = Obj.magic _1_inlined3 in
        let expr : (AST.expr) = Obj.magic expr in
        let _3 : unit = Obj.magic _3 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _5 =
                let (_2, _1) = (_2_inlined1, _1_inlined3) in
                let x = _2 in
                
# 126 "<standard.mly>"
    ( Some x )
# 78359 "asllib/Parser0.ml"
                
              in
              let indented_block =
                let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                let _3 = _1_inlined1 in
                let _3_1 = _3 in
                
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78369 "asllib/Parser0.ml"
                 _3_1
              in
              let _5_1 = _5 in
              
# 701 "asllib/Parser0.mly"
                       AST.S_Repeat 
# 78376 "asllib/Parser0.ml"
               (indented_block, expr, _5_1)
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__7_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78385 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78391 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined4;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _6;
                MenhirLib.EngineTypes.startp = _startpos__6_;
                MenhirLib.EngineTypes.endp = _endpos__6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _5;
                  MenhirLib.EngineTypes.startp = _startpos__5_;
                  MenhirLib.EngineTypes.endp = _endpos__5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined3;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _3;
                      MenhirLib.EngineTypes.startp = _startpos__3_;
                      MenhirLib.EngineTypes.endp = _endpos__3_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _4_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined2;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _2;
                            MenhirLib.EngineTypes.startp = _startpos__2_;
                            MenhirLib.EngineTypes.endp = _endpos__2_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _menhir_s;
                                MenhirLib.EngineTypes.semv = _1;
                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                MenhirLib.EngineTypes.next = _menhir_stack;
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 78484 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 = 
# 123 "<standard.mly>"
    ( None )
# 78503 "asllib/Parser0.ml"
                   in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78514 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 78524 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78533 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78539 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined7;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined6;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined5;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined4;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _6;
                          MenhirLib.EngineTypes.startp = _startpos__6_;
                          MenhirLib.EngineTypes.endp = _endpos__6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _5;
                            MenhirLib.EngineTypes.startp = _startpos__5_;
                            MenhirLib.EngineTypes.endp = _endpos__5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined3;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _3;
                                MenhirLib.EngineTypes.startp = _startpos__3_;
                                MenhirLib.EngineTypes.endp = _endpos__3_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _4_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined2;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _2;
                                      MenhirLib.EngineTypes.startp = _startpos__2_;
                                      MenhirLib.EngineTypes.endp = _endpos__2_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _menhir_s;
                                          MenhirLib.EngineTypes.semv = _1;
                                          MenhirLib.EngineTypes.startp = _startpos__1_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_;
                                          MenhirLib.EngineTypes.next = _menhir_stack;
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _4 : unit = Obj.magic _4 in
        let _1_inlined7 : (AST.stmt list) = Obj.magic _1_inlined7 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 78667 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_startpos__1_, _1_inlined2, _2, _1_inlined1, _1) = (_startpos__1_inlined5_, _1_inlined7, _2_inlined1, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                        let _3 = _1_inlined1 in
                        let _3_1 = _3 in
                        
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78693 "asllib/Parser0.ml"
                         _3_1
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78702 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 78708 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 78720 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 78730 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78739 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 78745 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined9;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined8;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = expr;
                      MenhirLib.EngineTypes.startp = _startpos_expr_;
                      MenhirLib.EngineTypes.endp = _endpos_expr_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined7;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined6;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined5;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined4;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _6;
                                MenhirLib.EngineTypes.startp = _startpos__6_;
                                MenhirLib.EngineTypes.endp = _endpos__6_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _5;
                                  MenhirLib.EngineTypes.startp = _startpos__5_;
                                  MenhirLib.EngineTypes.endp = _endpos__5_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined3;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _3;
                                      MenhirLib.EngineTypes.startp = _startpos__3_;
                                      MenhirLib.EngineTypes.endp = _endpos__3_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _4_inlined1;
                                        MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                        MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _1_inlined2;
                                          MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                          MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _2;
                                            MenhirLib.EngineTypes.startp = _startpos__2_;
                                            MenhirLib.EngineTypes.endp = _endpos__2_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined1;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _menhir_s;
                                                MenhirLib.EngineTypes.semv = _1;
                                                MenhirLib.EngineTypes.startp = _startpos__1_;
                                                MenhirLib.EngineTypes.endp = _endpos__1_;
                                                MenhirLib.EngineTypes.next = _menhir_stack;
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 78894 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let _1 = _1_inlined2 in
                                let _2 = 
# 123 "<standard.mly>"
    ( None )
# 78924 "asllib/Parser0.ml"
                                 in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 78931 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78940 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 78946 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78955 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 78963 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 78969 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78978 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 78987 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 78993 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79005 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79015 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79024 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79030 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _6_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__6_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__6_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined11;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined11_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined11_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined10;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined10_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined10_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined9;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined9_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined9_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined8;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined8_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined8_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _3_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = expr;
                          MenhirLib.EngineTypes.startp = _startpos_expr_;
                          MenhirLib.EngineTypes.endp = _endpos_expr_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _1_inlined7;
                            MenhirLib.EngineTypes.startp = _startpos__1_inlined7_;
                            MenhirLib.EngineTypes.endp = _endpos__1_inlined7_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined6;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined5;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined4;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _6;
                                    MenhirLib.EngineTypes.startp = _startpos__6_;
                                    MenhirLib.EngineTypes.endp = _endpos__6_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _;
                                      MenhirLib.EngineTypes.semv = _5;
                                      MenhirLib.EngineTypes.startp = _startpos__5_;
                                      MenhirLib.EngineTypes.endp = _endpos__5_;
                                      MenhirLib.EngineTypes.next = {
                                        MenhirLib.EngineTypes.state = _;
                                        MenhirLib.EngineTypes.semv = _1_inlined3;
                                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                                        MenhirLib.EngineTypes.next = {
                                          MenhirLib.EngineTypes.state = _;
                                          MenhirLib.EngineTypes.semv = _3;
                                          MenhirLib.EngineTypes.startp = _startpos__3_;
                                          MenhirLib.EngineTypes.endp = _endpos__3_;
                                          MenhirLib.EngineTypes.next = {
                                            MenhirLib.EngineTypes.state = _;
                                            MenhirLib.EngineTypes.semv = _4_inlined1;
                                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                                            MenhirLib.EngineTypes.next = {
                                              MenhirLib.EngineTypes.state = _;
                                              MenhirLib.EngineTypes.semv = _1_inlined2;
                                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                              MenhirLib.EngineTypes.next = {
                                                MenhirLib.EngineTypes.state = _;
                                                MenhirLib.EngineTypes.semv = _2;
                                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                                MenhirLib.EngineTypes.next = {
                                                  MenhirLib.EngineTypes.state = _;
                                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                                  MenhirLib.EngineTypes.next = {
                                                    MenhirLib.EngineTypes.state = _menhir_s;
                                                    MenhirLib.EngineTypes.semv = _1;
                                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                                  };
                                                };
                                              };
                                            };
                                          };
                                        };
                                      };
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _6_inlined1 : unit = Obj.magic _6_inlined1 in
        let _1_inlined11 : (AST.stmt list) = Obj.magic _1_inlined11 in
        let _1_inlined10 : unit = Obj.magic _1_inlined10 in
        let _1_inlined9 : ((AST.expr * AST.stmt) AST.annotated list) = Obj.magic _1_inlined9 in
        let _1_inlined8 : (AST.stmt list) = Obj.magic _1_inlined8 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let expr : (AST.expr) = Obj.magic expr in
        let _1_inlined7 : unit = Obj.magic _1_inlined7 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79193 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__6_, _startpos__1_inlined2_, _startpos__1_inlined1_, _startpos__1_, _6, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _3, _1_inlined2, _1_inlined1, _1) = (_endpos__6_inlined1_, _startpos__1_inlined7_, _startpos__1_inlined6_, _startpos__1_inlined5_, _6_inlined1, _1_inlined11, _1_inlined10, _1_inlined9, _1_inlined8, _3_inlined1, _1_inlined7, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let (_startpos__1_inlined1_, _startpos__1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined2_, _startpos__1_inlined1_, _1_inlined6, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                        let desc =
                          let simple_if_stmt =
                            let (_startpos__1_, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1, _1) = (_startpos__1_inlined1_, _1_inlined5, _1_inlined4, _1_inlined3, _1_inlined2, _1_inlined1) in
                            let desc =
                              let simple_else_opt =
                                let (_1_inlined2, _1_inlined1, _1) = (_1_inlined4, _1_inlined3, _1_inlined2) in
                                let _2 =
                                  let (_1_inlined1, _1) = (_1_inlined2, _1_inlined1) in
                                  let x =
                                    let _1 = _1_inlined1 in
                                    let _1_1 = _1 in
                                    
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79228 "asllib/Parser0.ml"
                                     _1_1
                                  in
                                  
# 126 "<standard.mly>"
    ( Some x )
# 79234 "asllib/Parser0.ml"
                                  
                                in
                                let _1_1 = _1 in
                                let _2_1 = _2 in
                                
# 635 "asllib/Parser0.mly"
                                                                                  build_stmt_conds  
# 79242 "asllib/Parser0.ml"
                                 (_1_1, _2_1)
                              in
                              let simple_stmt_list =
                                let _1 = _1_inlined1 in
                                let _1_1 = _1 in
                                
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79251 "asllib/Parser0.ml"
                                 _1_1
                              in
                              
# 632 "asllib/Parser0.mly"
                                                                      AST.S_Cond  
# 79257 "asllib/Parser0.ml"
                               (expr, simple_stmt_list, simple_else_opt)
                            in
                            let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                            let _endpos = _endpos_desc_ in
                            let _symbolstartpos = _startpos_desc_ in
                            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79266 "asllib/Parser0.ml"
                            
                          in
                          let simple_stmt_list =
                            let _1_1 = _1 in
                            
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79274 "asllib/Parser0.ml"
                             _1_1
                          in
                          
# 558 "asllib/Parser0.mly"
                                            AST.S_Seq  
# 79280 "asllib/Parser0.ml"
                           (simple_stmt_list, simple_if_stmt)
                        in
                        let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                        let _endpos = _endpos_desc_ in
                        let _symbolstartpos = _startpos_desc_ in
                        
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79289 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__6_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79298 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79304 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79316 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79326 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79335 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79341 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined6;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined5;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined4;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _6;
                      MenhirLib.EngineTypes.startp = _startpos__6_;
                      MenhirLib.EngineTypes.endp = _endpos__6_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _5;
                        MenhirLib.EngineTypes.startp = _startpos__5_;
                        MenhirLib.EngineTypes.endp = _endpos__5_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined3;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _3;
                            MenhirLib.EngineTypes.startp = _startpos__3_;
                            MenhirLib.EngineTypes.endp = _endpos__3_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _4_inlined1;
                              MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                              MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _1_inlined2;
                                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _2;
                                  MenhirLib.EngineTypes.startp = _startpos__2_;
                                  MenhirLib.EngineTypes.endp = _endpos__2_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _;
                                    MenhirLib.EngineTypes.semv = _1_inlined1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                    MenhirLib.EngineTypes.next = {
                                      MenhirLib.EngineTypes.state = _menhir_s;
                                      MenhirLib.EngineTypes.semv = _1;
                                      MenhirLib.EngineTypes.startp = _startpos__1_;
                                      MenhirLib.EngineTypes.endp = _endpos__1_;
                                      MenhirLib.EngineTypes.next = _menhir_stack;
                                    };
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined6 : (AST.stmt list) = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79455 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__2_, _startpos__1_, _1_inlined1, _1) = (_endpos__2_inlined1_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        let x =
                          let _1_1 = _1 in
                          
# 562 "asllib/Parser0.mly"
                                                ASTUtils.stmt_from_list  
# 79481 "asllib/Parser0.ml"
                           _1_1
                        in
                        
# 196 "<standard.mly>"
    ( x )
# 79487 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79496 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79502 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79514 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79524 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79533 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79539 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _9;
            MenhirLib.EngineTypes.startp = _startpos__9_;
            MenhirLib.EngineTypes.endp = _endpos__9_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined6;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined6_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined6_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined5;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined5_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined5_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined4;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined4_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined4_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _6;
                    MenhirLib.EngineTypes.startp = _startpos__6_;
                    MenhirLib.EngineTypes.endp = _endpos__6_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _5;
                      MenhirLib.EngineTypes.startp = _startpos__5_;
                      MenhirLib.EngineTypes.endp = _endpos__5_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined3;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _3;
                          MenhirLib.EngineTypes.startp = _startpos__3_;
                          MenhirLib.EngineTypes.endp = _endpos__3_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _;
                            MenhirLib.EngineTypes.semv = _4_inlined1;
                            MenhirLib.EngineTypes.startp = _startpos__4_inlined1_;
                            MenhirLib.EngineTypes.endp = _endpos__4_inlined1_;
                            MenhirLib.EngineTypes.next = {
                              MenhirLib.EngineTypes.state = _;
                              MenhirLib.EngineTypes.semv = _1_inlined2;
                              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                              MenhirLib.EngineTypes.next = {
                                MenhirLib.EngineTypes.state = _;
                                MenhirLib.EngineTypes.semv = _2;
                                MenhirLib.EngineTypes.startp = _startpos__2_;
                                MenhirLib.EngineTypes.endp = _endpos__2_;
                                MenhirLib.EngineTypes.next = {
                                  MenhirLib.EngineTypes.state = _;
                                  MenhirLib.EngineTypes.semv = _1_inlined1;
                                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                                  MenhirLib.EngineTypes.next = {
                                    MenhirLib.EngineTypes.state = _menhir_s;
                                    MenhirLib.EngineTypes.semv = _1;
                                    MenhirLib.EngineTypes.startp = _startpos__1_;
                                    MenhirLib.EngineTypes.endp = _endpos__1_;
                                    MenhirLib.EngineTypes.next = _menhir_stack;
                                  };
                                };
                              };
                            };
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.stmt list) = Obj.magic xs in
        let _9 : unit = Obj.magic _9 in
        let _1_inlined6 : unit = Obj.magic _1_inlined6 in
        let _1_inlined5 : unit = Obj.magic _1_inlined5 in
        let _1_inlined4 : (unit list) = Obj.magic _1_inlined4 in
        let _6 : unit = Obj.magic _6 in
        let _5 : unit = Obj.magic _5 in
        let _1_inlined3 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79646 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined3 in
        let _3 : unit = Obj.magic _3 in
        let _4_inlined1 : unit = Obj.magic _4_inlined1 in
        let _1_inlined2 : (AST.stmt list) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let _1 =
                  let _8 =
                    let (_endpos__1_inlined1_, _startpos__1_, _1_inlined1, _1) = (_endpos__1_inlined6_, _startpos__1_inlined5_, _1_inlined6, _1_inlined5) in
                    let x =
                      let desc =
                        let _1 = _1_inlined1 in
                        
# 534 "asllib/Parser0.mly"
                  ( ASTUtils.s_pass )
# 79670 "asllib/Parser0.ml"
                        
                      in
                      let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
                      let _endpos = _endpos_desc_ in
                      let _symbolstartpos = _startpos_desc_ in
                      
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79679 "asllib/Parser0.ml"
                      
                    in
                    
# 126 "<standard.mly>"
    ( Some x )
# 79685 "asllib/Parser0.ml"
                    
                  in
                  let _7 = _1_inlined4 in
                  let _4 = _1_inlined3 in
                  let _2 =
                    let (_4, _1_inlined1, _1) = (_4_inlined1, _1_inlined2, _1_inlined1) in
                    let _3 = _1_inlined1 in
                    let _3_1 = _3 in
                    
# 541 "asllib/Parser0.mly"
                                           ASTUtils.stmt_from_list  
# 79697 "asllib/Parser0.ml"
                     _3_1
                  in
                  ()
                in
                ()
              in
              
# 549 "asllib/Parser0.mly"
                                 ( AST.S_Pass )
# 79707 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__9_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 79716 "asllib/Parser0.ml"
            
          in
          (
# 231 "<standard.mly>"
    ( x :: xs )
# 79722 "asllib/Parser0.ml"
           : (AST.stmt list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79750 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 79760 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 307 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 79768 "asllib/Parser0.ml"
            
          in
          (
# 296 "asllib/Parser0.mly"
                                ( [ x ]  )
# 79774 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79809 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 79819 "asllib/Parser0.ml"
           in
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 307 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 79827 "asllib/Parser0.ml"
            
          in
          (
# 296 "asllib/Parser0.mly"
                                ( [ x ]  )
# 79833 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.bitfield list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79875 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : (AST.slice list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let x = _1_inlined1 in
            let s = _1 in
            
# 307 "asllib/Parser0.mly"
                                          ( AST.BitField_Simple(x, s) )
# 79888 "asllib/Parser0.ml"
            
          in
          (
# 297 "asllib/Parser0.mly"
                                ( x :: t )
# 79894 "asllib/Parser0.ml"
           : (AST.bitfield list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79922 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 79932 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 284 "asllib/Parser0.mly"
                               ( (x, t) )
# 79939 "asllib/Parser0.ml"
            
          in
          (
# 296 "asllib/Parser0.mly"
                                ( [ x ]  )
# 79945 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 79980 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 79990 "asllib/Parser0.ml"
           in
          let x =
            let x = _1 in
            
# 284 "asllib/Parser0.mly"
                               ( (x, t) )
# 79997 "asllib/Parser0.ml"
            
          in
          (
# 296 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80003 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_t_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_t_inlined1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let t : (AST.field list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80045 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t_inlined1 : (AST.ty) = Obj.magic t_inlined1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_inlined1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x =
            let t = t_inlined1 in
            let x = _1 in
            
# 284 "asllib/Parser0.mly"
                               ( (x, t) )
# 80058 "asllib/Parser0.ml"
            
          in
          (
# 297 "asllib/Parser0.mly"
                                ( x :: t )
# 80064 "asllib/Parser0.ml"
           : (AST.field list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80086 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let _2 = 
# 123 "<standard.mly>"
    ( None )
# 80095 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 296 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80101 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let x : unit = Obj.magic x in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80130 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let _2 = 
# 126 "<standard.mly>"
    ( Some x )
# 80139 "asllib/Parser0.ml"
           in
          let x = _1 in
          (
# 296 "asllib/Parser0.mly"
                                ( [ x ]  )
# 80145 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = t;
          MenhirLib.EngineTypes.startp = _startpos_t_;
          MenhirLib.EngineTypes.endp = _endpos_t_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let t : (string list) = Obj.magic t in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80181 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_t_ in
        let _v =
          let x = _1 in
          (
# 297 "asllib/Parser0.mly"
                                ( x :: t )
# 80191 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = body;
            MenhirLib.EngineTypes.startp = _startpos_body_;
            MenhirLib.EngineTypes.endp = _endpos_body_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let body : (AST.stmt list) = Obj.magic body in
        let _1 : (unit list) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.t) = 
# 230 "asllib/Parser0.mly"
    (
      let body = ASTUtils.stmt_from_list body in
      AST.[
        D_Func {
          name = "main";
          args = [];
          parameters = [];
          body = SB_ASL body;
          return_type = None;
          subprogram_type = ST_Procedure;
          recurse_limit = None;
        } |> ASTUtils.add_pos_from body
      ]
    )
# 80244 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let x =
            let desc = 
# 689 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 80271 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80279 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80285 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x =
            let desc = 
# 690 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 80327 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80335 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80341 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 674 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 80369 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80377 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80383 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 80405 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 80417 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80426 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80432 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = expr;
              MenhirLib.EngineTypes.startp = _startpos_expr_;
              MenhirLib.EngineTypes.endp = _endpos_expr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let expr : (AST.expr) = Obj.magic expr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_expr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 689 "asllib/Parser0.mly"
                AST.Pattern_Single  
# 80474 "asllib/Parser0.ml"
             expr in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos_expr_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80482 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80488 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc = 
# 690 "asllib/Parser0.mly"
                                   AST.Pattern_Range  
# 80545 "asllib/Parser0.ml"
             (e1, e2) in
            let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80553 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80559 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 674 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 80601 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80609 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80615 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 80651 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 80663 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 80672 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80678 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.expr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 80704 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.expr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.expr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.expr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 80743 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80770 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            
# 532 "asllib/Parser0.mly"
                             ( (x, t) )
# 80782 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80788 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80830 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            
# 532 "asllib/Parser0.mly"
                             ( (x, t) )
# 80842 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80848 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80870 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x = _1 in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 80880 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (string list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 80916 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = _1 in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 80926 "asllib/Parser0.ml"
           : (string list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.local_decl_item) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.local_decl_item list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 80952 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.local_decl_item list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.local_decl_item) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.local_decl_item list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 80991 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.lexpr list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 81016 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.lexpr list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.lexpr) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.lexpr list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 81055 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 686 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 81100 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 81106 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81115 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81121 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 81143 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 81155 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81164 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81170 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc = 
# 674 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 81198 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81206 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81212 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 79 "asllib/Parser0.mly"
       (bool)
# 81234 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 390 "asllib/Parser0.mly"
                       AST.L_Bool        
# 81249 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81255 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81264 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81271 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81280 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81286 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 77 "asllib/Parser0.mly"
       (Z.t)
# 81308 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 391 "asllib/Parser0.mly"
                       AST.L_Int         
# 81323 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81329 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81338 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81345 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81354 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81360 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 78 "asllib/Parser0.mly"
       (Q.t)
# 81382 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 392 "asllib/Parser0.mly"
                       AST.L_Real        
# 81397 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81403 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81412 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81419 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81428 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81434 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 76 "asllib/Parser0.mly"
       (Bitvector.t)
# 81456 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 393 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 81471 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81477 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81486 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81493 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81502 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81508 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 81530 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 394 "asllib/Parser0.mly"
                       AST.L_String      
# 81545 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 81551 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81560 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81567 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81576 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81582 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 81616 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 81622 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 81637 "asllib/Parser0.ml"
                    
                  in
                  
# 683 "asllib/Parser0.mly"
                         AST.E_Var  
# 81643 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81652 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81659 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81668 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81674 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 81696 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 683 "asllib/Parser0.mly"
                         AST.E_Var  
# 81710 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81719 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81726 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81735 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81741 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 81772 "asllib/Parser0.ml"
                   in
                  
# 683 "asllib/Parser0.mly"
                         AST.E_Var  
# 81777 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81786 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 81793 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81802 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 81808 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let x =
                let _1 = _1_inlined1 in
                let _1_1 = _1 in
                
# 686 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 81868 "asllib/Parser0.ml"
                 _1_1
              in
              
# 205 "<standard.mly>"
    ( x )
# 81874 "asllib/Parser0.ml"
              
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81883 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 81889 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 81925 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1_1 = _1 in
              
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 81937 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 81946 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 81952 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc = 
# 674 "asllib/Parser0.mly"
                                    ( AST.Pattern_All )
# 81994 "asllib/Parser0.ml"
             in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82002 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82008 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 79 "asllib/Parser0.mly"
       (bool)
# 82044 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 390 "asllib/Parser0.mly"
                       AST.L_Bool        
# 82059 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82065 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82074 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82081 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82090 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82096 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 77 "asllib/Parser0.mly"
       (Z.t)
# 82132 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 391 "asllib/Parser0.mly"
                       AST.L_Int         
# 82147 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82153 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82162 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82169 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82178 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82184 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 78 "asllib/Parser0.mly"
       (Q.t)
# 82220 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 392 "asllib/Parser0.mly"
                       AST.L_Real        
# 82235 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82241 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82250 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82257 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82266 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82272 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 76 "asllib/Parser0.mly"
       (Bitvector.t)
# 82308 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 393 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 82323 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82329 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82338 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82345 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82354 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82360 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82396 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let literal_expression =
                    let _1_1 = _1 in
                    
# 394 "asllib/Parser0.mly"
                       AST.L_String      
# 82411 "asllib/Parser0.ml"
                     _1_1
                  in
                  
# 682 "asllib/Parser0.mly"
                                  AST.E_Literal  
# 82417 "asllib/Parser0.ml"
                   literal_expression
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82426 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82433 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82442 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82448 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82496 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 82502 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            let desc =
              let _1 =
                let desc =
                  let qualident =
                    let i = _1 in
                    
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 82518 "asllib/Parser0.ml"
                    
                  in
                  
# 683 "asllib/Parser0.mly"
                         AST.E_Var  
# 82524 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82533 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82540 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82549 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82555 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82591 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = _1 in
                  
# 683 "asllib/Parser0.mly"
                         AST.E_Var  
# 82605 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82614 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82621 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82630 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82636 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.pattern list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let desc =
              let _1 =
                let desc =
                  let qualident = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 82681 "asllib/Parser0.ml"
                   in
                  
# 683 "asllib/Parser0.mly"
                         AST.E_Var  
# 82686 "asllib/Parser0.ml"
                   qualident
                in
                let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                let _endpos = _endpos_desc_ in
                let _symbolstartpos = _startpos_desc_ in
                
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82695 "asllib/Parser0.ml"
                
              in
              let _1_1 = _1 in
              
# 684 "asllib/Parser0.mly"
           AST.Pattern_Single  
# 82702 "asllib/Parser0.ml"
               _1_1
            in
            let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
            let _endpos = _endpos_desc_ in
            let _symbolstartpos = _startpos_desc_ in
            
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 82711 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82717 "asllib/Parser0.ml"
           : (AST.pattern list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = t;
            MenhirLib.EngineTypes.startp = _startpos_t_;
            MenhirLib.EngineTypes.endp = _endpos_t_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82745 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82757 "asllib/Parser0.ml"
             in
            
# 531 "asllib/Parser0.mly"
                                            ( (x, t) )
# 82762 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 82768 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x_inlined1;
            MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = t;
              MenhirLib.EngineTypes.startp = _startpos_t_;
              MenhirLib.EngineTypes.endp = _endpos_t_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82802 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos__1_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 82817 "asllib/Parser0.ml"
              
            in
            
# 531 "asllib/Parser0.mly"
                                            ( (x, t) )
# 82823 "asllib/Parser0.ml"
            
          in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 82829 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = t;
                MenhirLib.EngineTypes.startp = _startpos_t_;
                MenhirLib.EngineTypes.endp = _endpos_t_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82871 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 = 
# 123 "<standard.mly>"
    ( None )
# 82883 "asllib/Parser0.ml"
             in
            
# 531 "asllib/Parser0.mly"
                                            ( (x, t) )
# 82888 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82894 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x_inlined1;
                MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = t;
                  MenhirLib.EngineTypes.startp = _startpos_t_;
                  MenhirLib.EngineTypes.endp = _endpos_t_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.typed_identifier list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 82942 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let x_inlined1 : unit = Obj.magic x_inlined1 in
        let t : (AST.ty) = Obj.magic t in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_t_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let x = _1 in
            let _2 =
              let x = x_inlined1 in
              
# 126 "<standard.mly>"
    ( Some x )
# 82957 "asllib/Parser0.ml"
              
            in
            
# 531 "asllib/Parser0.mly"
                                            ( (x, t) )
# 82963 "asllib/Parser0.ml"
            
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 82969 "asllib/Parser0.ml"
           : (AST.typed_identifier list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = sexpr;
          MenhirLib.EngineTypes.startp = _startpos_sexpr_;
          MenhirLib.EngineTypes.endp = _endpos_sexpr_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_sexpr_ in
        let _v =
          let x = 
# 385 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 82996 "asllib/Parser0.ml"
           sexpr in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83001 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 386 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 83042 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83047 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2 : unit = Obj.magic _2 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let x = 
# 387 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 83088 "asllib/Parser0.ml"
           (e1, e2) in
          (
# 250 "<standard.mly>"
    ( [ x ] )
# 83093 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = sexpr;
              MenhirLib.EngineTypes.startp = _startpos_sexpr_;
              MenhirLib.EngineTypes.endp = _endpos_sexpr_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let sexpr : (AST.expr) = Obj.magic sexpr in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_sexpr_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x = 
# 385 "asllib/Parser0.mly"
                                      AST.Slice_Single  
# 83134 "asllib/Parser0.ml"
           sexpr in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83139 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 386 "asllib/Parser0.mly"
                                      AST.Slice_Range   
# 83196 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83202 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = e2;
              MenhirLib.EngineTypes.startp = _startpos_e2_;
              MenhirLib.EngineTypes.endp = _endpos_e2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e1;
                  MenhirLib.EngineTypes.startp = _startpos_e1_;
                  MenhirLib.EngineTypes.endp = _endpos_e1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let xs : (AST.slice list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_xs_ in
        let _v =
          let x =
            let _2 = _2_inlined1 in
            
# 387 "asllib/Parser0.mly"
                                      AST.Slice_Length  
# 83259 "asllib/Parser0.ml"
             (e1, e2)
          in
          (
# 253 "<standard.mly>"
    ( x :: xs )
# 83265 "asllib/Parser0.ml"
           : (AST.slice list))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_x_ in
        let _v : (AST.ty list) = 
# 250 "<standard.mly>"
    ( [ x ] )
# 83291 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = xs;
          MenhirLib.EngineTypes.startp = _startpos_xs_;
          MenhirLib.EngineTypes.endp = _endpos_xs_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let xs : (AST.ty list) = Obj.magic xs in
        let _2 : unit = Obj.magic _2 in
        let x : (AST.ty) = Obj.magic x in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_x_ in
        let _endpos = _endpos_xs_ in
        let _v : (AST.ty list) = 
# 253 "<standard.mly>"
    ( x :: xs )
# 83330 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v : (AST.expr) = 
# 205 "<standard.mly>"
    ( x )
# 83369 "asllib/Parser0.ml"
         in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 79 "asllib/Parser0.mly"
       (bool)
# 83390 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 390 "asllib/Parser0.mly"
                       AST.L_Bool        
# 83402 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83408 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83417 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 77 "asllib/Parser0.mly"
       (Z.t)
# 83439 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 391 "asllib/Parser0.mly"
                       AST.L_Int         
# 83451 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83457 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83466 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 78 "asllib/Parser0.mly"
       (Q.t)
# 83488 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 392 "asllib/Parser0.mly"
                       AST.L_Real        
# 83500 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83506 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83515 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 76 "asllib/Parser0.mly"
       (Bitvector.t)
# 83537 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 393 "asllib/Parser0.mly"
                       AST.L_BitVector   
# 83549 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83555 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83564 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 83586 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let literal_expression =
              let _1_1 = _1 in
              
# 394 "asllib/Parser0.mly"
                       AST.L_String      
# 83598 "asllib/Parser0.ml"
               _1_1
            in
            
# 356 "asllib/Parser0.mly"
                                                        AST.E_Literal    
# 83604 "asllib/Parser0.ml"
             literal_expression
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83613 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 83647 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 83653 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 83665 "asllib/Parser0.ml"
              
            in
            
# 357 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 83671 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83680 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 83702 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = _1 in
            
# 357 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 83713 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83722 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let qualident = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 83750 "asllib/Parser0.ml"
             in
            
# 357 "asllib/Parser0.mly"
                                                        AST.E_Var        
# 83755 "asllib/Parser0.ml"
             qualident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83764 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 83812 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 83818 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 83828 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 83834 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 83839 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 83847 "asllib/Parser0.ml"
              
            in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 83853 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83862 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 83917 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 83923 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 83933 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 83941 "asllib/Parser0.ml"
              
            in
            let name =
              let i = _1 in
              
# 338 "asllib/Parser0.mly"
                                 ( q ^ "_" ^ i )
# 83949 "asllib/Parser0.ml"
              
            in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 83955 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 83964 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 84000 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 84010 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 84016 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 84021 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84028 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84037 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 84080 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 84090 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 84098 "asllib/Parser0.ml"
              
            in
            let name = _1 in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84105 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84114 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 84156 "asllib/Parser0.ml"
             in
            let args =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 84162 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 84167 "asllib/Parser0.ml"
              
            in
            let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 84173 "asllib/Parser0.ml"
             in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84178 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84187 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined2 : (AST.expr list) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let params = 
# 343 "asllib/Parser0.mly"
             ( [] )
# 84236 "asllib/Parser0.ml"
             in
            let args =
              let _1_inlined1 = _1_inlined2 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 84244 "asllib/Parser0.ml"
              
            in
            let name = 
# 340 "asllib/Parser0.mly"
              ( "record" )
# 84250 "asllib/Parser0.ml"
             in
            
# 359 "asllib/Parser0.mly"
        ( AST.E_Call { name; args; params; call_type = ST_Function } )
# 84255 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84264 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 711 "asllib/Parser0.mly"
            ( AST.BNOT )
# 84299 "asllib/Parser0.ml"
             in
            
# 360 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 84304 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84313 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 712 "asllib/Parser0.mly"
            ( AST.NEG )
# 84348 "asllib/Parser0.ml"
             in
            
# 360 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 84353 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84362 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e;
          MenhirLib.EngineTypes.startp = _startpos_e_;
          MenhirLib.EngineTypes.endp = _endpos_e_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let e : (AST.expr) = Obj.magic e in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_e_ in
        let _v =
          let desc =
            let unop = 
# 713 "asllib/Parser0.mly"
            ( AST.NOT )
# 84397 "asllib/Parser0.ml"
             in
            
# 360 "asllib/Parser0.mly"
                                                        AST.E_Unop       
# 84402 "asllib/Parser0.ml"
             (unop, e)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84411 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 718 "asllib/Parser0.mly"
                 ( AST.AND    )
# 84453 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84458 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84467 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 719 "asllib/Parser0.mly"
                 ( AST.BAND   )
# 84509 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84514 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84523 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 720 "asllib/Parser0.mly"
                 ( AST.BOR    )
# 84565 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84570 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84579 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 721 "asllib/Parser0.mly"
                 ( AST.DIV    )
# 84621 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84626 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84635 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 722 "asllib/Parser0.mly"
                 ( AST.EOR    )
# 84677 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84682 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84691 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 723 "asllib/Parser0.mly"
                 ( AST.EQ_OP  )
# 84733 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84738 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84747 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 724 "asllib/Parser0.mly"
                 ( AST.NEQ    )
# 84789 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84794 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84803 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 725 "asllib/Parser0.mly"
                 ( AST.GEQ    )
# 84845 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84850 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84859 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 726 "asllib/Parser0.mly"
                 ( AST.IMPL   )
# 84901 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84906 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84915 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 727 "asllib/Parser0.mly"
                 ( AST.LEQ    )
# 84957 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 84962 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 84971 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 728 "asllib/Parser0.mly"
                 ( AST.PLUS   )
# 85013 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85018 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85027 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 729 "asllib/Parser0.mly"
                 ( AST.MINUS  )
# 85069 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85074 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85083 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 730 "asllib/Parser0.mly"
                 ( AST.MOD    )
# 85125 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85130 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85139 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 731 "asllib/Parser0.mly"
                 ( AST.MUL    )
# 85181 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85186 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85195 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 732 "asllib/Parser0.mly"
                 ( AST.OR     )
# 85237 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85242 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85251 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 733 "asllib/Parser0.mly"
                 ( AST.RDIV   )
# 85293 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85298 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85307 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 734 "asllib/Parser0.mly"
                 ( AST.SHL    )
# 85349 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85354 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85363 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 735 "asllib/Parser0.mly"
                 ( AST.SHR    )
# 85405 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85410 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85419 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = e2;
          MenhirLib.EngineTypes.startp = _startpos_e2_;
          MenhirLib.EngineTypes.endp = _endpos_e2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e1;
              MenhirLib.EngineTypes.startp = _startpos_e1_;
              MenhirLib.EngineTypes.endp = _endpos_e1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let e2 : (AST.expr) = Obj.magic e2 in
        let _1 : unit = Obj.magic _1 in
        let e1 : (AST.expr) = Obj.magic e1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e1_ in
        let _endpos = _endpos_e2_ in
        let _v =
          let desc =
            let op = 
# 715 "asllib/Parser0.mly"
                                  ( AST.PLUS )
# 85461 "asllib/Parser0.ml"
             in
            
# 361 "asllib/Parser0.mly"
                                                      ( AST.E_Binop (op, e1, e2) )
# 85466 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_e2_, _startpos_e1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85475 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.expr) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 292 "asllib/Parser0.mly"
                                           ( h::t )
# 85535 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 85541 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 362 "asllib/Parser0.mly"
                                                        AST.E_Tuple      
# 85548 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85557 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = expr;
          MenhirLib.EngineTypes.startp = _startpos_expr_;
          MenhirLib.EngineTypes.endp = _endpos_expr_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = c;
                    MenhirLib.EngineTypes.startp = _startpos_c_;
                    MenhirLib.EngineTypes.endp = _endpos_c_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let expr : (AST.expr) = Obj.magic expr in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined1 : ((AST.expr * AST.expr) AST.annotated list) = Obj.magic _1_inlined1 in
        let e : (AST.expr) = Obj.magic e in
        let _3 : unit = Obj.magic _3 in
        let c : (AST.expr) = Obj.magic c in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_expr_ in
        let _v =
          let desc =
            let e_else =
              let _1 = _1_inlined1 in
              let _1_1 = _1 in
              
# 382 "asllib/Parser0.mly"
                                                build_expr_conds  
# 85630 "asllib/Parser0.ml"
               (_1_1, expr)
            in
            
# 363 "asllib/Parser0.mly"
                                                        AST.E_Cond       
# 85636 "asllib/Parser0.ml"
             (c, e, e_else)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_expr_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85645 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 85679 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let ident = _1 in
            
# 364 "asllib/Parser0.mly"
                                                        AST.E_GetField   
# 85692 "asllib/Parser0.ml"
             (e, ident)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85701 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 85751 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 85756 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 85763 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85772 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (string list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _3 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 85830 "asllib/Parser0.ml"
              
            in
            let _3_1 = _3 in
            
# 365 "asllib/Parser0.mly"
                                                        AST.E_GetFields  
# 85837 "asllib/Parser0.ml"
             (e, _3_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85846 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 85889 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 85894 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 85901 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85910 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = e;
                MenhirLib.EngineTypes.startp = _startpos_e_;
                MenhirLib.EngineTypes.endp = _endpos_e_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.slice list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _2 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 85961 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 366 "asllib/Parser0.mly"
                                                        AST.E_Slice      
# 85968 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 85977 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = 
# 289 "asllib/Parser0.mly"
                ( [] )
# 86013 "asllib/Parser0.ml"
               in
              
# 205 "<standard.mly>"
    ( x )
# 86018 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 367 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 86025 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86034 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.expr list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 86078 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 367 "asllib/Parser0.mly"
                                                        AST.E_Concat     
# 86085 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86094 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2;
                MenhirLib.EngineTypes.startp = _startpos__2_;
                MenhirLib.EngineTypes.endp = _endpos__2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = e;
                  MenhirLib.EngineTypes.startp = _startpos_e_;
                  MenhirLib.EngineTypes.endp = _endpos_e_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.pattern list) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let bpattern =
              let desc =
                let x =
                  let _1 = _1_inlined1 in
                  let _1_1 = _1 in
                  
# 686 "asllib/Parser0.mly"
                                                       AST.Pattern_Any  
# 86155 "asllib/Parser0.ml"
                   _1_1
                in
                
# 205 "<standard.mly>"
    ( x )
# 86161 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86170 "asllib/Parser0.ml"
              
            in
            
# 368 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 86176 "asllib/Parser0.ml"
             (e, bpattern)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86185 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 86219 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let pattern_mask =
              let desc =
                let _1_1 = _1 in
                
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 86234 "asllib/Parser0.ml"
                 _1_1
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86243 "asllib/Parser0.ml"
              
            in
            
# 369 "asllib/Parser0.mly"
                                                        AST.E_Pattern    
# 86249 "asllib/Parser0.ml"
             (e, pattern_mask)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86258 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = e;
              MenhirLib.EngineTypes.startp = _startpos_e_;
              MenhirLib.EngineTypes.endp = _endpos_e_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1_inlined1 : (
# 75 "asllib/Parser0.mly"
       (Bitvector.mask)
# 86292 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let e : (AST.expr) = Obj.magic e in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_e_ in
        let _endpos = _endpos__1_inlined1_ in
        let _v =
          let desc =
            let _2 =
              let desc =
                let pm =
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos__1_inlined1_, _startpos__1_inlined1_, _1_inlined1) in
                  let desc =
                    let _1_1 = _1 in
                    
# 673 "asllib/Parser0.mly"
                                           AST.Pattern_Mask 
# 86310 "asllib/Parser0.ml"
                     _1_1
                  in
                  let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
                  let _endpos = _endpos_desc_ in
                  let _symbolstartpos = _startpos_desc_ in
                  
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86319 "asllib/Parser0.ml"
                  
                in
                
# 370 "asllib/Parser0.mly"
                                                     AST.Pattern_Not  
# 86325 "asllib/Parser0.ml"
                 pm
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86334 "asllib/Parser0.ml"
              
            in
            let _2_1 = _2 in
            
# 370 "asllib/Parser0.mly"
                                                                           AST.E_Pattern  
# 86341 "asllib/Parser0.ml"
             (e, _2_1)
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_inlined1_, _startpos_e_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86350 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 86386 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86394 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86401 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86410 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 86446 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86454 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86461 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86470 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 86506 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86514 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86521 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86530 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 86559 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let tident = _1 in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 86572 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86581 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86588 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86597 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 86638 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 86644 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let tident =
                  let i = _1 in
                  
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 86659 "asllib/Parser0.ml"
                  
                in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 86665 "asllib/Parser0.ml"
                 tident
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86674 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86681 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86690 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 86726 "asllib/Parser0.ml"
               in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86734 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86741 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86750 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 86808 "asllib/Parser0.ml"
                 in
                
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 86813 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86822 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86829 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86838 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3;
                  MenhirLib.EngineTypes.startp = _startpos__3_;
                  MenhirLib.EngineTypes.endp = _endpos__3_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 86920 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 86926 "asllib/Parser0.ml"
                 in
                
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 86931 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86940 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 86947 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 86956 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 87015 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87022 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87031 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87038 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87047 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 87109 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 87130 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87138 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87147 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87154 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87163 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 87237 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 87243 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 87265 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 87273 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87281 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87290 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87297 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87306 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3;
              MenhirLib.EngineTypes.startp = _startpos__3_;
              MenhirLib.EngineTypes.endp = _endpos__3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _2 = _2_inlined1 in
              let desc =
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 87400 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 87408 "asllib/Parser0.ml"
                
              in
              let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
              let _endpos = _endpos_desc_ in
              let _symbolstartpos = _startpos_desc_ in
              
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87417 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 371 "asllib/Parser0.mly"
                                                        AST.E_Unknown    
# 87424 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87433 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87469 "asllib/Parser0.ml"
               in
              let _1 = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 87474 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87481 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87490 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 87524 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 87537 "asllib/Parser0.ml"
               in
              let _1 = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 87542 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87549 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87558 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87594 "asllib/Parser0.ml"
               in
              let _1 = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 87599 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87606 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87615 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 87649 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 87662 "asllib/Parser0.ml"
               in
              let _1 = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 87667 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87674 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87683 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87719 "asllib/Parser0.ml"
               in
              let _1 = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 87724 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87731 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87740 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 87774 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 87787 "asllib/Parser0.ml"
               in
              let _1 = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 87792 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87799 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87808 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 87837 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 87848 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 87855 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87863 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87872 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 87906 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 87912 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 87923 "asllib/Parser0.ml"
               in
              let _1 =
                let tident = _1 in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 87930 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 87938 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 87947 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = q;
                MenhirLib.EngineTypes.startp = _startpos_q_;
                MenhirLib.EngineTypes.endp = _endpos_q_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 87988 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 87994 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88005 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 88014 "asllib/Parser0.ml"
                  
                in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 88020 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88028 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88037 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _2_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = q;
                  MenhirLib.EngineTypes.startp = _startpos_q_;
                  MenhirLib.EngineTypes.endp = _endpos_q_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 88083 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 88089 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 88095 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 88106 "asllib/Parser0.ml"
               in
              let _1 =
                let _2 = _2_inlined1 in
                let tident =
                  let i = _1 in
                  
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 88115 "asllib/Parser0.ml"
                  
                in
                
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 88121 "asllib/Parser0.ml"
                 tident
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88129 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88138 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _menhir_s;
            MenhirLib.EngineTypes.semv = _1;
            MenhirLib.EngineTypes.startp = _startpos__1_;
            MenhirLib.EngineTypes.endp = _endpos__1_;
            MenhirLib.EngineTypes.next = _menhir_stack;
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88174 "asllib/Parser0.ml"
               in
              let _1 = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 88179 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88186 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88195 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = _1;
              MenhirLib.EngineTypes.startp = _startpos__1_;
              MenhirLib.EngineTypes.endp = _endpos__1_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 88229 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 88242 "asllib/Parser0.ml"
               in
              let _1 = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 88247 "asllib/Parser0.ml"
               in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88254 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88263 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88320 "asllib/Parser0.ml"
               in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88326 "asllib/Parser0.ml"
                 in
                
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 88331 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88339 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88348 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 88400 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 88418 "asllib/Parser0.ml"
                
              in
              let _1 =
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88425 "asllib/Parser0.ml"
                 in
                
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 88430 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88438 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88447 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined2;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = x;
                    MenhirLib.EngineTypes.startp = _startpos_x_;
                    MenhirLib.EngineTypes.endp = _endpos_x_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88525 "asllib/Parser0.ml"
               in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 88534 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88540 "asllib/Parser0.ml"
                 in
                
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 88545 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88553 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88562 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = x;
                      MenhirLib.EngineTypes.startp = _startpos_x_;
                      MenhirLib.EngineTypes.endp = _endpos_x_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 88632 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 88653 "asllib/Parser0.ml"
                
              in
              let _1 =
                let b =
                  let _1_inlined1 = _1_inlined3 in
                  let x = _1_inlined1 in
                  
# 205 "<standard.mly>"
    ( x )
# 88663 "asllib/Parser0.ml"
                  
                in
                let e = 
# 205 "<standard.mly>"
    ( x )
# 88669 "asllib/Parser0.ml"
                 in
                
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 88674 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88682 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88691 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = x;
              MenhirLib.EngineTypes.startp = _startpos_x_;
              MenhirLib.EngineTypes.endp = _endpos_x_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88748 "asllib/Parser0.ml"
               in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 88755 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 88762 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88770 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88779 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x_inlined1;
          MenhirLib.EngineTypes.startp = _startpos_x_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos_x_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = x;
                MenhirLib.EngineTypes.startp = _startpos_x_;
                MenhirLib.EngineTypes.endp = _endpos_x_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x_inlined1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 88831 "asllib/Parser0.ml"
        ) = Obj.magic x_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_inlined1_ in
        let _v =
          let desc =
            let _1 =
              let _3 =
                let x = x_inlined1 in
                
# 126 "<standard.mly>"
    ( Some x )
# 88849 "asllib/Parser0.ml"
                
              in
              let _1 =
                let _1 =
                  let _2 = 
# 205 "<standard.mly>"
    ( x )
# 88857 "asllib/Parser0.ml"
                   in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 88864 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88872 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88881 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 88943 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 88956 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 88970 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 88978 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 88986 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 88995 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 89059 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 89068 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 89081 "asllib/Parser0.ml"
               in
              let _1 =
                let _3 = _3_inlined2 in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89095 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89103 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89111 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89120 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = q;
                      MenhirLib.EngineTypes.startp = _startpos_q_;
                      MenhirLib.EngineTypes.endp = _endpos_q_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 89194 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 89200 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 89213 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 89227 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89235 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89243 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89251 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89260 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = q;
                        MenhirLib.EngineTypes.startp = _startpos_q_;
                        MenhirLib.EngineTypes.endp = _endpos_q_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 89336 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 89345 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 89351 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 89364 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined2, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let _1 = _1_inlined1 in
                      let _1 =
                        let i = _1 in
                        
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 89378 "asllib/Parser0.ml"
                        
                      in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89386 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89394 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89402 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89411 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _2;
          MenhirLib.EngineTypes.startp = _startpos__2_;
          MenhirLib.EngineTypes.endp = _endpos__2_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _4;
            MenhirLib.EngineTypes.startp = _startpos__4_;
            MenhirLib.EngineTypes.endp = _endpos__4_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined3;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _2_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined2;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined1;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _menhir_s;
                          MenhirLib.EngineTypes.semv = _1;
                          MenhirLib.EngineTypes.startp = _startpos__1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_;
                          MenhirLib.EngineTypes.next = _menhir_stack;
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__2_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 123 "<standard.mly>"
    ( None )
# 89496 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89510 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89518 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89526 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__2_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89535 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = x;
          MenhirLib.EngineTypes.startp = _startpos_x_;
          MenhirLib.EngineTypes.endp = _endpos_x_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _4;
              MenhirLib.EngineTypes.startp = _startpos__4_;
              MenhirLib.EngineTypes.endp = _endpos__4_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined3;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined3_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _3_inlined2;
                  MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
                  MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _3_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _2_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__2_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__2_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _;
                        MenhirLib.EngineTypes.semv = _1_inlined2;
                        MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                        MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                        MenhirLib.EngineTypes.next = {
                          MenhirLib.EngineTypes.state = _;
                          MenhirLib.EngineTypes.semv = _1_inlined1;
                          MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                          MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                          MenhirLib.EngineTypes.next = {
                            MenhirLib.EngineTypes.state = _menhir_s;
                            MenhirLib.EngineTypes.semv = _1;
                            MenhirLib.EngineTypes.startp = _startpos__1_;
                            MenhirLib.EngineTypes.endp = _endpos__1_;
                            MenhirLib.EngineTypes.next = _menhir_stack;
                          };
                        };
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let x : (
# 74 "asllib/Parser0.mly"
       (string)
# 89611 "asllib/Parser0.ml"
        ) = Obj.magic x in
        let _2 : unit = Obj.magic _2 in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3_inlined3 : unit = Obj.magic _3_inlined3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2_inlined1 : unit = Obj.magic _2_inlined1 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos_x_ in
        let _v =
          let desc =
            let _1 =
              let _3 = 
# 126 "<standard.mly>"
    ( Some x )
# 89631 "asllib/Parser0.ml"
               in
              let _1 =
                let (_3, _2) = (_3_inlined3, _2_inlined1) in
                let _1 =
                  let _2 =
                    let _1_inlined1 = _1_inlined2 in
                    let x =
                      let (_3, _1) = (_3_inlined1, _1_inlined1) in
                      ()
                    in
                    
# 205 "<standard.mly>"
    ( x )
# 89645 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 89653 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 342 "asllib/Parser0.mly"
                                ( AST.(E_Literal (L_Bool true)) )
# 89661 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos_x_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89670 "asllib/Parser0.ml"
           : (AST.expr))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 310 "asllib/Parser0.mly"
                          ( AST.(T_Int UnConstrained) )
# 89697 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89705 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 311 "asllib/Parser0.mly"
                          ( AST.T_Real                )
# 89732 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89740 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 312 "asllib/Parser0.mly"
                          ( AST.T_Bool                )
# 89767 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89775 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 89797 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident = _1 in
            
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 89808 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89817 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _2;
            MenhirLib.EngineTypes.startp = _startpos__2_;
            MenhirLib.EngineTypes.endp = _endpos__2_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _menhir_s;
              MenhirLib.EngineTypes.semv = q;
              MenhirLib.EngineTypes.startp = _startpos_q_;
              MenhirLib.EngineTypes.endp = _endpos_q_;
              MenhirLib.EngineTypes.next = _menhir_stack;
            };
          };
        } = _menhir_stack in
        let _1 : (
# 74 "asllib/Parser0.mly"
       (string)
# 89851 "asllib/Parser0.ml"
        ) = Obj.magic _1 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 89857 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos_q_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc =
            let tident =
              let i = _1 in
              
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 89869 "asllib/Parser0.ml"
              
            in
            
# 313 "asllib/Parser0.mly"
                            AST.T_Named                
# 89875 "asllib/Parser0.ml"
             tident
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos_q_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89884 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = _1;
          MenhirLib.EngineTypes.startp = _startpos__1_;
          MenhirLib.EngineTypes.endp = _endpos__1_;
          MenhirLib.EngineTypes.next = _menhir_stack;
        } = _menhir_stack in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__1_ in
        let _v =
          let desc = 
# 314 "asllib/Parser0.mly"
                          ( t_bit                     )
# 89911 "asllib/Parser0.ml"
           in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89919 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let e = 
# 205 "<standard.mly>"
    ( x )
# 89968 "asllib/Parser0.ml"
             in
            
# 315 "asllib/Parser0.mly"
                          ( AST.(T_Bits (e, []))      )
# 89973 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 89982 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3_inlined1;
          MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
          MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined3;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined3_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3;
                MenhirLib.EngineTypes.startp = _startpos__3_;
                MenhirLib.EngineTypes.endp = _endpos__3_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = x;
                  MenhirLib.EngineTypes.startp = _startpos_x_;
                  MenhirLib.EngineTypes.endp = _endpos_x_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined1;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _menhir_s;
                      MenhirLib.EngineTypes.semv = _1;
                      MenhirLib.EngineTypes.startp = _startpos__1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_;
                      MenhirLib.EngineTypes.next = _menhir_stack;
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined3 : (AST.bitfield list) = Obj.magic _1_inlined3 in
        let _1_inlined2 : unit = Obj.magic _1_inlined2 in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_inlined1_ in
        let _v =
          let desc =
            let b =
              let _1_inlined1 = _1_inlined3 in
              let x = _1_inlined1 in
              
# 205 "<standard.mly>"
    ( x )
# 90055 "asllib/Parser0.ml"
              
            in
            let e = 
# 205 "<standard.mly>"
    ( x )
# 90061 "asllib/Parser0.ml"
             in
            
# 316 "asllib/Parser0.mly"
                                      ( AST.(T_Bits (e, b)) )
# 90066 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_inlined1_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90075 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = x;
            MenhirLib.EngineTypes.startp = _startpos_x_;
            MenhirLib.EngineTypes.endp = _endpos_x_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _1_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _menhir_s;
                MenhirLib.EngineTypes.semv = _1;
                MenhirLib.EngineTypes.startp = _startpos__1_;
                MenhirLib.EngineTypes.endp = _endpos__1_;
                MenhirLib.EngineTypes.next = _menhir_stack;
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let x : (AST.expr) = Obj.magic x in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let _2 = 
# 205 "<standard.mly>"
    ( x )
# 90125 "asllib/Parser0.ml"
               in
              ()
            in
            
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90132 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90141 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _1_inlined1;
                  MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _menhir_s;
                    MenhirLib.EngineTypes.semv = _1;
                    MenhirLib.EngineTypes.startp = _startpos__1_;
                    MenhirLib.EngineTypes.endp = _endpos__1_;
                    MenhirLib.EngineTypes.next = _menhir_stack;
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 90196 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 90215 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90223 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90232 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined1;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _1_inlined2;
                MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = q;
                    MenhirLib.EngineTypes.startp = _startpos_q_;
                    MenhirLib.EngineTypes.endp = _endpos_q_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined1 : unit = Obj.magic _3_inlined1 in
        let _1_inlined2 : (
# 74 "asllib/Parser0.mly"
       (string)
# 90299 "asllib/Parser0.ml"
        ) = Obj.magic _1_inlined2 in
        let _2 : unit = Obj.magic _2 in
        let q : (
# 80 "asllib/Parser0.mly"
       (string)
# 90305 "asllib/Parser0.ml"
        ) = Obj.magic q in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let _1 = _1_inlined1 in
                  let _1 =
                    let i = _1 in
                    
# 330 "asllib/Parser0.mly"
                                   ( q ^ "_" ^ i )
# 90324 "asllib/Parser0.ml"
                    
                  in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 90332 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90340 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90349 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _4;
          MenhirLib.EngineTypes.startp = _startpos__4_;
          MenhirLib.EngineTypes.endp = _endpos__4_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _3;
            MenhirLib.EngineTypes.startp = _startpos__3_;
            MenhirLib.EngineTypes.endp = _endpos__3_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _3_inlined2;
              MenhirLib.EngineTypes.startp = _startpos__3_inlined2_;
              MenhirLib.EngineTypes.endp = _endpos__3_inlined2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = _3_inlined1;
                MenhirLib.EngineTypes.startp = _startpos__3_inlined1_;
                MenhirLib.EngineTypes.endp = _endpos__3_inlined1_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _;
                  MenhirLib.EngineTypes.semv = _2;
                  MenhirLib.EngineTypes.startp = _startpos__2_;
                  MenhirLib.EngineTypes.endp = _endpos__2_;
                  MenhirLib.EngineTypes.next = {
                    MenhirLib.EngineTypes.state = _;
                    MenhirLib.EngineTypes.semv = _1_inlined2;
                    MenhirLib.EngineTypes.startp = _startpos__1_inlined2_;
                    MenhirLib.EngineTypes.endp = _endpos__1_inlined2_;
                    MenhirLib.EngineTypes.next = {
                      MenhirLib.EngineTypes.state = _;
                      MenhirLib.EngineTypes.semv = _1_inlined1;
                      MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
                      MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
                      MenhirLib.EngineTypes.next = {
                        MenhirLib.EngineTypes.state = _menhir_s;
                        MenhirLib.EngineTypes.semv = _1;
                        MenhirLib.EngineTypes.startp = _startpos__1_;
                        MenhirLib.EngineTypes.endp = _endpos__1_;
                        MenhirLib.EngineTypes.next = _menhir_stack;
                      };
                    };
                  };
                };
              };
            };
          };
        } = _menhir_stack in
        let _4 : (AST.ty) = Obj.magic _4 in
        let _3 : unit = Obj.magic _3 in
        let _3_inlined2 : unit = Obj.magic _3_inlined2 in
        let _3_inlined1 : (AST.expr) = Obj.magic _3_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let _1_inlined2 : (AST.expr) = Obj.magic _1_inlined2 in
        let _1_inlined1 : unit = Obj.magic _1_inlined1 in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__4_ in
        let _v =
          let desc =
            let _1 =
              let _2 =
                let _1_inlined1 = _1_inlined2 in
                let x =
                  let (_3, _1) = (_3_inlined1, _1_inlined1) in
                  ()
                in
                
# 205 "<standard.mly>"
    ( x )
# 90433 "asllib/Parser0.ml"
                
              in
              ()
            in
            
# 256 "asllib/Parser0.mly"
                              ( AST.(T_Bits (ASTUtils.expr_of_int 0, [])) )
# 90441 "asllib/Parser0.ml"
            
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__4_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90450 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
      (fun _menhir_env ->
        let _menhir_stack = _menhir_env.MenhirLib.EngineTypes.stack in
        let {
          MenhirLib.EngineTypes.state = _;
          MenhirLib.EngineTypes.semv = _3;
          MenhirLib.EngineTypes.startp = _startpos__3_;
          MenhirLib.EngineTypes.endp = _endpos__3_;
          MenhirLib.EngineTypes.next = {
            MenhirLib.EngineTypes.state = _;
            MenhirLib.EngineTypes.semv = _1_inlined1;
            MenhirLib.EngineTypes.startp = _startpos__1_inlined1_;
            MenhirLib.EngineTypes.endp = _endpos__1_inlined1_;
            MenhirLib.EngineTypes.next = {
              MenhirLib.EngineTypes.state = _;
              MenhirLib.EngineTypes.semv = _2;
              MenhirLib.EngineTypes.startp = _startpos__2_;
              MenhirLib.EngineTypes.endp = _endpos__2_;
              MenhirLib.EngineTypes.next = {
                MenhirLib.EngineTypes.state = _;
                MenhirLib.EngineTypes.semv = h;
                MenhirLib.EngineTypes.startp = _startpos_h_;
                MenhirLib.EngineTypes.endp = _endpos_h_;
                MenhirLib.EngineTypes.next = {
                  MenhirLib.EngineTypes.state = _menhir_s;
                  MenhirLib.EngineTypes.semv = _1;
                  MenhirLib.EngineTypes.startp = _startpos__1_;
                  MenhirLib.EngineTypes.endp = _endpos__1_;
                  MenhirLib.EngineTypes.next = _menhir_stack;
                };
              };
            };
          };
        } = _menhir_stack in
        let _3 : unit = Obj.magic _3 in
        let _1_inlined1 : (AST.ty list) = Obj.magic _1_inlined1 in
        let _2 : unit = Obj.magic _2 in
        let h : (AST.ty) = Obj.magic h in
        let _1 : unit = Obj.magic _1 in
        let _endpos__0_ = _menhir_stack.MenhirLib.EngineTypes.endp in
        let _startpos = _startpos__1_ in
        let _endpos = _endpos__3_ in
        let _v =
          let desc =
            let _1 =
              let x =
                let _1 = _1_inlined1 in
                let t = _1 in
                
# 292 "asllib/Parser0.mly"
                                           ( h::t )
# 90510 "asllib/Parser0.ml"
                
              in
              
# 205 "<standard.mly>"
    ( x )
# 90516 "asllib/Parser0.ml"
              
            in
            let _1_1 = _1 in
            
# 303 "asllib/Parser0.mly"
                              AST.T_Tuple  
# 90523 "asllib/Parser0.ml"
             _1_1
          in
          let (_endpos_desc_, _startpos_desc_) = (_endpos__3_, _startpos__1_) in
          let _endpos = _endpos_desc_ in
          let _symbolstartpos = _startpos_desc_ in
          (
# 253 "asllib/Parser0.mly"
                              ( AST.{ desc; pos_start=_symbolstartpos; pos_end=_endpos; version })
# 90532 "asllib/Parser0.ml"
           : (AST.ty))
        in
        {
          MenhirLib.EngineTypes.state = _menhir_s;
          MenhirLib.EngineTypes.semv = Obj.repr _v;
          MenhirLib.EngineTypes.startp = _startpos;
          MenhirLib.EngineTypes.endp = _endpos;
          MenhirLib.EngineTypes.next = _menhir_stack;
        });
    |]
  
  and trace =
    None
  
end

module MenhirInterpreter = struct
  
  module ET = MenhirLib.TableInterpreter.MakeEngineTable (Tables)
  
  module TI = MenhirLib.Engine.Make (ET)
  
  include TI
  
end

let opn =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 1991 lexer lexbuf)

and ast =
  fun lexer lexbuf : (AST.t) ->
    Obj.magic (MenhirInterpreter.entry `Legacy 0 lexer lexbuf)

module Incremental = struct
  
  let opn =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 1991 initial_position)
  
  and ast =
    fun initial_position : (AST.t) MenhirInterpreter.checkpoint ->
      Obj.magic (MenhirInterpreter.start 0 initial_position)
  
end
